if ( !( "sprinkles_util" in getroottable() ) ) {
	::sprinkles_util <- {};

	printl("Executing sprinkles_util for the first time");
}
else
{
	printl("sprinkles_util already loaded! no need to do it again")
	//return
}

IncludeScript("sprinklesscripts/lib/Netprop_fix.nut")
IncludeScript("sprinklesscripts/lib/CBaseEntity.nut")
IncludeScript("sprinklesscripts/lib/trace_filter.nut")

::SetDestroyCallback <- function(entity, callback)
{
	entity.ValidateScriptScope()
	local scope = entity.GetScriptScope()
	scope.setdelegate({}.setdelegate({
			parent   = scope.getdelegate()
			id       = entity.GetScriptId()
			index    = entity.entindex()
			callback = callback
			_get = function(k)
			{
				return parent[k]
			}
			_delslot = function(k)
			{
				if (k == id)
				{
					entity = EntIndexToHScript(index)
					local scope = entity.GetScriptScope()
					scope.self <- entity
					callback.pcall(scope)
				}
				delete parent[k]
			}
		})
	)
}

//// Util File Full of very useful things!
::CONST <- getconsttable();

::NULL <- null

::MAX_WEAPONS <- 8;
::MAX_AMMO_SLOTS <- 7
::MaxPlayers <- MaxClients().tointeger();

::tf_player_manager <- Entities.FindByClassname(null, "tf_player_manager");

::tf_gamerules <- Entities.FindByClassname(null, "tf_gamerules");

::UpgradeProxyManager <- Entities.FindByName(null, "upgrade_proxycontroler");

const FLT_EPSILON		= 1.192092896e-7;;
const FLT_MAX			= 3.402823466e+38;;
const FLT_MIN			= 1.175494351e-38;;
const STOP_EPSILON 		= 0.1;
const INT_MAX			= 0x7FFFFFFF;;
const INT_MIN			= -2147483648;;

const DEG2RAD			= 0.017453293;;			// PI / 180 = 0.01745329251994329576
const RAD2DEG			= 57.295779513;; 		// 180 / PI = 57.29577951308232087679
const PI				= 3.141592654;;			// 3.14159265358979323846
const MAX_COORD_FLOAT	= 16384.0;;
const MAX_TRACE_LENGTH	= 56755.840862417;;	 	// sqrt(3) * 2 * MAX_COORD_FLOAT = 56755.84086241697115430736

const GRENADE_DEFAULT_SIZE = 2.0
::GRENADE_SIZE_VECT_MIN <- Vector( -GRENADE_DEFAULT_SIZE, -GRENADE_DEFAULT_SIZE, -GRENADE_DEFAULT_SIZE );
::GRENADE_SIZE_VECT_MAX <- Vector( GRENADE_DEFAULT_SIZE, GRENADE_DEFAULT_SIZE, GRENADE_DEFAULT_SIZE );

CONST.RAND_MAX <- ::RAND_MAX;
::DEG2RAD <- DEG2RAD;
::RAD2DEG <- RAD2DEG;
::MAX_COORD_FLOAT <- MAX_COORD_FLOAT;
::MAX_TRACE_LENGTH <- MAX_TRACE_LENGTH;

const DEG2RADDIV2		= 0.008726646;;
const RAD2DEG2			= 114.591559026;;
const PI2				= 6.283185307;;			// 6.28318530717958647692
const PIDIV2			= 1.570796327;;			// 1.57079632679489661923
const FLT_MAX_N			= -3.402823466e+38;;
const N_ONE				= -1;;

::vec3_origin <- Vector()
::vec3_angle <- QAngle()

const DEPLOYTIME_SMALL 				= 2.25;
const DEPLOYTIME_BIG 				= 2.6;
const DEPLOYTIME_GENERIC 			= 2.0;

const	SHAKE_START = 0		// Starts the screen shake for all players within the radius.
const	SHAKE_STOP = 1	 			// Stops the screen shake for all players within the radius.
const	SHAKE_AMPLITUDE = 2		// Modifies the amplitude of an active screen shake for all players within the radius.
const	SHAKE_FREQUENCY = 3		// Modifies the frequency of an active screen shake for all players within the radius.
const	SHAKE_START_RUMBLEONLY = 4	// Starts a shake effect that only rumbles the controller, no screen effect.
const	SHAKE_START_NORUMBLE = 5	// Starts a shake that does NOT rumble the controller.

const TF_PLAYERCLASS_GENERIC 		= 0;
const TF_PLAYERCLASS_SCOUT 			= 1;
const TF_PLAYERCLASS_SNIPER 		= 2;
const TF_PLAYERCLASS_SOLDIER 		= 3;
const TF_PLAYERCLASS_DEMOMAN 		= 4;
const TF_PLAYERCLASS_MEDIC 			= 5;
const TF_PLAYERCLASS_HEAVY 			= 6;
const TF_PLAYERCLASS_PYRO 			= 7;
const TF_PLAYERCLASS_SPY 			= 8;
const TF_PLAYERCLASS_ENGINEER 		= 9;
const TF_PLAYERCLASS_CIVILIAN		= 10;

const TF_TEAM_UNASSIGNED 			= 0;
const TF_TEAM_SPECTATOR 			= 1;
const TF_TEAM_PVE_DEFENDERS 		= 2;
const TF_TEAM_RED					= 2;
const TF_TEAM_BLUE 					= 3;
const TF_TEAM_PVE_INVADERS 			= 3;
const TF_TEAM_COUNT 				= 4;
const TF_TEAM_PVE_INVADERS_GIANTS 	= 4;
const TF_TEAM_BOSS 					= 5;

const TF_AMMO_DUMMY 				= 0;
const TF_AMMO_PRIMARY 				= 1;
const TF_AMMO_SECONDARY				= 2;
const TF_AMMO_METAL 				= 3;
const TF_AMMO_GRENADES1 			= 4;
const TF_AMMO_GRENADES2 			= 5;
const TF_AMMO_GRENADES3 			= 6;
const TF_AMMO_COUNT 				= 7;

const TF_COND_AIMING 					= 0;
const TF_COND_ZOOMED 					= 1;
const TF_COND_DISGUISING 				= 2;
const TF_COND_DISGUISED 				= 3;
const TF_COND_STEALTHED 				= 4;
const TF_COND_INVULNERABLE 				= 5;
const TF_COND_TELEPORTED 				= 6;
const TF_COND_TAUNTING 					= 7;
const TF_COND_INVULNERABLE_WEARINGOFF	= 8;
const TF_COND_STEALTHED_BLINK 			= 9;
const TF_COND_SELECTED_TO_TELEPORT 		= 10;
const TF_COND_CRITBOOSTED 				= 11;
const TF_COND_TMPDAMAGEBONUS 			= 12;
const TF_COND_FEIGN_DEATH 				= 13;
const TF_COND_PHASE 					= 14;
const TF_COND_STUNNED 					= 15;
const TF_COND_OFFENSEBUFF 				= 16;
const TF_COND_SHIELD_CHARGE 			= 17;
const TF_COND_DEMO_BUFF 				= 18;
const TF_COND_ENERGY_BUFF 				= 19;
const TF_COND_RADIUSHEAL 				= 20;
const TF_COND_HEALTH_BUFF 				= 21;
const TF_COND_BURNING 					= 22;
const TF_COND_HEALTH_OVERHEALED 		= 23;
const TF_COND_URINE 					= 24;
const TF_COND_BLEEDING 					= 25;
const TF_COND_DEFENSEBUFF 				= 26;
const TF_COND_MAD_MILK 					= 27;
const TF_COND_MEGAHEAL 					= 28;
const TF_COND_REGENONDAMAGEBUFF 		= 29;
const TF_COND_MARKEDFORDEATH 			= 30;
const TF_COND_NOHEALINGDAMAGEBUFF 		= 31;
const TF_COND_SPEED_BOOST 				= 32;
const TF_COND_CRITBOOSTED_PUMPKIN 		= 33;
const TF_COND_CRITBOOSTED_USER_BUFF 	= 34;
const TF_COND_CRITBOOSTED_DEMO_CHARGE 	= 35;
const TF_COND_SODAPOPPER_HYPE 			= 36;
const TF_COND_CRITBOOSTED_FIRST_BLOOD 	= 37;
const TF_COND_CRITBOOSTED_BONUS_TIME 	= 38;
const TF_COND_CRITBOOSTED_CTF_CAPTURE 	= 39;
const TF_COND_CRITBOOSTED_ON_KILL 		= 40;
const TF_COND_CANNOT_SWITCH_FROM_MELEE 	= 41;
const TF_COND_DEFENSEBUFF_NO_CRIT_BLOCK = 42;
const TF_COND_REPROGRAMMED		 		= 43;
const TF_COND_CRITBOOSTED_RAGE_BUFF 	= 44;
const TF_COND_DEFENSEBUFF_HIGH 			= 45;
const TF_COND_SNIPERCHARGE_RAGE_BUFF 	= 46;
const TF_COND_DISGUISE_WEARINGOFF 		= 47;
const TF_COND_MARKEDFORDEATH_SILENT 	= 48;
const TF_COND_DISGUISED_AS_DISPENSER 	= 49;
const TF_COND_SAPPED 					= 50;
const TF_COND_INVULNERABLE_HIDE_UNLESS_DAMAGED 	= 51;
const TF_COND_INVULNERABLE_USER_BUFF 	= 52;
const TF_COND_HALLOWEEN_BOMB_HEAD		= 53;
const TF_COND_HALLOWEEN_THRILLER 		= 54;
const TF_COND_RADIUSHEAL_ON_DAMAGE 		= 55;
const TF_COND_CRITBOOSTED_CARD_EFFECT 	= 56;
const TF_COND_INVULNERABLE_CARD_EFFECT 	= 57;
const TF_COND_MEDIGUN_UBER_BULLET_RESIST= 58;
const TF_COND_MEDIGUN_UBER_BLAST_RESIST = 59;
const TF_COND_MEDIGUN_UBER_FIRE_RESIST 	= 60;
const TF_COND_MEDIGUN_SMALL_BULLET_RESIST= 61;
const TF_COND_MEDIGUN_SMALL_BLAST_RESIST= 62;
const TF_COND_MEDIGUN_SMALL_FIRE_RESIST	= 63;
const TF_COND_STEALTHED_USER_BUFF 		= 64;
const TF_COND_MEDIGUN_DEBUFF 			= 65;
const TF_COND_STEALTHED_USER_BUFF_FADING= 66;
const TF_COND_BULLET_IMMUNE 			= 67;
const TF_COND_BLAST_IMMUNE				= 68;
const TF_COND_FIRE_IMMUNE				= 69;
const TF_COND_PREVENT_DEATH 			= 70;
const TF_COND_MVM_BOT_STUN_RADIOWAVE 	= 71;
const TF_COND_KING_BUFFED 				= 113;

const TF_DMG_CUSTOM_NONE = 0
const TF_DMG_CUSTOM_HEADSHOT = 1
const TF_DMG_CUSTOM_BACKSTAB = 2
const TF_DMG_CUSTOM_BURNING = 3
const TF_DMG_WRENCH_FIX = 4
const TF_DMG_CUSTOM_MINIGUN = 5
const TF_DMG_CUSTOM_SUICIDE = 6
const TF_DMG_CUSTOM_TAUNTATK_HADOUKEN = 7
const TF_DMG_CUSTOM_BURNING_FLARE = 8
const TF_DMG_CUSTOM_TAUNTATK_HIGH_NOON = 9
const TF_DMG_CUSTOM_TAUNTATK_GRAND_SLAM = 10
const TF_DMG_CUSTOM_PENETRATE_MY_TEAM = 11
const TF_DMG_CUSTOM_PENETRATE_ALL_PLAYERS = 12
const TF_DMG_CUSTOM_TAUNTATK_FENCING = 13
const TF_DMG_CUSTOM_PENETRATE_NONBURNING_TEAMMATE = 14
const TF_DMG_CUSTOM_TAUNTATK_ARROW_STAB = 15
const TF_DMG_CUSTOM_TELEFRAG = 16
const TF_DMG_CUSTOM_BURNING_ARROW = 17
const TF_DMG_CUSTOM_FLYINGBURN = 18
const TF_DMG_CUSTOM_PUMPKIN_BOMB = 19
const TF_DMG_CUSTOM_DECAPITATION = 20
const TF_DMG_CUSTOM_TAUNTATK_GRENADE = 21
const TF_DMG_CUSTOM_BASEBALL = 22
const TF_DMG_CUSTOM_CHARGE_IMPACT = 23
const TF_DMG_CUSTOM_TAUNTATK_BARBARIAN_SWING = 24
const TF_DMG_CUSTOM_AIR_STICKY_BURST = 25
const TF_DMG_CUSTOM_DEFENSIVE_STICKY = 26
const TF_DMG_CUSTOM_PICKAXE = 27
const TF_DMG_CUSTOM_ROCKET_DIRECTHIT = 28
const TF_DMG_CUSTOM_TAUNTATK_UBERSLICE = 29
const TF_DMG_CUSTOM_PLAYER_SENTRY = 30

const RUNE_HASTE = 91
const RUNE_AGILITY = 97
const RUNE_KING = 109

const DMG_GENERIC 					= 0
const DMG_CRUSH 					= 1
const DMG_BULLET 					= 2
const DMG_SLASH 					= 4
const DMG_BURN 						= 8
const DMG_TRAIN 					= 16
const DMG_FALL	 					= 32
const DMG_BLAST 					= 64
const DMG_CLUB	 					= 128
const DMG_SHOCK 					= 256
const DMG_SONIC 					= 512
const DMG_ENERGYBEAM 				= 1024
const DMG_RADIUS_MAX 				= 1024
const DMG_PREVENT_PHYSICS_FORCE  	= 2048
const DMG_NEVERGIB  				= 4096
const DMG_ALWAYSGIB  				= 8192
const DMG_DROWN 					= 16384
const DMG_PARALYZE 					= 32768
const DMG_SAWBLADE 					= 65536
const DMG_POISON 					= 131072
const DMG_NOCLOSEDISTANCEMOD 		= 131072
const DMG_RADIATION 				= 262144
const DMG_HALF_FALLOFF 				= 262144
const DMG_DROWNRECOVER 				= 524288
const DMG_ACID 						= 1048576
const DMG_CRITICAL 					= 1048576
const DMG_SLOWBURN					= 2097152
const DMG_BULLETFALLOFF				= 2097152
const DMG_USEDISTANCEMOD			= 2097152
const DMG_REMOVENORAGDOLL  			= 4194304
const DMG_PHYSGUN  					= 8388608
const DMG_PLASMA  					= 16777216
const DMG_IGNITE  					= 16777216
const DMG_FROM_OTHER_SAPPER  		= 16777216
const DMG_AIRBOAT  					= 33554432
const DMG_USE_HITLOCATIONS 			= 33554432
const DMG_DISSOLVE  				= 67108864
const DMG_DONT_COUNT_DAMAGE_TOWARDS_CRIT_RATE  				= 67108864
const DMG_BLAST_SURFACE  			= 134217728
const DMG_MELEE  					= 134217728
const DMG_DIRECT  					= 268435456
const DMG_BUCKSHOT   				= 536870912
const DMG_LASTGENERICFLAG    		= 2147483648

const WL_NotInWater = 0
const WL_Feet = 1
const WL_Waist = 2
const WL_Eyes = 3

::DMG_MELEE_COMB <- DMG_CLUB + DMG_NEVERGIB + DMG_BLAST_SURFACE

::VEC_VIEW <- Vector( 0, 0, 64 ),			//VEC_VIEW (m_vView)
::VEC_HULL_MIN <-	Vector(-16, -16, 0 ),		//VEC_HULL_MIN (m_vHullMin)
::VEC_HULL_MAX <-	Vector( 16,  16,  72 ),		//VEC_HULL_MAX (m_vHullMax)
::VEC_DUCK_HULL_MIN <-	Vector(-16, -16, 0 ),		//VEC_DUCK_HULL_MIN (m_vDuckHullMin)
::VEC_DUCK_HULL_MAX <-	Vector( 16,  16,  36 ),		//VEC_DUCK_HULL_MAX	(m_vDuckHullMax)
::VEC_DUCK_VIEW <-	Vector( 0, 0, 28 ),			//VEC_DUCK_VIEW		(m_vDuckView)
::VEC_OBS_HULL_MIN <-	Vector(-10, -10, -10 ),		//VEC_OBS_HULL_MIN	(m_vObsHullMin)
::VEC_OBS_HULL_MAX <-	Vector( 10,  10,  10 ),		//VEC_OBS_HULL_MAX	(m_vObsHullMax)
::VEC_DEAD_VIEWHEIGHT <-	Vector( 0, 0, 14 )			//VEC_DEAD_VIEWHEIGHT (m_vDeadViewHeight)

const HITGROUP_GENERIC = 0
const HITGROUP_HEAD = 1
const HITGROUP_CHEST = 2
const HITGROUP_STOMACH = 3
const HITGROUP_LEFTARM = 4
const HITGROUP_RIGHTARM = 5
const HITGROUP_LEFTLEG = 6
const HITGROUP_RIGHTLEG = 7
const HITGROUP_GEAR = 10

const SOLID_NONE = 0
const SOLID_BSP = 1
const SOLID_BBOX = 2
const SOLID_OBB = 3
const SOLID_OBB_YAW = 4
const SOLID_CUSTOM = 5
const SOLID_VPHYSICS = 6
const SOLID_LAST = 7

const OBS_MODE_NONE = 0
const OBS_MODE_DEATHCAM = 1
const OBS_MODE_FREEZECAM = 2
const OBS_MODE_FIXED = 3
const OBS_MODE_IN_EYE = 4
const OBS_MODE_CHASE = 5
const OBS_MODE_POI = 6
const OBS_MODE_ROAMING = 7
const NUM_OBSERVER_MODES = 8

const MOVETYPE_NONE = 0
const MOVETYPE_ISOMETRIC = 1
const MOVETYPE_WALK = 2
const MOVETYPE_STEP = 3
const MOVETYPE_FLY = 4
const MOVETYPE_FLYGRAVITY = 5
const MOVETYPE_VPHYSICS = 6
const MOVETYPE_PUSH = 7
const MOVETYPE_NOCLIP = 8
const MOVETYPE_LADDER = 9
const MOVETYPE_OBSERVER = 10
const MOVETYPE_CUSTOM = 11
const MOVETYPE_LAST = 11


const MASK_ALL = -1
const MASK_SPLITAREAPORTAL = 48
const MASK_SOLID_BRUSHONLY = 16395
const MASK_WATER = 16432
const MASK_BLOCKLOS = 16449
const MASK_OPAQUE = 16513
const MASK_DEADSOLID = 65547
const MASK_PLAYERSOLID_BRUSHONLY = 81931
const MASK_NPCWORLDSTATIC = 131083
const MASK_NPCSOLID_BRUSHONLY = 147467
const MASK_CURRENT = 16515072
const MASK_SHOT_PORTAL = 33570819
const MASK_SOLID = 33570827
const MASK_BLOCKLOS_AND_NPCS = 33570881
const MASK_OPAQUE_AND_NPCS = 33570945
const MASK_VISIBLE_AND_NPCS = 33579137
const MASK_PLAYERSOLID = 33636363
const MASK_NPCSOLID = 33701899
const MASK_SHOT_HULL = 100679691
const MASK_SHOT = 1174421507

const CONTENTS_EMPTY = 0
const CONTENTS_SOLID = 1
const CONTENTS_WINDOW = 2
const CONTENTS_AUX = 4
const CONTENTS_GRATE = 8
const CONTENTS_SLIME = 16
const CONTENTS_WATER = 32
const CONTENTS_BLOCKLOS = 64
const CONTENTS_OPAQUE = 128
const LAST_VISIBLE_CONTENTS = 128
const ALL_VISIBLE_CONTENTS = 255
const CONTENTS_TESTFOGVOLUME = 256
const CONTENTS_UNUSED = 512
const CONTENTS_UNUSED6 = 1024
const CONTENTS_TEAM1 = 2048
const CONTENTS_TEAM2 = 4096
const CONTENTS_IGNORE_NODRAW_OPAQUE = 8192
const CONTENTS_MOVEABLE = 16384
const CONTENTS_AREAPORTAL = 32768
const CONTENTS_PLAYERCLIP = 65536
const CONTENTS_MONSTERCLIP = 131072
const CONTENTS_CURRENT_0 = 262144
const CONTENTS_CURRENT_90 = 524288
const CONTENTS_CURRENT_180 = 1048576
const CONTENTS_CURRENT_270 = 2097152
const CONTENTS_CURRENT_UP = 4194304
const CONTENTS_CURRENT_DOWN = 8388608
const CONTENTS_ORIGIN = 16777216
const CONTENTS_MONSTER = 33554432
const CONTENTS_DEBRIS = 67108864
const CONTENTS_DETAIL = 134217728
const CONTENTS_TRANSLUCENT = 268435456
const CONTENTS_LADDER = 536870912
const CONTENTS_HITBOX = 1073741824

const EFL_KILLME = 1
const EFL_DORMANT = 2
const EFL_NOCLIP_ACTIVE = 4
const EFL_SETTING_UP_BONES = 8
const EFL_HAS_PLAYER_CHILD = 16
const EFL_KEEP_ON_RECREATE_ENTITIES = 16
const EFL_DIRTY_SHADOWUPDATE = 32
const EFL_NOTIFY = 64
const EFL_FORCE_CHECK_TRANSMIT = 128
const EFL_BOT_FROZEN = 256
const EFL_SERVER_ONLY = 512
const EFL_NO_AUTO_EDICT_ATTACH = 1024
const EFL_DIRTY_ABSTRANSFORM = 2048
const EFL_DIRTY_ABSVELOCITY = 4096
const EFL_DIRTY_ABSANGVELOCITY = 8192
const EFL_DIRTY_SURROUNDING_COLLISION_BOUNDS = 16384
const EFL_DIRTY_SPATIAL_PARTITION = 32768
const EFL_FORCE_ALLOW_MOVEPARENT = 65536
const EFL_IN_SKYBOX = 131072
const EFL_USE_PARTITION_WHEN_NOT_SOLID = 262144
const EFL_TOUCHING_FLUID = 524288
const EFL_IS_BEING_LIFTED_BY_BARNACLE = 1048576
const EFL_NO_ROTORWASH_PUSH = 2097152
const EFL_NO_THINK_FUNCTION = 4194304
const EFL_NO_GAME_PHYSICS_SIMULATION = 8388608
const EFL_CHECK_UNTOUCH = 16777216
const EFL_DONTBLOCKLOS = 33554432
const EFL_DONTWALKON = 67108864
const EFL_NO_DISSOLVE = 134217728
const EFL_NO_MEGAPHYSCANNON_RAGDOLL = 268435456
const EFL_NO_WATER_VELOCITY_CHANGE = 536870912
const EFL_NO_PHYSCANNON_INTERACTION = 1073741824
const EFL_NO_DAMAGE_FORCES = 2147483648

const FL_ONGROUND = 1
const FL_DUCKING = 2
const FL_ANIMDUCKING = 4
const FL_WATERJUMP = 8
const PLAYER_FLAG_BITS = 11
const FL_ONTRAIN = 16
const FL_INRAIN = 32
const FL_FROZEN = 64
const FL_ATCONTROLS = 128
const FL_CLIENT = 256
const FL_FAKECLIENT = 512
const FL_INWATER = 1024
const FL_FLY = 2048
const FL_SWIM = 4096
const FL_CONVEYOR = 8192
const FL_NPC = 16384
const FL_GODMODE = 32768
const FL_NOTARGET = 65536
const FL_AIMTARGET = 131072
const FL_PARTIALGROUND = 262144
const FL_STATICPROP = 524288
const FL_GRAPHED = 1048576
const FL_GRENADE = 2097152
const FL_STEPMOVEMENT = 4194304
const FL_DONTTOUCH = 8388608
const FL_BASEVELOCITY = 16777216
const FL_WORLDBRUSH = 33554432
const FL_OBJECT = 67108864
const FL_KILLME = 134217728
const FL_ONFIRE = 268435456
const FL_DISSOLVING = 536870912
const FL_TRANSRAGDOLL = 1073741824
const FL_UNBLOCKABLE_BY_PLAYER = 2147483648

::TF_HITGROUP_NAMES <- [
    "HITGROUP_GENERIC",
    "HITGROUP_HEAD",
    "HITGROUP_CHEST",
    "HITGROUP_STOMACH",
    "HITGROUP_LEFTARM",
    "HITGROUP_RIGHTARM",
    "HITGROUP_LEFTLEG",
    "HITGROUP_RIGHTLEG",
    "dummy",
    "dummy",
    "HITGROUP_GEAR"
];

::IN_ATTACK 	<- 1 << 0
::IN_JUMP 		<- 1 << 1
::IN_DUCK 		<- 1 << 2
::IN_FORWARD 	<- 1 << 3
::IN_BACK 		<- 1 << 4
::IN_USE 		<- 1 << 5
::IN_CANCEL	 	<- 1 << 6
::IN_LEFT 		<- 1 << 7
::IN_RIGHT	 	<- 1 << 8
::IN_MOVELEFT 	<- 1 << 9
::IN_MOVERIGHT 	<- 1 << 10
::IN_ATTACK2 	<- 1 << 11
::IN_RUN  		<- 1 << 12
::IN_RELOAD  	<- 1 << 13
::IN_ALT1  		<- 1 << 14
::IN_ALT2 		<- 1 << 15
::IN_SCORE 		<- 1 << 16
::IN_SPEED 		<- 1 << 17
::IN_WALK 		<- 1 << 18
::IN_ZOOM 		<- 1 << 19
::IN_WEAPON1 	<- 1 << 20
::IN_WEAPON2 	<- 1 << 21
::IN_BULLRUSH  	<- 1 << 22
::IN_GRENADE1   <- 1 << 23
::IN_GRENADE2  	<- 1 << 24
::IN_ATTACK3  	<- 1 << 25

::TF_CLASS_NAMES <- [
    "generic",
    "scout",
    "sniper",
    "soldier",
    "demo",
    "medic",
    "heavy",
    "pyro",
    "spy",
    "engineer",
    "civilian"
];

::ROBOTMODEL_INDEX <- [
    GetModelIndex("models/player/fracture/bot_scout.mdl"),
    GetModelIndex("models/player/fracture/bot_scout.mdl"),
    GetModelIndex("models/player/fracture/bot_sniper.mdl"),
    GetModelIndex("models/player/fracture/bot_soldier.mdl"),
    GetModelIndex("models/player/fracture/bot_demo.mdl"),
    GetModelIndex("models/player/fracture/bot_medic.mdl"),
    GetModelIndex("models/player/fracture/bot_heavy.mdl"),
    GetModelIndex("models/player/fracture/bot_pyro.mdl"),
    GetModelIndex("models/player/fracture/bot_spy.mdl"),
    GetModelIndex("models/player/fracture/bot_engineer.mdl"),
    GetModelIndex("models/player/fracture/bot_scout.mdl"),
];

::TF_TEAM_NAMES <- [
    "None",
    "Spectator",
    "RED",
    "BLU",
    "Team4",
    "Boss",
];

::TF_AMMO_INDEX <-
[
	0, //dummy
	1, //primary
	2, //secondary
	3, //metal
	4, //grenades1
	5, //grenades2
	6, //grenades3
	7, //count
];

::LagCompVecArray <-
[
	vec3_origin, // dummy value
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
	vec3_origin,
]

::FlashBangHaverArray <-
[
	false, // dummy value
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
]

//-----------------------------------------------------------------------------
// Purpose: Check the dev level
// Output : Returns true on success, false on failure.
//-----------------------------------------------------------------------------
::IsInDebugMode <- function()
{
	return GetDeveloperLevel() > 0
}

//-----------------------------------------------------------------------------
// Purpose: Check the dev level and print text based on it
// input  : pMsg.
// Output : Returns true on success, false on failure.
//-----------------------------------------------------------------------------
::DebugPrint <- function(pMsg)
{
	if(IsInDebugMode())
    {
        print(pMsg)
    }
}

//-----------------------------------------------------------------------------
// Purpose: Check the dev level and print text based on it
// input  : pMsg.
// Output : Returns true on success, false on failure.
//-----------------------------------------------------------------------------
::DebugPrintl <- function(pMsg)
{
	if(IsInDebugMode())
    {
        printl(pMsg)
    }
}

//-----------------------------------------------------------------------------
// Purpose: Check the dev level and print text based on it
// input  : pMsg.
// Output : Returns true on success, false on failure.
//-----------------------------------------------------------------------------
::DebugError <- function(pMsg)
{
	if(IsInDebugMode())
    {
        error(pMsg)
    }
}

//-----------------------------------------------------------------------------
// Purpose: Called Everytime a player swings a weapon this records all players possions
// during that swing whether or not it will improve things idk
//-----------------------------------------------------------------------------
::LagCompCall <- function()
{
	for (local entity; entity = Entities.FindByClassname(entity, "player");)
	{
		LagCompVecArray[entity.entindex()] = GetPropVector(entity, "m_vecOrigin")
		//printl("Player: " + entity.GetPlayerName() + " ,with the ID: " + entity.entindex() + " ,Has Pos: " + LagCompVecArray[entity.entindex()])
		//DebugDrawBox(LagCompVecArray[entity.entindex()], WorldAlignMins(entity), WorldAlignMaxs(entity), 255, 0, 0, 150, 1.0)
	}
}

::PrecacheParticle <- function(name)
{
    PrecacheEntityFromTable({ classname = "info_particle_system", effect_name = name })
}

::min <- function( a, b )
{
	if ( a < b )
		return a;
	return b;
}

::Min <- min
/*
::CTFPlayer.Speak <-  function(iConcept = "", modifiers = "", pszOutResponseChosen = NULL, bufsize = 0, filter = NULL);
{
	EntFireByHandle(this, "SpeakResponseConcept", iConcept + " " + modifiers, 0.0, this, this)
	return true;
}

::CTFBot.Speak <- CTFPlayer.Speak

::CTFPlayer.SpeakIfAllowed <- function( iConcept, modifiers = "", pszOutResponseChosen = NULL, bufsize = 0, filter = NULL );
{
	if ( !this.IsAlive() )
		return false;

	//if ( IsAllowedToSpeak( concept, bRespondingToPlayer ) )
	return Speak( iConcept, modifiers, pszOutResponseChosen, bufsize, filter );
}

::CTFBot.SpeakIfAllowed <- CTFPlayer.SpeakIfAllowed

::CTFPlayer.SpeakConceptIfAllowed <- function( iConcept, modifiers = "", pszOutResponseChosen = NULL, bufsize = 0, filter = NULL )
{
	// Save the current concept.
	//m_iCurrentConcept = iConcept;
	return SpeakIfAllowed( iConcept, modifiers, pszOutResponseChosen, bufsize, filter );
}

::CTFBot.SpeakConceptIfAllowed <- CTFPlayer.SpeakConceptIfAllowed
*/

::HaveAllPlayersSpeakConceptIfAllowed <-  function(iConcept, iTeam, modifiers = "", delay =  0.0)
{
	for (local i = 1; i <= MaxPlayers ; i++)
	{
		local player = PlayerInstanceFromIndex(i)

		if (player == null) continue;

		if ( iTeam != TF_TEAM_UNASSIGNED )
		{
			if ( player.GetTeam() != iTeam )
				continue;
		}

		EntFireByHandle(player, "SpeakResponseConcept", iConcept + " " + modifiers, delay, player, player)
	}
}
/*
::RandomPlayersSpeakConceptIfAllowed <- function( iConcept, iNumRandomPlayer, iTeam, modifiers)
{
		local speakCandidates;

		local pPlayer;
		for ( local i = 1; i <= MaxClients; i++ )
		{
			pPlayer = PlayerInstanceFromIndex(i)

			if ( !pPlayer )
				continue;

			if ( iTeam != TEAM_UNASSIGNED )
			{
				if ( pPlayer->GetTeamNumber() != iTeam )
					continue;
			}

			speakCandidates.AddToTail( pPlayer );
		}

		local iSpeaker = iNumRandomPlayer;
		while ( iSpeaker > 0 && speakCandidates.Count() > 0 )
		{
			int iRandomSpeaker = RandomInt( 0, speakCandidates.Count() - 1 );
			speakCandidates[ iRandomSpeaker ]->SpeakConceptIfAllowed( iConcept, modifiers );
			speakCandidates.FastRemove( iRandomSpeaker );
			iSpeaker--;
		}
}
*/
::IsPointInRespawnRoom <- function(point)
{
	local triggers = [];
	for (local trigger; trigger = Entities.FindByClassname(trigger, "func_respawnroom");)
	{
		trigger.SetCollisionGroup(0);
		trigger.RemoveSolidFlags(4); // FSOLID_NOT_SOLID
		triggers.append(trigger);
	}

	local trace =
	{
		start = point,
		end = point,
		mask = 0
	}
	TraceLineEx(trace);

	foreach (trigger in triggers)
	{
		trigger.SetCollisionGroup(25); // special collision group used by respawnrooms only
		trigger.AddSolidFlags(4); // FSOLID_NOT_SOLID
	}

	return trace.hit && trace.enthit.GetClassname() == "func_respawnroom";
}

::DebugDrawTrigger <- function(trigger, r, g, b, alpha, duration)
{
	local origin = trigger.GetOrigin()
	local mins = NetProps.GetPropVector(trigger, "m_Collision.m_vecMins")
	local maxs = NetProps.GetPropVector(trigger, "m_Collision.m_vecMaxs")
	if (trigger.GetSolid() == 2)
		DebugDrawBox(origin, mins, maxs, r, g, b, alpha, duration)
	else if (trigger.GetSolid() == 3)
		DebugDrawBoxAngles(origin, mins, maxs, trigger.GetAbsAngles(), Vector(r, g, b), alpha, duration)
}

::Distance3D <- function(v1,v2)
{
	local a = (v2.x-v1.x);
	local b = (v2.y-v1.y);
	local c = (v2.z-v1.z);

	return sqrt((a*a)+(b*b)+(c*c));
}

::clamp <- function( val, minVal, maxVal )
{
	if ( maxVal < minVal )
		return maxVal;
	else if( val < minVal )
		return minVal;
	else if( val > maxVal )
		return maxVal;
	else
		return val;
}

::min <- function( a, b )
{
	if ( a < b )
		return a;
	return b;
}

::max <- function( a, b )
{
	if ( a > b )
		return a;
	return b;
}

::clampCeiling <- function(valueA, valueB)
{
    if (valueA < valueB)
        return valueA;
    return valueB;
}

::Remap <- function(value, low1, high1, low2, high2)
{
    return low2 + (value - low1) * (high2 - low2) / (high1 - low1)
}

::CloseEnough <- function( a, b, e = 1.e-3 )
{
	a = a - b;
	if (0.0 > a)
		a = -a;

	return a <= e;
}

::CloseEnoughVelocity <- function( a, b, e = 1.e-3 )
{
	local ax = a.x;
	local ay = a.y;
	local az = a.z;
	local bx = b.x;
	local by = b.y;
	local bz = b.z;
	ax = ax - bx;
	ay = ay - by;
	az = az - bz;
	if (0.0 > ax)
		ax = -ax;

	if (0.0 > ay)
		ay = -ay;

	if (0.0 > az)
	az = -az;

	return (ax <= e) && (ay <= e) && (az <= e);
}

::RemapVal <- function( val,  A,  B,  C,  D)
{
	if ( A == B )
		return val >= B ? D : C;
	return C + (D - C) * (val - A) / (B - A);
}

::RemapValClamped <- function( val,  A,  B,  C,  D)
{
	if ( A == B )
		return val >= B ? D : C;
	local cVal = (val - A) / (B - A);
	cVal = clamp( cVal, 0.0, 1.0 );

	return C + (D - C) * cVal;
}

::RemapValClampedRound <- function ( val,  A,  B,  C,  D)
{
	if ( A == B )
		return val >= B ? D : C;
	local cVal = (val - A) / (B - A);
	cVal = clamp( cVal, 0.0, 1.0 );

	local unrounded = C + (D - C) * cVal;
	return floor(unrounded / 100) * 100;
}

//val = the chance of something happening, min is the minium chance usually 0, max is the max chance of a event

::RandomChance <-  function(val, min, max)
{
	local clampedchance = clamp( val, min, max )
	local randomVal = RandomInt(min, max)

	return (clampedchance >= randomVal)
}

::VectorAdd <- function(a, b)
{
	local c = Vector()

	c.x = a.x + b.x;
	c.y = a.y + b.y;
	c.z = a.z + b.z;

	return c
}

::VectorSubtract <- function(a, b)
{
	local c = Vector()

	c.x = a.x - b.x;
	c.y = a.y - b.y;
	c.z = a.z - b.z;

	return c
}
/*
::VectorIRotate <- function( in1, in2)
{
	out.x = in1.x*in2[0][0] + in1.y*in2[1][0] + in1.z*in2[2][0];
	out.y = in1.x*in2[0][1] + in1.y*in2[1][1] + in1.z*in2[2][1];
	out.z = in1.x*in2[0][2] + in1.y*in2[1][2] + in1.z*in2[2][2];

	return out
}
*/
::VectorCopy <- function(src, dst )
{
	dst.x = src.x;
	dst.y = src.y;
	dst.z = src.z;
	return dst
}

::FClassnameIs <- function( entity, classname )
{
	if (entity != null)
	{
		if (entity.GetClassname() == classname)
		{
			return true
		}
		else
		{
			return false
		}
	}
	else
	{
		return false
	}
}

::WorldAlignMins <- function( entity )
{
	return GetPropVector(entity, "m_Collision.m_vecMins");
}

::WorldAlignMaxs <- function( entity )
{
	return GetPropVector(entity, "m_Collision.m_vecMaxs");
}

::WorldAlignSize <- function( entity)
{
	return VectorSubtract( GetPropVector(entity, "m_Collision.m_vecMaxs"), GetPropVector(entity, "m_Collision.m_vecMins"));
}

::AngleVectors <- function( angle, forward = Vector(), right = null, up = null )
{
	local sr, cr,

		yr = DEG2RAD*angle.y,
		sy = sin(yr), cy = cos(yr),

		pr = DEG2RAD*angle.x,
		sp = sin(pr), cp = cos(pr);

	if ( angle.z )
	{
		local rr = DEG2RAD*angle.z;
		sr = -sin(rr);
		cr = cos(rr);
	}
	else
	{
		sr = 0.0;
		cr = 1.0;
	};

	if ( forward )
	{
		forward.x = cp*cy;
		forward.y = cp*sy;
		forward.z = -sp;
	};

	if ( right )
	{
		right.x = sr*sp*cy+cr*sy;
		right.y = sr*sp*sy-cr*cy;
		right.z = sr*cp;
	};

	if ( up )
	{
		up.x = cr*sp*cy-sr*sy;
		up.y = cr*sp*sy+sr*cy;
		up.z = cr*cp;
	};

	return forward;
}

::Vector2DNormalize <- function( v )
{
	Assert( v.IsValid() );
	local l = v.Length();
	if (l != 0.0)
	{
		v /= l;
	}
	else
	{
		v.x = v.y = 0.0;
	}
	return l;
}

::MakeVectorFromPoints <- function( pt1, pt2)
{
	local output = Vector()
	output.x = pt2.x - pt1.x;
	output.y = pt2.y - pt1.y;
	output.z = pt2.z - pt1.z;
	return output
}

::VectorAdd <- function( a, b)
{
	local o = Vector()
	o.x = a.x + b.x;
	o.y = a.y + b.y;
	o.z = a.z + b.z;

	return o;
}

::VectorScale <- function( a, b)
{
	local o = Vector()
	o.x = a.x * b;
	o.y = a.y * b;
	o.z = a.z * b;

	return o;
}

::VectorNormalize <- function( vec )
{
	local ool = sqrt( FLT_EPSILON + vec.x * vec.x + vec.y * vec.y + vec.z * vec.z );

	vec.x *= ool;
	vec.y *= ool;
	vec.z *= ool;
	return vec;
}

::VectorMA <- function( start, scale, direction, dest )
{
	dest.x = start.x + scale * direction.x;
	dest.y = start.y + scale * direction.y;
	dest.z = start.z + scale * direction.z;
	return dest
}

::NormalizeInPlace <- function(v)
{
	return VectorNormalize( v );
}

::DotProduct <-  function(a, b)
{
	return( a.x*b.x + a.y*b.y + a.z*b.z )
}

::DotProductAbs <- function( in1, in2 )
{
	local x = in1.x * in2.x;
	local y = in1.y * in2.y;
	local z = in1.z * in2.z;

	if ( 0.0 > x ) x = -x;
	if ( 0.0 > y ) y = -y;
	if ( 0.0 > z ) z = -z;

	return x + y + z;
}

::TraceAddValve <- function(trace)
{
	if(trace.hit)
	{
		trace.m_pEnt <- trace.enthit
		trace.DidHitWorld <- trace.m_pEnt == Entities.First();
		trace.DidHitNonWorldEntity <- trace.m_pEnt != NULL && !trace.DidHitWorld;
		trace.GetEntityIndex <- trace.m_pEnt.entindex()
	}
	else
	{
		trace.m_pEnt <- null
		trace.DidHitWorld <- false;
		trace.DidHitNonWorldEntity <- false;
		trace.GetEntityIndex <- -1
	}

	return trace
}

::UTIL_ScreenShake <- ScreenShake

::PhysicsAddGravityMove <- function(entity, move)
{
	if (entity == null)
		return

	local vecAbsVelocity = entity.GetAbsVelocity(); //vector

	move.x = (vecAbsVelocity.x + entity.GetBaseVelocity().x ) * FrameTime();
	move.y = (vecAbsVelocity.y + entity.GetBaseVelocity().y ) * FrameTime();

	if ( entity.GetFlags() & FL_ONGROUND )
	{
		move.z = entity.GetBaseVelocity().z * FrameTime();
		return;
	}

	// linear acceleration due to gravity
	local newZVelocity = vecAbsVelocity.z - GetActualGravity( entity ) * FrameTime(); //float

	move.z = ((vecAbsVelocity.z + newZVelocity) / 2.0 + entity.GetBaseVelocity().z ) * FrameTime();

	local vecBaseVelocity = entity.GetBaseVelocity(); //vector
	vecBaseVelocity.z = 0.0;
	entity.SetBaseVelocity( vecBaseVelocity );

	vecAbsVelocity.z = newZVelocity;
	entity.SetAbsVelocity( vecAbsVelocity );

	// Bound velocity
	PhysicsCheckVelocity(entity);
}

::SimulateAngles <- function(entity, flFrameTime)
{
	// move angles
	local angles = vec3_angle; //QAngle
	angles = VectorMA(entity.GetLocalAngles(), flFrameTime, entity.GetLocalAngularVelocity(), angles);
	entity.SetLocalAngles( angles );
}

::PhysicsClipVelocity <- function(invec, normal, overbounce =  1)
{
	local	backoff;
	local	change;
	local angle;
	local		i, blocked;
	local out =
	[
		0,
		0,
		0,
	]
	blocked = 0;

	local normalArray =
	[
		normal.x,
		normal.y,
		normal.z,
	]

	angle = normalArray[ 2 ];

	if ( angle > 0 )
	{
		blocked = 1;		// floor
	}
	if ( !angle )
	{
		blocked = 2;		// step
	}

	backoff = DotProduct (invec, normal) * overbounce;
	local invecArray =
	[
		invec.x,
		invec.y,
		invec.z,
	]

	for ( i=0 ; i<3 ; i++ )
	{
		change = normalArray[i]*backoff;
		out[i] = invecArray[i] - change;
		if (out[i] > -STOP_EPSILON && out[i] < STOP_EPSILON)
		{
			out[i] = 0;
		}
	}

	return blocked, Vector(out[0], out[1], out[2]);
}

::VectorCompare <- function(v1, v2)
{
	return v1 == v2;
}

::VectorMultiply <- function(a, b)
{
	local c = Vector()
	c.x = a.x * b;
	c.y = a.y * b;
	c.z = a.z * b;
	return c
}

::VectorScale <- function(v1, scale)
{
	return VectorMultiply( v1, scale);
}

::SetAbsVelocity <- function(ent, vecAbsVelocity)
{
	if (GetPropVector(ent, "m_vecAbsVelocity") == vecAbsVelocity )
		return;

	// The abs velocity won't be dirty since we're setting it here
	//InvalidatePhysicsRecursive( VELOCITY_CHANGED );
	//m_iEFlags &= ~EFL_DIRTY_ABSVELOCITY;

	SetPropVector(ent, "m_vecAbsVelocity", vecAbsVelocity)

	local pMoveParent = ent.GetMoveParent();

	if (!pMoveParent)
	{
		SetPropVector(ent, "m_vecAbsVelocity", vecAbsVelocity)
		return;
	}

	// First subtract out the parent's abs velocity to get a relative
	// velocity measured in world space
	local relVelocity = VectorSubtract(vecAbsVelocity, ent.GetMoveParent().GetAbsVelocity());

	// Transform velocity into parent space
	//VectorIRotate( relVelocity, pMoveParent->EntityToWorldTransform(), m_vecVelocity );
}

::FindHullIntersection <- function( vecSrc, tr, mins, maxs, pEntity )
{
	//printl("FindHullIntersection start")
	local	i, j, k;

	local vecEnd;
	local tmpTrace
	local distance = 1000000.0;
	local minmaxs = array(2, {
	    mins = mins ,
	    maxs = maxs
	})
	local vecHullEnd = tr.endpos;

	vecHullEnd = vecSrc + ((vecHullEnd - vecSrc)*2);

	tmpTrace =
	{
		start = vecSrc,
		end = vecHullEnd,
		ignore = pEntity,
		mask = MASK_SOLID,
		filter = function(entity)
		{
			// if player is on red team, accept the hit
			if (entity.GetTeam() != pEntity.GetTeam())
				return TRACE_STOP;

			return TRACE_CONTINUE;
		}
	};

	TraceLineFilter(tmpTrace);

	//printl("FindHullIntersection tmpTrace")

	if ( tmpTrace.fraction < 1.0 )
	{
		//printl("FindHullIntersection break1")
		tr = tmpTrace;
		return tr;
	}
	/*
	for ( i = 0; i < 2; i++ )
	{
		for ( j = 0; j < 2; j++ )
		{
			for ( k = 0; k < 2; k++ )
			{
				vecEnd.x = vecHullEnd.x + minmaxs[i][0];
				vecEnd.y = vecHullEnd.y + minmaxs[j][1];
				vecEnd.z = vecHullEnd.z + minmaxs[k][2];

				tmpTrace =
				{
					start = vecSrc,
					end = vecEnd,
					mask = MASK_SOLID,
					ignore = pEntity,
				}

				TraceLineEx(tmpTrace)

				if ( tmpTrace.fraction < 1.0 )
				{
					local thisDistance = (tmpTrace.endpos - vecSrc).Length();
					if ( thisDistance < distance )
					{
						printl("FindHullIntersection break2")
						tr = tmpTrace;
						distance = thisDistance;
						return tr;
					}
				}
			}
		}
	}
	*/
}

::GetGroundEntity <- function(entity)
{
	return GetPropEntity(entity, "m_hGroundEntity")
}

::GetActualGravity <- function( pEnt )
{
	local ent_gravity = pEnt.GetGravity(); //float
	if ( ent_gravity == 0.0 )
	{
		ent_gravity = 1.0;
	}

	return ent_gravity * Convars.GetFloat("sv_gravity");
}

::SetGroundEntity <- function(entity, ground)
{
	if ( GetGroundEntity(entity) == ground )
		return;

	SetPropEntity(entity, "m_hGroundEntity", ground)
}

::PhysicsRunThink <-  function(entity, thinkMethod = 0)
{
	if ( entity.IsEFlagSet( EFL_NO_THINK_FUNCTION ) )
		return true;

	local bAlive = true;

	// Are we just firing the base think?
	if ( thinkMethod == 1 )
		return bAlive;

	return bAlive;
}

::PhysicsCheckVelocity <- function(entity)
{
	local origin = [
		entity.GetAbsOrigin().x,
		entity.GetAbsOrigin().y,
		entity.GetAbsOrigin().z,
	]

	local vecAbsVelocity = [
		entity.GetAbsVelocity().x,
		entity.GetAbsVelocity().y,
		entity.GetAbsVelocity().z,
	]

	local bReset = false;
	for ( local i=0 ; i<3 ; i++ )
	{
		/*
		if ( IS_NAN(vecAbsVelocity[i]) )
		{
			vecAbsVelocity[i] = 0;
			bReset = true;
		}
		if ( IS_NAN(origin[i]) )
		{
			origin[i] = 0;
			bReset = true;
		}
		*/
		if ( vecAbsVelocity[i] > Convars.GetFloat("sv_maxvelocity") )
		{
			vecAbsVelocity[i] = Convars.GetFloat("sv_maxvelocity");
			bReset = true;
		}
		else if ( vecAbsVelocity[i] < -Convars.GetFloat("sv_maxvelocity") )
		{
			vecAbsVelocity[i] = -Convars.GetFloat("sv_maxvelocity");
			bReset = true;
		}
	}

	if (bReset)
	{
		entity.SetAbsOrigin( Vector(origin.x, origin.y, origin.z) );
		entity.SetAbsVelocity( Vector(vecAbsVelocity.x, vecAbsVelocity.y, vecAbsVelocity.z)  );
	}
}

//-----------------------------------------------------------------------------
// returns true if we're currently being ragdolled
//-----------------------------------------------------------------------------
::IsRagdoll <- function(entity)
{
	if (entity != null)
	{
		if (entity.GetClassname() == "tf_ragdoll")
		{
			return true
		}
		else
		{
			return false
		}
	}
	else
	{
		return false
	}
}

//-----------------------------------------------------------------------------
// Makes ragdolls ignore npcclip brushes
//-----------------------------------------------------------------------------
::PhysicsSolidMaskForEntity <- function(entity )
{
	// This allows ragdolls to move through npcclip brushes
	if ( !IsRagdoll(entity) )
	{
		return MASK_NPCSOLID;
	}
	return MASK_SOLID;
}
//-----------------------------------------------------------------------------
// helper method for trace hull as used by physics...
//-----------------------------------------------------------------------------
::Physics_TraceHull <- function( pBaseEntity, vecStart, vecEnd, chullMin, chullMax, maskfortrace )
{
	local trace =
	{
		ignore  = pBaseEntity // don't hit ourselves
		start   = vecStart // start from feet
		end     = vecEnd // sweep downwards
		hullmin = chullMin // same box size as player
		hullmax = chullMax
		mask = maskfortrace
	}
	return TraceHull(trace)
}

//-----------------------------------------------------------------------------
// Purpose: Does not change the entities velocity at all
// Input  : push -
// Output : trace_t
//-----------------------------------------------------------------------------

::PhysicsCheckSweep <-  function(entity, vecAbsStart, vecAbsDelta)
{
	local mask = PhysicsSolidMaskForEntity();

	local vecAbsEnd = vec3_origin;
	VectorAdd( vecAbsStart, vecAbsDelta, vecAbsEnd );

	// Set collision type
	if ( !entity.IsSolid() || entity.IsSolidFlagSet( FSOLID_VOLUME_CONTENTS ) )
	{
		// don't collide with monsters
		//mask &= ~CONTENTS_MONSTER;
	}

	return Physics_TraceHull( entity, vecAbsStart, vecAbsEnd, WorldAlignMins(entity), WorldAlignMaxs(entity), mask );
}

//-----------------------------------------------------------------------------
// Purpose:
// Input  : push -
// Output : trace_t
//-----------------------------------------------------------------------------
::PhysicsPushEntity <-  function(entity, push)
{
	//local pTrace = {}

	// NOTE: absorigin and origin must be equal because there is no moveparent
	local prevOrigin;
	prevOrigin = VectorCopy(entity.GetAbsOrigin(), prevOrigin);

	local pTrace = PhysicsCheckSweep(entity, prevOrigin, push);

	if ( pTrace.fraction )
	{
		entity.SetOrigin( pTrace.endpos );
	}
	// CLIENT DLL HACKS
	SetPropVector(entity, "m_vecNetworkOrigin", self.GetLocalOrigin())
	SetPropVector(entity, "m_angNetworkAngles", self.GetLocalAngles())

//	InvalidatePhysicsRecursive( POSITION_CHANGED | ANGLES_CHANGED );

	if ( pTrace.m_pEnt )
	{
		PhysicsImpact( pTrace.m_pEnt, pTrace );
	}

	return pTrace
}

::PhysicsToss <- function(entity)
{
	local	trace; //trace_t
	local move = vec3_origin; //vector

	entity.PhysicsCheckWater();

	// regular thinking
	if ( !PhysicsRunThink(entity) )
		return;

	// Moving upward, off the ground, or  resting on a client/monster, remove FL_ONGROUND
	if ( entity.GetAbsVelocity().z > 0 || !GetGroundEntity(entity) || !GetGroundEntity(entity).IsStandable() )
	{
		SetGroundEntity(entity, NULL);
	}
	// Check to see if entity is on the ground at rest
	if ( entity.GetFlags() & FL_ONGROUND )
	{
		if ( VectorCompare( entity.GetAbsVelocity(), vec3_origin ) )
		{
			// Clear rotation if not moving (even if on a conveyor)
			entity.SetLocalAngularVelocity( vec3_angle );
			if ( VectorCompare( entity.GetBaseVelocity(), vec3_origin ) )
				return;
		}
	}

	PhysicsCheckVelocity(entity);

	// add gravity
	if ( entity.GetMoveType() == MOVETYPE_FLYGRAVITY && !(entity.GetFlags() & FL_FLY) )
	{
		PhysicsAddGravityMove(entity, move);
	}
	else
	{
		// Base velocity is not properly accounted for since this entity will move again after the bounce without
		// taking it into account
		local vecAbsVelocity = entity.GetAbsVelocity(); //vector
		vecAbsVelocity += entity.GetBaseVelocity();
		move = VectorScale(vecAbsVelocity, FrameTime());
		PhysicsCheckVelocity(entity);
	}

	// move angles
	SimulateAngles(entity, FrameTime());

	// move origin
	trace = PhysicsPushEntity(entity, move);

	//if ( VPhysicsGetObject() )
	//{
		//VPhysicsGetObject()->UpdateShadow( GetAbsOrigin(), vec3_angle, true, gpGlobals->frametime );
	//}

	PhysicsCheckVelocity(entity);

	if (trace.fraction != 1.0)
	{
		PerformFlyCollisionResolution( trace, move );
	}

	// check for in water
	PhysicsCheckWaterTransition();
}

::BounceSound <- function()
{
    printl("BounceSound!")
}

::OnBounced <- function()
{
    printl("BounceSound!")
}

::ResolveFlyCollisionCustom <- function( trace, vecMove )
{
	local kSleepVelocity = 20.0;
	local kSleepVelocitySquared = kSleepVelocity * kSleepVelocity;

	// Verify that we have an entity.
	pEntity = trace.m_pEnt;
	Assert( pEntity );

	if ( pEntity )
	{
		local pChicken = (pEntity.GetClassname() == "tf_zombie")
		if (pChicken)
		{
			// hurt the chicken
            pEntity.TakeDamage(10, DMG_CLUB, this)

			return;
		}
	}

	// if its breakable glass and we kill it, don't bounce.
	// give some damage to the glass, and if it breaks, pass
	// through it.
	local breakthrough = false;

	if( pEntity && FClassnameIs( pEntity, "func_breakable" ) )
	{
		breakthrough = true;
	}

	if( pEntity && FClassnameIs( pEntity, "func_breakable_surf" ) )
	{
		breakthrough = true;
	}

	if( pEntity && FClassnameIs( pEntity, "prop_physics_multiplayer" ) && (pEntity.GetMaxHealth() > 0) && (GetPropInt(pEntity, "m_takedamage") == 2) )
	{
		breakthrough = true;
	}

	// this one is tricky because BounceTouch hits breakable propers before we hit this function and the damage is already applied there (CBaseGrenade::BounceTouch( CBaseEntity *pOther ))
	// by the time we hit this, the prop hasn't been removed yet, but it broke, is set to not take anymore damage and is marked for deletion - we have to cover this case here
	if (pEntity && (pEntity.GetClassname() == "prop_dynamic") && (pEntity.GetMaxHealth() > 0) && ((GetPropInt(pEntity, "m_takedamage") == 2) || ((GetPropInt(pEntity, "m_takedamage") == 2) && pEntity.IsEFlagSet(1) ) ) )
	{
		breakthrough = true;
	}

	if ( breakthrough )
	{
        pEntity.TakeDamage(10, DMG_CLUB, self.GetOwner())

		if( pEntity.GetHealth() <= 0 )
		{
			// slow our flight a little bit
			local vel = self.GetAbsVelocity();

			vel *= 0.4;

			self.SetAbsVelocity( vel );
			return;
		}
	}


	//Assume all surfaces have the same elasticity
	local flSurfaceElasticity = 1.0;

	//Don't bounce off of players with perfect elasticity
	if ( pEntity && pEntity.IsPlayer() )
	{
		flSurfaceElasticity = 0.3;

		// and do slight damage to players on the opposite team
		if ( self.GetTeamNumber() != pEntity.GetTeamNumber() )
		{
            pEntity.TakeDamage(1, DMG_GENERIC, self.GetOwner())
		}
	}

	if ( pEntity )
	{
		m_lastHitPlayer = pEntity;
	}

	local flTotalElasticity = self.GetElasticity() * flSurfaceElasticity;
	flTotalElasticity = clamp( flTotalElasticity, 0.0, 0.9 );

	// NOTE: A backoff of 2.0f is a reflection
	local vecAbsVelocity = Vector();
	vecAbsVelocity = PhysicsClipVelocity(self.GetAbsVelocity(), trace.plane.normal, 2.0);
	vecAbsVelocity *= flTotalElasticity;

	// Get the total velocity (player + conveyors, etc.)
	vecMove = VectorAdd(vecAbsVelocity, GetBaseVelocity());
	local flSpeedSqr = DotProduct( vecMove, vecMove );

	local bIsWeapon = (GetPropEntity(pEntity, "m_hOwner") != NULL);

	// Stop if on ground or if we bounce and our velocity is really low (keeps it from bouncing infinitely)

	if ( pEntity && ( ( trace.plane.normal.z > 0.7 ) || (trace.plane.normal.z > 0.1 && flSpeedSqr < kSleepVelocitySquared) ) && ( pEntity.IsStandable() || bIsProjectile || bIsWeapon || pEntity.IsWorld() ) )
	{
		// clip it again to emulate old behavior and keep it from bouncing up like crazy when you throw it at the ground on the first toss
		if ( flSpeedSqr > 96000 )
		{
			local alongDist = DotProduct( vecAbsVelocity.Normalized(), trace.plane.normal );
			if ( alongDist > 0.5 )
			{
				local flBouncePadding = (1.0 - alongDist) + 0.5;
				vecAbsVelocity *= flBouncePadding;
			}
		}

		self.SetAbsVelocity( vecAbsVelocity );

		if ( flSpeedSqr < kSleepVelocitySquared )
		{
			self.SetGroundEntity( pEntity );

			// Reset velocities.
			self.SetAbsVelocity( vec3_origin );
			self.SetLocalAngularVelocity( vec3_angle );

			//align to the ground so we're not standing on end
			local angle =  vec3_angle;
			angle = VectorAngles(trace.plane.normal, angle);

			// rotate randomly in yaw
			angle.x = RandomFloat( 0, 360 );

			// TODO: rotate around trace.plane.normal

			self.SetAbsAngles( angle );
		}
		else
		{
			local vecBaseDir = self.GetBaseVelocity();
			if ( !vecBaseDir.IsZero() )
			{
				vecBaseDir = VectorNormalize(vecBaseDir);
				local vecDelta = GetBaseVelocity() - vecAbsVelocity;
				local flScale = vecDelta.Dot( vecBaseDir );
				vecAbsVelocity += GetBaseVelocity() * flScale;
			}

			vecMove = VectorScale(vecAbsVelocity, (1.0 - trace.fraction) * FrameTime());

			trace = PhysicsPushEntity(self, vecMove);
		}
	}
	else
	{
		self.SetAbsVelocity( vecAbsVelocity );
		VectorScale( vecAbsVelocity, ( 1.0 - trace.fraction ) * FrameTime(), vecMove );
		trace = PhysicsPushEntity(self, vecMove);
	}

	BounceSound();

	OnBounced();

	if (m_nBounces > GRENADE_FAILSAFE_MAX_BOUNCES )
	{
		//failsafe detonate after 20 bounces
		self.SetAbsVelocity( vec3_origin );
		DetonateOnNextThink();
		self.SetMoveType(0,0 );
	}
	else
	{
		m_nBounces++;
	}
}

::CEconEntity.CalculateChargeDamage <-  function( flCurrentChargeMeter)
{
	local flImpactDamage = RemapValClamped( flCurrentChargeMeter, 90.0, 40.0, 15.0, 50.0 );

	local pOwner = this.GetOwner()

	if ( !pOwner )
		return flImpactDamage;

	// Cap at 5 decapitations for dmg bonus
	local iDecaps = Min( pOwner.GetDecapitations(), 5 );
	if ( iDecaps > 0 )
	{
		flImpactDamage *= (1.0 + iDecaps * 0.1 );
	}

	flImpactDamage *= this.GetAttribute("charge impact damage increased", 1.0)
	flImpactDamage *= this.GetAttribute("charge impact damage decreased", 1.0)

	return flImpactDamage;
}

::CBaseCombatWeapon.CalculateChargeDamage <- CEconEntity.CalculateChargeDamage
::CTFWeaponBase.CalculateChargeDamage <- CBaseCombatWeapon.CalculateChargeDamage

::CEconEntity.GetShieldDamageForce <-  function( flCurrentChargeMeter)
{
	local vecVelocity = this.GetAbsVelocity();
	local pPhysicsObject = GetPropEntity(this, "m_pPhysicsObject");
	if ( pPhysicsObject )
	{
		vecVelocity = this.GetVelocity();
		VectorNormalize( vecVelocity );
	}

	return (vecVelocity * this.CalculateChargeDamage( flCurrentChargeMeter ) );
}

::CBaseCombatWeapon.GetShieldDamageForce <- CEconEntity.GetShieldDamageForce
::CTFWeaponBase.GetShieldDamageForce <- CBaseCombatWeapon.GetShieldDamageForce

::CEconEntity.ShieldBash <-  function( pPlayer, flCurrentChargeMeter )
{
	local pOwner = this.GetOwner();
	if ( !pOwner )
		return;

	// Setup the swing range.
	local vecForward = AngleVectors(pOwner.EyeAngles());
	local vecStart = pOwner.Weapon_ShootPosition();
	local vecEnd = vecStart + vecForward * 48;

	// See if we hit anything.
	local trace = {
		start   = vecStart
		end     = vecEnd
		hullmin = Vector(-24,-24,-24)
		hullmax = Vector(24,24,24)
		mask 	= MASK_SOLID
		ignore  = pOwner // don't hit ourselves
	}

	TraceHull(trace);

	// Play an impact sound.
	local bImpactDamage = false;
	if(trace.hit)
	{
		if ( trace.enthit )
		{
			local pszSoundName = "";
			if ( trace.enthit.IsPlayer() )
			{
				bImpactDamage = true;
				pszSoundName = "DemoCharge.HitFleshRange";
			}
			else
			{
				pszSoundName = "DemoCharge.HitWorld";
			}
			pOwner.EmitSound( pszSoundName );
		}

		UTIL_ScreenShake(pOwner.GetCenter(), 25.0, 150.0, 1.0, 750, SHAKE_START,false );

		// Apply impact damage, if any.
		if ( bImpactDamage )
		{
			local flBashDamage = CalculateChargeDamage( flCurrentChargeMeter );
			trace.enthit.TakeDamageCustom(this, pOwner, this, GetShieldDamageForce( flCurrentChargeMeter ), trace.endpos, flBashDamage, DMG_CLUB, TF_DMG_CUSTOM_CHARGE_IMPACT);
		}

		return true
	}

	return false
}


::CBaseCombatWeapon.GetShieldDamageForce <- CEconEntity.GetShieldDamageForce
::CTFWeaponBase.GetShieldDamageForce <- CBaseCombatWeapon.GetShieldDamageForce

::CEconEntity.GetWeaponName <-  function()
{
	local weapon = this;

	switch (GetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex"))
	{
		case 0:
			return "Bat"
			break;
		case 1:
			return "Bottle"
			break;
		case 2:
			return "Fire Axe"
			break;
		case 3:
			return "Kukri"
			break;
		case 4:
			return "Knife"
			break;
		case 5:
			return "Fists"
			break;
		case 6:
			return "Shovel"
			break;
		case 7:
			return "Wrench"
			break;
		case 8:
			return "Bonesaw"
			break;
		case 10:
			return "Shotgun"
			break;
		case 11:
			return "Shotgun"
			break;
		case 12:
			return "Shotgun"
			break;
		case 13:
			return "Scattergun"
			break;
		case 14:
			return "Sniper Rifle"
			break;
		case 16:
			return "SMG"
			break;
		case 17:
			return "Syringe Gun"
			break;
		case 20:
			return "Stickybomb Launcher"
			break;
		case 22:
			return "Pistol"
			break;
		case 25:
			return "Construction PDA"
			break;
		case 26:
			return "Destruction PDA"
			break;
		case 27:
			return "Disguise Kit PDA"
			break;
		case 28:
			return "Toolbox"
			break;
		case 30:
			return "Invis Watch"
			break;
		case 36:
			return "Blutsauger"
			break;
		case 37:
			return "Ubersaw"
			break;
		case 38:
			return "Axtinguisher"
			break;
		case 39:
			return "Flare Gun"
			break;
		case 42:
			return "Sandvich"
			break;
		case 43:
			return "Killing Gloves of Boxing"
			break;
		case 44:
			return "Sandman"
			break;
		case 45:
			return "Force-A-Nature"
			break;
		case 46:
			return "Bonk! Atomic Punch"
			break;
		case 56:
			return "Huntsman"
			break;
		case 57:
			return "Razorback"
			break;
		case 58:
			return "Jarate"
			break;
		case 59:
			return "Dead Ringer"
			break;
		case 60:
			return "Cloak and Dagger"
			break;
		case 128:
			return "Equalizer"
			break;
		case 129:
			return "Buff Banner"
			break;
		case 130:
			return "Scottish Resistance"
			break;
		case 131:
			return "Chargin' Targe"
			break;
		case 132:
			return "Eyelander"
			break;
		case 133:
			return "Gunboats"
			break;
		case 140:
			return "Wrangler"
			break;
		case 142:
			return "Gunslinger"
			break;
		case 153:
			return "Homewrecker"
			break;
		case 154:
			return "Pain Train"
			break;
		case 155:
			return "Southern Hospitality"
			break;
		case 159:
			return "Dalokohs Bar"
			break;
		case 160:
			return "Lugermorph"
			break;
		case 163:
			return "Crit-a-Cola"
			break;
		case 169:
			return "Golden Wrench"
			break;
		case 171:
			return "Tribalman's Shiv"
			break;
		case 172:
			return "Scotsman's Skullcutter"
			break;
		case 173:
			return "Vita-Saw"
			break;
		case 190:
			return "Bat"
			break;
		case 191:
			return "Bottle"
			break;
		case 192:
			return "Fire Axe"
			break;
		case 193:
			return "Kukri"
			break;
		case 194:
			return "Knife"
			break;
		case 195:
			return "Fists"
			break;
		case 196:
			return "Shovel"
			break;
		case 197:
			return "Wrench"
			break;
		case 198:
			return "Bonesaw"
			break;
		case 200:
			return "Scattergun"
			break;
		case 201:
			return "Sniper Rifle"
			break;
		case 204:
			return "Syringe Gun"
			break;
		case 212:
			return "Invis Watch"
			break;
		case 214:
			return "Powerjack"
			break;
		case 220:
			return "Shortstop"
			break;
		case 221:
			return "Holy Mackerel"
			break;
		case 222:
			return "Mad Milk"
			break;
		case 225:
			return "Your Eternal Reward"
			break;
		case 226:
			return "Battalion's Backup"
			break;
		case 230:
			return "Sydney Sleeper"
			break;
		case 231:
			return "Darwin's Danger Shield"
			break;
		case 232:
			return "Bushwacka"
			break;
		case 239:
			return "Gloves of Running Urgently"
			break;
		case 264:
			return "Frying Pan"
			break;
		case 266:
			return "Horseless Headless Horsemann's Headtaker"
			break;
		case 297:
			return "Enthusiast's Timepiece"
			break;
		case 304:
			return "Amputator"
			break;
		case 305:
			return "Crusader's Crossbow"
			break;
		case 307:
			return "Ullapool Caber"
			break;
		case 310:
			return "Warrior's Spirit"
			break;
		case 311:
			return "Buffalo Steak Sandvich"
			break;
		case 317:
			return "Candy Cane"
			break;
		case 325:
			return "Boston Basher"
			break;
		case 326:
			return "Back Scratcher"
			break;
		case 327:
			return "Claidheamh Mòr"
			break;
		case 329:
			return "Jag"
			break;
		case 331:
			return "Fists of Steel"
			break;
		case 348:
			return "Sharpened Volcano Fragment"
			break;
		case 349:
			return "Sun-on-a-Stick"
			break;
		case 351:
			return "Detonator"
			break;
		case 354:
			return "Concheror"
			break;
		case 355:
			return "Fan O'War"
			break;
		case 356:
			return "Conniver's Kunai"
			break;
		case 357:
			return "Half-Zatoichi"
			break;
		case 401:
			return "Shahanshah"
			break;
		case 402:
			return "Bazaar Bargain"
			break;
		case 404:
			return "Persian Persuader"
			break;
		case 406:
			return "Splendid Screen"
			break;
		case 412:
			return "Overdose"
			break;
		case 413:
			return "Solemn Vow"
			break;
		case 416:
			return "Market Gardener"
			break;
		case 423:
			return "Saxxy"
			break;
		case 426:
			return "Eviction Notice"
			break;
		case 433:
			return "Fishcake"
			break;
		case 444:
			return "Mantreads"
			break;
		case 447:
			return "Disciplinary Action"
			break;
		case 450:
			return "Atomizer"
			break;
		case 452:
			return "Three-Rune Blade"
			break;
		case 457:
			return "Postal Pummeler"
			break;
		case 461:
			return "Big Earner"
			break;
		case 466:
			return "Maul"
			break;
		case 474:
			return "Conscientious Objector"
			break;
		case 482:
			return "Nessie's Nine Iron"
			break;
		case 526:
			return "Machina"
			break;
		case 572:
			return "Unarmed Combat"
			break;
		case 574:
			return "Wanga Prick"
			break;
		case 587:
			return "Apoco-Fists"
			break;
		case 589:
			return "Eureka Effect"
			break;
		case 593:
			return "Third Degree"
			break;
		case 594:
			return "Phlogistinator"
			break;
		case 595:
			return "Manmelter"
			break;
		case 609:
			return "Scottish Handshake"
			break;
		case 638:
			return "Sharp Dresser"
			break;
		case 642:
			return "Cozy Camper"
			break;
		case 648:
			return "Wrap Assassin"
			break;
		case 649:
			return "Spy-cicle"
			break;
		case 656:
			return "Holiday Punch"
			break;
		case 660:
			return "Festive Bat"
			break;
		case 662:
			return "Festive Wrench"
			break;
		case 664:
			return "Festive Sniper Rifle"
			break;
		case 665:
			return "Festive Knife"
			break;
		case 727:
			return "Black Rose"
			break;
		case 735:
			return "Sapper"
			break;
		case 736:
			return "Sapper"
			break;
		case 737:
			return "Construction PDA"
			break;
		case 739:
			return "Lollichop"
			break;
		case 740:
			return "Scorch Shot"
			break;
		case 752:
			return "Hitman's Heatmaker"
			break;
		case 775:
			return "Escape Plan"
			break;
		case 792:
			return "Sniper Rifle"
			break;
		case 794:
			return "Knife"
			break;
		case 795:
			return "Wrench"
			break;
		case 801:
			return "Sniper Rifle"
			break;
		case 803:
			return "Knife"
			break;
		case 804:
			return "Wrench"
			break;
		case 810:
			return "Red-Tape Recorder"
			break;
		case 812:
			return "Flying Guillotine"
			break;
		case 813:
			return "Neon Annihilator"
			break;
		case 831:
			return "Red-Tape Recorder"
			break;
		case 833:
			return "Flying Guillotine (Genuine)"
			break;
		case 834:
			return "Neon Annihilator (Genuine)"
			break;
		case 851:
			return "AWPer Hand"
			break;
		case 863:
			return "Robo-Sandvich"
			break;
		case 880:
			return "Freedom Staff"
			break;
		case 881:
			return "Sniper Rifle"
			break;
		case 883:
			return "Knife"
			break;
		case 884:
			return "Wrench"
			break;
		case 890:
			return "Sniper Rifle"
			break;
		case 892:
			return "Knife"
			break;
		case 893:
			return "Wrench"
			break;
		case 899:
			return "Sniper Rifle"
			break;
		case 901:
			return "Knife"
			break;
		case 902:
			return "Wrench"
			break;
		case 908:
			return "Sniper Rifle"
			break;
		case 910:
			return "Knife"
			break;
		case 911:
			return "Wrench"
			break;
		case 933:
			return "Ap-Sap"
			break;
		case 939:
			return "Bat Outta Hell"
			break;
		case 947:
			return "Quackenbirdt"
			break;
		case 954:
			return "Memory Maker"
			break;
		case 957:
			return "Sniper Rifle"
			break;
		case 959:
			return "Knife"
			break;
		case 960:
			return "Wrench"
			break;
		case 966:
			return "Sniper Rifle"
			break;
		case 968:
			return "Knife"
			break;
		case 969:
			return "Wrench"
			break;
		case 999:
			return "Festive Holy Mackerel"
			break;
		case 1000:
			return "Festive Axtinguisher"
			break;
		case 1001:
			return "Festive Buff Banner"
			break;
		case 1002:
			return "Festive Sandvich"
			break;
		case 1003:
			return "Festive Ubersaw"
			break;
		case 1005:
			return "Festive Huntsman"
			break;
		case 1013:
			return "Ham Shank"
			break;
		case 1071:
			return "Gold Frying Pan"
			break;
		case 1079:
			return "Festive Crusader's Crossbow"
			break;
		case 1080:
			return "Festive Sapper"
			break;
		case 1081:
			return "Festive Flare Gun"
			break;
		case 1082:
			return "Festive Eyelander"
			break;
		case 1083:
			return "Festive Jarate"
			break;
		case 1084:
			return "Festive Gloves of Running Urgently"
			break;
		case 1092:
			return "Fortified Compound"
			break;
		case 1098:
			return "Classic"
			break;
		case 1099:
			return "Tide Turner"
			break;
		case 1100:
			return "Bread Bite"
			break;
		case 1101:
			return "B.A.S.E. Jumper"
			break;
		case 1102:
			return "Snack Attack"
			break;
		case 1105:
			return "Self-Aware Beauty Mark"
			break;
		case 1121:
			return "Mutated Milk"
			break;
		case 1123:
			return "Necro Smasher"
			break;
		case 1127:
			return "Crossing Guard"
			break;
		case 1141:
			return "Festive Shotgun"
			break;
		case 1143:
			return "Festive Bonesaw"
			break;
		case 1144:
			return "Festive Targe"
			break;
		case 1145:
			return "Festive Bonk!"
			break;
		case 1152:
			return "Grappling Hook"
			break;
		case 1153:
			return "Panic Attack"
			break;
		case 1179:
			return "Thermal Thruster"
			break;
		case 1180:
			return "Gas Passer"
			break;
		case 1181:
			return "Hot Hand"
			break;
		case 1184:
			return "Gloves of Running Urgently"
			break;
		case 1190:
			return "Second Banana"
			break;
		case 15000:
			return "Sniper Rifle"
			break;
		case 15007:
			return "Sniper Rifle"
			break;
		case 15019:
			return "Sniper Rifle"
			break;
		case 15023:
			return "Sniper Rifle"
			break;
		case 15033:
			return "Sniper Rifle"
			break;
		case 15059:
			return "Sniper Rifle"
			break;
		case 15062:
			return "Knife"
			break;
		case 15070:
			return "Sniper Rifle"
			break;
		case 15071:
			return "Sniper Rifle"
			break;
		case 15072:
			return "Sniper Rifle"
			break;
		case 15073:
			return "Wrench"
			break;
		case 15074:
			return "Wrench"
			break;
		case 15075:
			return "Wrench"
			break;
		case 15094:
			return "Knife"
			break;
		case 15095:
			return "Knife"
			break;
		case 15096:
			return "Knife"
			break;
		case 15111:
			return "Sniper Rifle"
			break;
		case 15112:
			return "Sniper Rifle"
			break;
		case 15114:
			return "Wrench"
			break;
		case 15118:
			return "Knife"
			break;
		case 15119:
			return "Knife"
			break;
		case 15135:
			return "Sniper Rifle"
			break;
		case 15136:
			return "Sniper Rifle"
			break;
		case 15139:
			return "Wrench"
			break;
		case 15140:
			return "Wrench"
			break;
		case 15143:
			return "Knife"
			break;
		case 15144:
			return "Knife"
			break;
		case 15154:
			return "Sniper Rifle"
			break;
		case 15156:
			return "Wrench"
			break;
		case 30665:
			return "Shooting Star"
			break;
		case 30667:
			return "Batsaber"
			break;
		case 30758:
			return "Prinny Machete"
			break;
		default:
			return ""
			break;
	}
}

::CBaseCombatWeapon.GetWeaponName <- CEconEntity.GetWeaponName
::CTFWeaponBase.GetWeaponName <- CBaseCombatWeapon.GetWeaponName

::CEconEntity.GetWeaponIndex <-  function()
{
	local weapon = this
	return GetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex")
}

::CBaseCombatWeapon.GetWeaponIndex <- CEconEntity.GetWeaponIndex
::CTFWeaponBase.GetWeaponIndex <- CBaseCombatWeapon.GetWeaponIndex

::CTFPlayer.GetDecapitations <- function()
{
	return GetPropInt(this, "m_Shared.m_iDecapitations")
}

::CTFBot.GetDecapitations <- CTFPlayer.GetDecapitations

::CTFPlayer.SetDecapitations <- function(Decapitations)
{
	SetPropInt(this, "m_Shared.m_iDecapitations", Decapitations)
}

::CTFBot.SetDecapitations <- CTFPlayer.SetDecapitations

::CTFPlayer.AddDecapitations <- function(Decapitations)
{
	local NewDecapitations = this.GetDecapitations() + Decapitations
	if(NewDecapitations < 0)
	{
		SetPropInt(this, "m_Shared.m_iDecapitations", 0)
	}
	else
	{
		SetPropInt(this, "m_Shared.m_iDecapitations", NewDecapitations)
	}
}

::CTFBot.AddDecapitations <- CTFPlayer.SetDecapitations

::CTFPlayer.GetAmmoCount <- function(iAmmoIndex)
{
	local player = this;
	if ( iAmmoIndex == -1 )
		return 0;

	// Infinite ammo?
	//if ( GetAmmoDef()->MaxCarry( iAmmoIndex ) == INFINITE_AMMO )
	//	return 999;

	return GetPropIntArray(player, "m_iAmmo", iAmmoIndex)
}

::CTFBot.GetAmmoCount <- CTFPlayer.GetAmmoCount

::CTFPlayer.SetAmmoCount <-  function(m_iAmmo, m_iAmmoIndex, m_bRemove)
{
	local player = this;
	if ( m_iAmmoIndex == -1 )
		return 0;

	if(m_bRemove)
	{
		SetPropIntArray(player, "m_iAmmo", GetPropIntArray(player, "m_iAmmo", m_iAmmoIndex) - m_iAmmo, m_iAmmoIndex)
	}
	else
	{
		SetPropIntArray(player, "m_iAmmo", GetPropIntArray(player, "m_iAmmo", m_iAmmoIndex) + m_iAmmo, m_iAmmoIndex)
	}
}

::CTFBot.SetAmmoCount <- CTFPlayer.SetAmmoCount

::CTFPlayer.SetNextAttack <- function(flWait)
{
	local player = this;
	SetPropFloat(player, "m_flNextAttack", flWait)
}

::CTFBot.SetNextAttack <- CTFPlayer.SetNextAttack

::CEconEntity.DefaultReload <-  function()
{
	local m_hWeapon = this

	local pOwner = m_hWeapon.GetOwner();
	if (!pOwner)
		return false;

	// If I don't have any spare ammo, I can't reload
	if ( pOwner.GetAmmoCount(m_hWeapon.GetPrimaryAmmoType()) <= 0 )
		return false;

	//if (m_bIsDeploying)
		//return false;

	local bReload = false;

	// If you don't have clips, then don't try to reload them.
	if ( m_hWeapon.UsesClipsForAmmo1() )
	{
		// need to reload primary clip?
		local primary = min(m_hWeapon.GetMaxClip1() - m_hWeapon.Clip1(), pOwner.GetAmmoCount(m_hWeapon.GetPrimaryAmmoType()));
		printl(primary)
		if ( primary != 0 )
		{
			m_hWeapon.SetClip1(m_hWeapon.Clip1() + primary)
			pOwner.SetAmmoCount(primary, m_hWeapon.GetPrimaryAmmoType(), true)
			pOwner.SetAmmoCount(1, m_hWeapon.GetPrimaryAmmoType(), false)
			bReload = true;
		}
	}

	if ( !bReload )
		return false;

#ifdef CLIENT_DLL
	// Play reload
	//WeaponSound( RELOAD );
#endif
	//SendWeaponAnim( iActivity );
	local vm = pOwner.GetViewmodel()

	local flSequenceEndTime = Time() + vm.GetSequenceDuration(vm.GetSequence());
	pOwner.SetNextAttack( flSequenceEndTime );
	SetPropFloat(m_hWeapon, "m_flNextPrimaryAttack", flSequenceEndTime)

	//m_bInReload = true;

	return true;
}

::CBaseCombatWeapon.DefaultReload <- CEconEntity.DefaultReload
::CTFWeaponBase.DefaultReload <- CBaseCombatWeapon.DefaultReload

::CBaseCombatWeapon.IsMeleeWeaponBetter <- function()
{
	local weapon = this;
	switch (weapon.GetClassname())
	{
		case "tf_weapon_bat":
		case "tf_weapon_bat_wood":
		case "tf_weapon_bat_fish":
		case "tf_weapon_bat_giftwrap":
		case "tf_weapon_shovel":
		case "tf_weapon_katana":
		case "tf_weapon_fireaxe":
		case "tf_weapon_breakable_sign":
		case "tf_weapon_slap":
		case "tf_weapon_bottle":
		case "tf_weapon_sword":
		case "tf_weapon_stickbomb":
		case "tf_weapon_fists":
		case "tf_weapon_wrench":
		case "tf_weapon_robot_arm":
		case "tf_weapon_bonesaw":
		case "tf_weapon_knife":
		case "tf_weapon_club":
			return true
			break;
		default:
			return false
			break;
	}
}

::CTFWeaponBase.IsMeleeWeaponBetter <- CBaseCombatWeapon.IsMeleeWeaponBetter

::CBaseCombatWeapon.WeaponReach <- function()
{ // 64 96 110
	local weapon = this;
	local DefaultReach = (66 * weapon.GetAttribute("melee range multiplier", 1))
	if (weapon.GetAttribute("is_a_sword", 0) != 0)
	{
		return DefaultReach * 1.5
	}

	return DefaultReach
}

::CTFWeaponBase.WeaponReach <- CBaseCombatWeapon.WeaponReach

::CBaseCombatWeapon.ApplyFireDelay <- function( flDelay )
{
	local weapon = this;
	local pPlayer = weapon.GetOwner()
	local flDelayMult = 1.0;

	flDelayMult = flDelayMult * weapon.GetAttribute("fire rate penalty", 1.0);
	flDelayMult = flDelayMult * weapon.GetAttribute("fire rate bonus", 1.0);
	flDelayMult = flDelayMult * weapon.GetAttribute("fire rate penalty HIDDEN", 1.0);
	flDelayMult = flDelayMult * weapon.GetAttribute("fire rate bonus HIDDEN", 1.0);

	//local flComboBoost = 0.0;
	//CALL_ATTRIB_HOOK_FLOAT( flComboBoost, kill_combo_fire_rate_boost );
	//flComboBoost *= GetKillComboCount();

	//flDelayMult -= flComboBoost;

	// Haste Powerup Rune adds multiplier to fire delay time
	if ( pPlayer && pPlayer.GetCarryingRuneType() == RUNE_HASTE )
	{
		flDelayMult *= 0.5;
	}
	else if ( pPlayer && ( pPlayer.GetCarryingRuneType() == RUNE_KING || pPlayer.InCond( TF_COND_KING_BUFFED ) ) )
	{
		flDelayMult *= 0.75;
	}

	return flDelay * flDelayMult;
}

::CTFWeaponBase.ApplyFireDelay <- CBaseCombatWeapon.ApplyFireDelay

::CBaseCombatWeapon.GetWeaponDeployTime <- function()
{
	local weapon = this;
	local pPlayer = weapon.GetOwner()
	local flDelayMult = 1.0;

	if ( !pPlayer )
		return false;

	local flWeaponSwitchTime = 0.5;

	// Overrides the anim length for calculating ready time.
	local flDeployTimeMultiplier = 1.0;

	flDeployTimeMultiplier = flDeployTimeMultiplier * weapon.GetAttribute("deploy time increased", 1.0); //177
	flDeployTimeMultiplier = flDeployTimeMultiplier * weapon.GetAttribute("deploy time decreased", 1.0); //178
	flDeployTimeMultiplier = flDeployTimeMultiplier * weapon.GetAttribute("single wep deploy time decreased", 1.0); //547
	flDeployTimeMultiplier = flDeployTimeMultiplier * weapon.GetAttribute("single wep deploy time increased", 1.0); //773

	// don't apply mult_switch_from_wep_deploy_time attribute if the last weapon hasn't been deployed for more than 0.67 second to match to weapon script switch time
	// unless the player latched to a hook target, then allow switching right away

	//CTFWeaponBase *pLastWeapon = dynamic_cast< CTFWeaponBase* >( pPlayer->GetLastWeapon() );
	//if ( GetPropEntity(owner, "m_hGrapplingHookTarget") != NULL || ( pLastWeapon && gpGlobals->curtime - pLastWeapon->m_flLastDeployTime > flWeaponSwitchTime ) )
	//{
	//	CALL_ATTRIB_HOOK_FLOAT_ON_OTHER( pLastWeapon, flDeployTimeMultiplier, mult_switch_from_wep_deploy_time );
	//}

	//if ( pPlayer->m_Shared.InCond( TF_COND_BLASTJUMPING ) )
	//{
	//	CALL_ATTRIB_HOOK_FLOAT( flDeployTimeMultiplier, mult_rocketjump_deploy_time );
	//}

	local iIsSword = weapon.GetAttribute("is_a_sword", 0)
	if (iIsSword != 0 )
	{
		// swords deploy and holster 75% slower
		flDeployTimeMultiplier *= 1.75;
	}

	if ( pPlayer.GetCarryingRuneType() == RUNE_AGILITY )
	{
		flDeployTimeMultiplier /= 5.0;
	}

	local numHealers = GetPropInt(pPlayer, "m_Shared.m_nNumHealers")
	if ( numHealers == 0 )
	{
		flDeployTimeMultiplier = flDeployTimeMultiplier * pPlayer.GetCustomAttribute("mod medic healed deploy time penalty", 1.0); //234
		flDeployTimeMultiplier = flDeployTimeMultiplier * weapon.GetAttribute("mod medic healed deploy time penalty", 1.0); //234
	}
	flDeployTimeMultiplier = max( flDeployTimeMultiplier, 0.00001 );
	local flDeployTime = flWeaponSwitchTime * flDeployTimeMultiplier;
	return flDeployTime
}

::CTFWeaponBase.GetWeaponDeployTime <- CBaseCombatWeapon.GetWeaponDeployTime

::CBaseCombatWeapon.GetWeaponStats <- function()
{ // 64 96 110
	local self = this;
	local table =
	{
		weapon = self,
		owner = weapon.GetOwner(),
		viewmodel = GetPropEntity(owner, "m_hViewModel"),
		itemid = GetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex"),
	}

	return table
}

::CTFWeaponBase.GetWeaponStats <- CBaseCombatWeapon.GetWeaponStats


::CBaseCombatWeapon.CorrectCrits <- function()
{
	local weapon = this;
	switch (weapon.GetWeaponName())
	{
		case "Flying Guillotine":
		case "Eyelander":
		case "Horseless Headless Horsemann's Headtaker":
		case "Nessie's Nine Iron":
		case "Claidheamh Mòr":
		case "Ullapool Caber":
		case "Half-Zatoichi":
		case "Persian Persuader":
		case "Southern Hospitality":
		case "Market Gardener":
		case "Neon Annihilator":
		case "Gunslinger":
		case "Bushwacka":
		case "Knife":
		case "Sharp Dresser":
		case "Black Rose":
		case "Your Eternal Reward":
		case "Wanga Prick":
		case "Big Earner":
		case "Conniver's Kunai":
		case "Spy-cicle":
			return true
			break;
		default:
			return false
			break;
	}
}

::CTFWeaponBase.CorrectCrits <- CBaseCombatWeapon.CorrectCrits

::CBaseCombatWeapon.GetMeleeDamage <-  function(flDamage)
{
	local weapon = this
	local pPlayer = weapon.GetOwner();
	flDamage = flDamage * weapon.GetAttribute("damage penalty", 1.0)
	flDamage = flDamage * weapon.GetAttribute("damage bonus", 1.0)
	flDamage = flDamage * weapon.GetAttribute("damage bonus HIDDEN", 1.0)
	flDamage = flDamage * weapon.GetAttribute("CARD: damage bonus", 1.0)

	/*
	local iCritDoesNoDamage = 0;
	CALL_ATTRIB_HOOK_INT( iCritDoesNoDamage, crit_does_no_damage );
	if ( iCritDoesNoDamage > 0 )
	{
		if ( iscrit )
		{
			return 0.0;
		}

		if ( piDamageType && piDamageType & DMG_CRITICAL )
		{
			return 0.0;
		}
	}
	*/


	if ( pPlayer )
	{
		local flHalfHealth = pPlayer.GetMaxHealth() * 0.5;
		if ( pPlayer.GetHealth() < flHalfHealth )
		{
			flDamage = flDamage * weapon.GetAttribute("dmg bonus while half dead", 1.0)
		}
		else
		{
			flDamage = flDamage * weapon.GetAttribute("dmg penalty while half alive", 1.0)
		}
		// Some weapons change damage based on player's health
		//local flReducedHealthBonus = CALL_ATTRIB_HOOK_FLOAT( flReducedHealthBonus, mult_dmg_with_reduced_health );
		//if ( flReducedHealthBonus != 1.0 )
		//{
		//	local flHealthFraction = clamp( pPlayer->HealthFraction(), 0.0, 1.0 );
		//	flReducedHealthBonus = Lerp( flHealthFraction, flReducedHealthBonus, 1.0 );
		//
		//	flDamage *= flReducedHealthBonus;
		//}
	}

	return flDamage;
}

::CTFWeaponBase.GetMeleeDamage <- CBaseCombatWeapon.GetMeleeDamage

::CBaseCombatWeapon.GetSwingRange <- function()
{ // 64 96 110
	local weapon = this;
	local pOwner = weapon.GetOwner()
	if ( pOwner && pOwner.InCond( TF_COND_SHIELD_CHARGE ) )
	{
		return 128;
	}
	else
	{
		if ( weapon.GetAttribute("is_a_sword", 0) != 0)
		{
			return 72; // swords are typically 72
		}
		return 48;
	}
}

::CTFWeaponBase.GetSwingRange <- CBaseCombatWeapon.GetSwingRange

::allow_tf_weapon_backstabs_degree <- 180

::CBaseCombatWeapon.IsBehindAndFacingTarget <-  function(pTarget, degree = allow_tf_weapon_backstabs_degree)
{
	local weapon = this;
	local pOwner = weapon.GetOwner();
	if ( !pOwner )
		return false;

	// Get a vector from owner origin to target origin
	local vecToTarget = pTarget.GetOrigin() - pOwner.GetOrigin();
	vecToTarget.z = 0.0;
	//vecToTarget.NormalizeInPlace();
	vecToTarget.Norm()

	// Get owner forward view vector
	local vecOwnerForward = AngleVectors(pOwner.EyeAngles(), Vector(), NULL, NULL);
	vecOwnerForward.z = 0.0;
	//vecOwnerForward.NormalizeInPlace();
	vecOwnerForward.Norm()

	// Get target forward view vector
	local vecTargetForward = AngleVectors(pTarget.EyeAngles(), Vector(), NULL, NULL);
	vecTargetForward.z = 0.0;
	//vecTargetForward.NormalizeInPlace();
	vecTargetForward.Norm()

	// Make sure owner is behind, facing and aiming at target's back
	local flPosVsTargetViewDot = DotProduct( vecToTarget, vecTargetForward );	// Behind?
	local flPosVsOwnerViewDot = DotProduct( vecToTarget, vecOwnerForward );		// Facing?
	local flViewAnglesDot = DotProduct( vecTargetForward, vecOwnerForward );	// Facestab?

	// Debug
	// 	NDebugOverlay::HorzArrow( pTarget->WorldSpaceCenter(), pTarget->WorldSpaceCenter() + 50.0f * vecTargetForward, 5.0f, 0, 255, 0, 255, true, NDEBUG_PERSIST_TILL_NEXT_SERVER );
	// 	NDebugOverlay::HorzArrow( pOwner->WorldSpaceCenter(), pOwner->WorldSpaceCenter() + 50.0f * vecOwnerForward, 5.0f, 0, 255, 0, 255, true, NDEBUG_PERSIST_TILL_NEXT_SERVER );
	// 	DevMsg( "PosDot: %3.2f FacingDot: %3.2f AnglesDot: %3.2f\n", flPosVsTargetViewDot, flPosVsOwnerViewDot, flViewAnglesDot );
	//printl(flPosVsTargetViewDot)
	//printl(flPosVsOwnerViewDot)
	//printl(flViewAnglesDot)
	return ( flPosVsTargetViewDot > RemapVal(degree,  0,  360,  1.0,  -1.0) && flPosVsOwnerViewDot > 0.5 && flViewAnglesDot > RemapVal(clamp( degree, 0, 270 ),  0,  270,  1.0,  -1.0) );

}

::CTFWeaponBase.IsBehindAndFacingTarget <- CBaseCombatWeapon.IsBehindAndFacingTarget

::CBaseCombatWeapon.CanPerformBackstabAgainstTarget <-  function(pTarget)
{
	if ( !pTarget )
		return false;

	// Immune?
	local iNoBackstab = pTarget.GetCustomAttribute("cannot be backstabbed", 0);
	if ( iNoBackstab )
		return false;

	// Behind and facing target's back?
	if ( IsBehindAndFacingTarget( pTarget ) )
		return true;

	// Is target (bot) disabled via a sapper?
	if ( IsMannVsMachineMode() && pTarget.GetTeam() == TF_TEAM_PVE_INVADERS )
	{
		if ( pTarget.InCond( TF_COND_MVM_BOT_STUN_RADIOWAVE ) )
			return true;

		if ( pTarget.InCond( TF_COND_SAPPED ) && !pTarget.IsMiniBoss() )
			return true;
	}

	return false;
}

::CTFWeaponBase.CanPerformBackstabAgainstTarget <- CBaseCombatWeapon.CanPerformBackstabAgainstTarget

::CBaseCombatWeapon.DoSwingTraceInternal <-  function(bCleave, melee_bounds_multiplier = 1.0, melee_range_multiplier = 1.0)
{
	local weapon = this;
	// Setup a volume for the melee weapon to be swung - approx size, so all melee behave the same.
	local vecSwingMinsBase = Vector(-18, -18, -18);
	local vecSwingMaxsBase = Vector(18, 18, 18);

	local trace

	local fBoundsScale = melee_range_multiplier;

	local vecSwingMins = vecSwingMinsBase * fBoundsScale;
	local vecSwingMaxs = vecSwingMaxsBase * fBoundsScale;

	// Get the current player.
	local pPlayer = weapon.GetOwner();

	if ( !pPlayer )
		return null;

	// Setup the swing range.
	local fSwingRange = weapon.GetSwingRange() * melee_range_multiplier;

	// Scale the range and bounds by the model scale if they're larger
	// Not scaling down the range for smaller models because midgets need all the help they can get
	if ( pPlayer.GetModelScale() > 1.0 )
	{
		fSwingRange *= pPlayer.GetModelScale();
		vecSwingMins *= pPlayer.GetModelScale();
		vecSwingMaxs *= pPlayer.GetModelScale();
	}

	local vecSwingStart = pPlayer.Weapon_ShootPosition()
	local vecSwingEnd = vecSwingStart + pPlayer.EyeAngles().Forward() * fSwingRange

	//to think valve already knew it would be a issue and doesn't fix it, god i love valve

	// In MvM, melee hits from the robot team wont hit teammates to ensure mobs of melee bots don't
	// swarm so tightly they hit each other and no-one else
	//bool bDontHitTeammates = pPlayer->GetTeamNumber() == TF_TEAM_PVE_INVADERS && TFGameRules()->IsMannVsMachineMode();
	//CTraceFilterIgnoreTeammates ignoreTeammatesFilter( pPlayer, COLLISION_GROUP_NONE, pPlayer->GetTeamNumber() );

	if ( bCleave ) //not even used? for a attribute that doesn't even exist
	{
		/*
		Ray_t ray;
		ray.Init( vecSwingStart, vecSwingEnd, vecSwingMins, vecSwingMaxs );
		CBaseEntity *pList[256];
		int nTargetCount = UTIL_EntitiesAlongRay( pList, ARRAYSIZE( pList ), ray, FL_CLIENT|FL_OBJECT );

		int nHitCount = 0;
		for ( local i=0; i<nTargetCount; ++i )
		{
			CBaseEntity *pTarget = pList[i];
			if ( pTarget == pPlayer )
			{
				// don't hit yourself
				continue;
			}

			if ( bDontHitTeammates && pTarget->GetTeamNumber() == pPlayer->GetTeamNumber() )
			{
				// don't hit teammate
				continue;
			}

			if ( pTargetTraceVector )
			{
				trace_t tr;
				UTIL_TraceModel( vecSwingStart, vecSwingEnd, vecSwingMins, vecSwingMaxs, pTarget, COLLISION_GROUP_NONE, &tr );
				pTargetTraceVector->AddToTail();
				pTargetTraceVector->Tail() = tr;
			}
			nHitCount++;
		}

		return nHitCount > 0;
		*/
	}
	else
	{
		local bSapperHit = false;
		/*
		// if this weapon can damage sappers, do that trace first
		local iDmgSappers = weapon.GetAttribute("set_dmg_apply_to_sapper", 0)
		if ( iDmgSappers != 0 )
		{
			CTraceFilterIgnorePlayers ignorePlayersFilter( NULL, COLLISION_GROUP_NONE );
			UTIL_TraceLine( vecSwingStart, vecSwingEnd, MASK_SOLID, &ignorePlayersFilter, &trace );
			if ( trace.fraction >= 1.0 )
			{
				UTIL_TraceHull( vecSwingStart, vecSwingEnd, vecSwingMins, vecSwingMaxs, MASK_SOLID, &ignorePlayersFilter, &trace );
			}

			if ( trace.fraction < 1.0 && trace.m_pEnt && trace.m_pEnt->IsBaseObject() && trace.m_pEnt->GetTeamNumber() == pPlayer->GetTeamNumber() )
			{
				CBaseObject *pObject = static_cast< CBaseObject* >( trace.m_pEnt );
				if ( pObject->HasSapper() )
				{
					bSapperHit = true;
				}
			}
		}
		*/
		if ( !bSapperHit )
		{
			// See if we hit anything.
			trace =
			{
				start = vecSwingStart,
				end = vecSwingEnd,
				ignore = pPlayer,
				mask = MASK_SOLID,
				filter = function(entity)
				{
					// if player is on red team, accept the hit
					if (entity.GetTeam() != pPlayer.GetTeam())
						return TRACE_STOP;

					return TRACE_CONTINUE;
				}
			};

			TraceLineFilter(trace);

			//DebugDrawLine(trace.startpos, trace.endpos, 0, 0, 255, false, 5.0)

			if ( trace.fraction >= 1.0 )
			{
				trace =
				{
					start = vecSwingStart,
					end = vecSwingEnd,
					hullmin = vecSwingMins,
					hullmax = vecSwingMaxs,
					ignore = pPlayer,
					mask = MASK_SOLID,
					filter = function(entity)
					{
						// if player is on red team, accept the hit
						if (entity.GetTeam() != pPlayer.GetTeam())
							return TRACE_STOP;

						return TRACE_CONTINUE;
					}
				};

				TraceHullFilter(trace)

				//DebugDrawBox(vecSwingEnd, vecSwingMins, vecSwingMaxs, 0, 255, 0, 150, 5.0)

				if ( trace.fraction <= 1.0 )
				{
					// Calculate the point of intersection of the line (or hull) and the object we hit
					// This is and approximation of the "best" intersection
					if (!trace.hit || trace.enthit.IsBSPModel())
					{
						// Why duck hull min/max?
						local tmptrace = FindHullIntersection(vecSwingStart, trace, VEC_DUCK_HULL_MIN, VEC_DUCK_HULL_MAX, pPlayer);
						if (tmptrace != null)
						{
							trace = tmptrace
						}
					}

					// This is the point on the actual surface (the hull could have hit space)
					//vecSwingEnd = trace.endpos;
				}
			}
		}

		return trace;
	}
}

::CTFWeaponBase.DoSwingTraceInternal <- CBaseCombatWeapon.DoSwingTraceInternal

::CBaseCombatWeapon.GetMeleeSoundHitFlesh <-  function()
{
	local weapon = this;

	switch (weapon.GetWeaponName())
	{
		//all class / multi
		case "Pain Train":
			return "Weapon_PickAxe.HitFlesh"
			break;
		case "Half-Zatoichi":
			return "Weapon_Katana.HitFlesh"
			break;
		case "Ham Shank":
			return "Weapon_HolyMackerel.HitFlesh"
			break;
		case "Prinny Machete":
		case "Crossing Guard":
		case "Necro Smasher":
		case "Memory Maker":
		case "Bat Outta Hell":
		case "Freedom Staff":
		case "Conscientious Objector":
		case "Saxxy":
			return "Weapon_Machete.HitFlesh"
			break;
		//scout
		case "Three-Rune Blade":
			return "Weapon_Sword.HitFlesh"
			break;
		case "Bat":
		case "Candy Cane":
		case "Sun-on-a-Stick":
		case "Fan O'War":
		case "Atomizer":
		case "Festive Bat":
			return "Weapon_Bat.HitFlesh"
			break;
		case "Sandman":
			return "Weapon_BaseballBat.HitFlesh"
			break;
		case "Unarmed Combat":
		case "Festive Holy Mackerel":
		case "Holy Mackerel":
			return "Weapon_HolyMackerel.HitFlesh"
			break;
		case "Gold Frying Pan":
		case "Frying Pan":
			return "FryingPan.HitFlesh"
			break;
		case "Boston Basher":
			return "BostonBasher.Impact"
			break;
		case "Batsaber":
			return "Weapon_BatSaber.HitFlesh"
			break;
		case "Wrap Assassin":
			return "BallBuster.HitFlesh"
			break;
		//soldier
		case "Market Gardener":
		case "Shovel":
			return "Weapon_Shovel.HitFlesh"
			break;
		case "Escape Plan":
		case "Equalizer":
			return "Weapon_PickAxe.HitFlesh"
			break;
		case "Disciplinary Action":
			return "DisciplineDevice.Impact"
			break;
		//pyro
		case "Festive Axtinguisher":
		case "Axtinguisher":
		case "Fire Axe":
		case "Back Scratcher":
		case "Sharpened Volcano Fragment":
		case "Lollichop":
		case "Postal Pummeler":
			return "Weapon_FireAxe.HitFlesh"
			break;
		case "Powerjack":
		case "Maul":
		case "Homewrecker":
			return "Weapon_Machete.HitFlesh"
			break;
		case "Third Degree":
			return "Weapon_3rd_degree.HitFlesh"
			break;
		case "Neon Annihilator (Genuine)":
		case "Neon Annihilator":
			return "Neon_Sign.HitFlesh"
			break;
		case "Hot Hand":
			return "Weapon_HolyMackerel.HitFlesh"
			break;
		//demo
		case "Ullapool Caber":
		case "Scottish Handshake":
		case "Bottle":
			return "Weapon_Bottle.HitFlesh"
			break;
		case "Nessie's Nine Iron":
		case "Scotsman's Skullcutter":
		case "Persian Persuader":
		case "Claidheamh Mòr":
		case "Eyelander":
		case "Festive Eyelander":
			return "Weapon_Sword.HitFlesh"
			break;
		case "Horseless Headless Horsemann's Headtaker":
			return "Halloween.HeadlessBossAxeHitFlesh"
			break;
		//heavy
		case "Fists":
			return "Weapon_Fist.HitFlesh"
			break;
		case "Fists of Steel":
			return "Weapon_MetalGloves.HitFlesh"
			break;
		case "Eviction Notice":
			return "EvictionNotice.Impact"
			break;
		case "Holiday Punch":
			return "Weapon_mittens.HitFlesh"
			break;
		case "Killing Gloves of Boxing":
		case "Gloves of Running Urgently":
		case "Warrior's Spirit":
		case "Apoco-Fists":
		case "Festive Gloves of Running Urgently (G.R.U.)":
		case "Bread Bite":
			return "Weapon_BoxingGloves.HitFlesh"
			break;
		//engineer
		case "Gunslinger":
		case "Wrench":
		case "Southern Hospitality":
		case "Golden Wrench":
		case "Jag":
		case "Eureka Effect":
		case "Festive Wrench":
			return "Weapon_Wrench.HitFlesh"
			break;
		//medic
		case "Amputator":
		case "Bonesaw":
		case "Festive Bonesaw":
			return "Weapon_BoneSaw.HitFlesh"
			break;
		case "Vita-Saw":
		case "Ubersaw":
		case "Festive Ubersaw":
			return "Weapon_UberSaw.HitFlesh"
			break;
		case "Solemn Vow":
			return "Weapon_Machete.HitFlesh"
			break;
		//sniper
		case "Kukri":
		case "Tribalman's Shiv":
		case "Bushwacka":
		case "Shahanshah":
			return "Weapon_Machete.HitFlesh"
			break;
		//spy
		case "Knife":
		case "Your Eternal Reward":
		case "Conniver's Kunai":
		case "Festive Knife":
		case "Black Rose":
		case "Wanga Prick":
		case "Big Earner":
			return "Weapon_Knife.HitFlesh"
			break;
		case "Spy-cicle":
			return ""
			break;
		case "Sharp Dresser":
			return "Weapon_Assassin_Knife.HitFlesh"
			break;
		default:
			return "Weapon_Bat.HitFlesh"
			break;
	}
}

::CTFWeaponBase.GetMeleeSoundHitFlesh <- CBaseCombatWeapon.GetMeleeSoundHitFlesh

::CBaseCombatWeapon.GetMeleeSoundHitWorld <-  function()
{
	local weapon = this;

	switch (weapon.GetWeaponName())
	{
		//all class / multi
		case "Pain Train":
			return "Weapon_Shovel.HitWorld"
			break;
		case "Half-Zatoichi":
			return "Weapon_Katana.HitWorld"
			break;
		case "Ham Shank":
			return "Weapon_HolyMackerel.HitWorld"
			break;
		case "Prinny Machete":
		case "Crossing Guard":
		case "Necro Smasher":
		case "Memory Maker":
		case "Bat Outta Hell":
		case "Freedom Staff":
		case "Conscientious Objector":
		case "Saxxy":
			return "Weapon_Machete.HitWorld"
			break;
		//scout
		case "Three-Rune Blade":
			return "Weapon_Sword.HitWorld"
			break;
		case "Bat":
		case "Candy Cane":
		case "Sun-on-a-Stick":
		case "Fan O'War":
		case "Atomizer":
		case "Festive Bat":
			return "Weapon_Bat.HitWorld"
			break;
		case "Sandman":
			return "Weapon_BaseballBat.HitWorld"
			break;
		case "Unarmed Combat":
		case "Festive Holy Mackerel":
		case "Holy Mackerel":
			return "Weapon_HolyMackerel.HitWorld"
			break;
		case "Gold Frying Pan":
		case "Frying Pan":
			return "FryingPan.HitWorld"
			break;
		case "Boston Basher":
			return "BostonBasher.Impact"
			break;
		case "Batsaber":
			return "Weapon_BatSaber.HitWorld"
			break;
		case "Wrap Assassin":
			return "BallBuster.HitWorld"
			break;
		//soldier
		case "Market Gardener":
		case "Shovel":
		case "Escape Plan":
		case "Equalizer":
			return "Weapon_Shovel.HitWorld"
			break;
		case "Disciplinary Action":
			return "DisciplineDevice.HitWorld"
			break;
		//pyro
		case "Powerjack":
		case "Maul":
		case "Homewrecker":
		case "Festive Axtinguisher":
		case "Axtinguisher":
		case "Fire Axe":
		case "Back Scratcher":
		case "Sharpened Volcano Fragment":
		case "Lollichop":
		case "Postal Pummeler":
			return "Weapon_FireAxe.HitWorld"
			break;
		case "Third Degree":
			return "Weapon_3rd_degree.HitWorld"
			break;
		case "Neon Annihilator (Genuine)":
		case "Neon Annihilator":
			return "Neon_Sign.HitWorld"
			break;
		case "Hot Hand":
			return "Weapon_HolyMackerel.HitWorld"
			break;
		//demo
		case "Ullapool Caber":
		case "Scottish Handshake":
		case "Bottle":
			return "Weapon_Bottle.HitWorld"
			break;
		case "Nessie's Nine Iron":
		case "Scotsman's Skullcutter":
		case "Persian Persuader":
		case "Claidheamh Mòr":
		case "Eyelander":
		case "Festive Eyelander":
			return "Weapon_Sword.HitWorld"
			break;
		case "Horseless Headless Horsemann's Headtaker":
			return "Halloween.HeadlessBossAxeHitWorld"
			break;
		//heavy
		case "Fists":
			return "Weapon_Fist.HitWorld"
			break;
		case "Fists of Steel":
			return "Weapon_MetalGloves.HitWorld"
			break;
		case "Eviction Notice":
			return "EvictionNotice.HitWorld"
			break;
		case "Holiday Punch":
			return "Weapon_mittens.HitWorld"
			break;
		case "Killing Gloves of Boxing":
		case "Gloves of Running Urgently":
		case "Warrior's Spirit":
		case "Apoco-Fists":
		case "Festive Gloves of Running Urgently (G.R.U.)":
		case "Bread Bite":
			return "Weapon_BoxingGloves.HitWorld"
			break;
		//engineer
		case "Gunslinger":
		case "Wrench":
		case "Southern Hospitality":
		case "Golden Wrench":
		case "Jag":
		case "Eureka Effect":
		case "Festive Wrench":
			return "Weapon_Wrench.HitWorld"
			break;
		//medic
		case "Vita-Saw":
		case "Ubersaw":
		case "Festive Ubersaw":
		case "Amputator":
		case "Bonesaw":
		case "Festive Bonesaw":
			return "Weapon_BoneSaw.HitWorld"
			break;
		case "Solemn Vow":
			return "Weapon_Machete.HitWorld"
			break;
		//sniper
		case "Kukri":
		case "Tribalman's Shiv":
		case "Bushwacka":
		case "Shahanshah":
			return "Weapon_Machete.HitWorld"
			break;
		//spy
		case "Knife":
		case "Your Eternal Reward":
		case "Conniver's Kunai":
		case "Festive Knife":
		case "Black Rose":
		case "Wanga Prick":
		case "Big Earner":
			return "Weapon_Knife.HitWorld"
			break;
		case "Spy-cicle":
			return ""
			break;
		case "Sharp Dresser":
			return "Weapon_Assassin_Knife.HitWorld"
			break;
		default:
			return "Weapon_Bat.HitWorld"
			break;
	}
}

::CTFWeaponBase.GetMeleeSoundHitWorld <- CBaseCombatWeapon.GetMeleeSoundHitWorld

::allow_tf_weapon_Pain_Train <- true;
::allow_tf_weapon_Half_Zatoichi <- true;
::allow_tf_weapon_HamShank <- true;
::allow_tf_weapon_NecroSmasher <- true;
::allow_tf_weapon_Prinny_Machete <- true;
::allow_tf_weapon_Crossing_Guard <- true;
::allow_tf_weapon_Memory_Maker <- true;
::allow_tf_weapon_BatOuttaHell <- true;
::allow_tf_weapon_Conscientious_Objector <- true;
::allow_tf_weapon_Freedom_Staff <- true;
::allow_tf_weapon_Saxxy <- true;
::allow_tf_weapon_Pan <- true;
::allow_tf_weapon_Hurtselfbat <- true;
::allow_tf_weapon_Bat <- true;
::allow_tf_weapon_CandyCane <- true;
::allow_tf_weapon_SunStick <- true;
::allow_tf_weapon_WarFan <- true;
::allow_tf_weapon_Atomizer <- true;
::allow_tf_weapon_Sandman <- true;
::allow_tf_weapon_FishBase <- true;
::allow_tf_weapon_BallBuster <- true;
::allow_tf_weapon_Bonk <- true;
::allow_tf_weapon_critcola <- true;
::allow_tf_weapon_milk <- true;
::allow_tf_weapon_cleaver <- true;
::allow_tf_weapon_MarketGardener <- true;
::allow_tf_weapon_Shovel <- true;
::allow_tf_weapon_EscapePlan <- true;
::allow_tf_weapon_Equalizer <- true;
::allow_tf_weapon_DisciplinaryAction <- true;

::allow_tf_weapon_basejumper <- true;
::allow_tf_weapon_buffbanner <- true;
::allow_tf_weapon_battalionBackup <- true;
::allow_tf_weapon_concheror <- true;

::allow_tf_weapon_Powerjack <- true;
::allow_tf_weapon_Homewrecker  <- true;
::allow_tf_weapon_Axtinguisher <- true;
::allow_tf_weapon_BackScratcher <- true;
::allow_tf_weapon_SVF <- true;
::allow_tf_weapon_Fireaxe <- true;
::allow_tf_weapon_ThirdDegree <- true;
::allow_tf_weapon_NeonAnnihilator <- true;
::allow_tf_weapon_HotHand <- true;
::allow_tf_weapon_GasPasser <- false;

::allow_tf_weapon_Flaregun <- false;
::allow_tf_weapon_detonator <- false;
::allow_tf_weapon_manmelter <- false;
::allow_tf_weapon_scorchshot <- false;

::allow_tf_weapon_Caber <- true;
::allow_tf_weapon_bottle <- true;
::allow_tf_weapon_eyelander <- true;
::allow_tf_weapon_Skullcutter <- true;
::allow_tf_weapon_Persuader <- true;
::allow_tf_weapon_Claidheamh <- true;
::allow_tf_weapon_CharginTarge <- true;
::allow_tf_weapon_SplendidScreen <- true;
::allow_tf_weapon_TideTurner <- true;
::allow_tf_weapon_Fists <- true;
::allow_tf_weapon_FistsOfSteel <- true;
::allow_tf_weapon_EvictionNotice  <- true;
::allow_tf_weapon_GRU  <- true;
::allow_tf_weapon_BearGloves  <- true;
::allow_tf_weapon_ExplodeGloves  <- true;
::allow_tf_weapon_KGB <- true;
::allow_tf_weapon_Sandvich <- true;
::allow_tf_weapon_DalokohsBar <- true;
::allow_tf_weapon_Steak <- true;
::allow_tf_weapon_Banana <- true;

::allow_tf_weapon_gunslinger <- true;
::allow_tf_weapon_southernhospitality <- true;
::allow_tf_weapon_jag <- true;
::allow_tf_weapon_eurekaeffect <- true;
::allow_tf_weapon_wrench <- true;
::allow_tf_weapon_toolbox <- false;
::allow_tf_weapon_constructionpda <- false;
::allow_tf_weapon_destructionpda <- false;


::allow_tf_weapon_vitasaw <- true;
::allow_tf_weapon_ubersaw <- true;
::allow_tf_weapon_amputator <- true;
::allow_tf_weapon_bonesaw <- true;
::allow_tf_weapon_solemnvow <- true;
::allow_tf_weapon_crossbow <- true;
::allow_tf_weapon_kukri <- true;
::allow_tf_weapon_shiv <- true;
::allow_tf_weapon_bushwacka <- true;
::allow_tf_weapon_shahanshah <- true;
::allow_tf_weapon_huntsman <- true;
::allow_tf_weapon_jarate <- false;
::allow_tf_weapon_dangershield <- true;
::allow_tf_weapon_cozycamper <- true;
::allow_tf_weapon_razorback <- true;
::allow_tf_weapon_knife <- true;
::allow_tf_weapon_reward <- true;
::allow_tf_weapon_kunai <- true;
::allow_tf_weapon_bigearner <- true;
::allow_tf_weapon_cicle <- true;
::allow_tf_weapon_spypda <- true;
::allow_tf_weapon_inviswatch <- true;
::allow_tf_weapon_deadringer <- true;
::allow_tf_weapon_cloakanddagger <- true;
::allow_tf_weapon_sapper <- false;
::allow_tf_weapon_grapplinghook <- false;

::CEconEntity.AllowedMeleeWeaponsKatsu <-  function()
{
	local weapon = this;

	switch (weapon.GetWeaponName())
	{
		//all class / multi
		case "Pain Train":
			return allow_tf_weapon_Pain_Train
			break;
		case "Half-Zatoichi":
			return allow_tf_weapon_Half_Zatoichi
			break;
		case "Ham Shank":
			return allow_tf_weapon_HamShank
			break;
		case "Prinny Machete":
			return allow_tf_weapon_Prinny_Machete
			break;
		case "Crossing Guard":
			return allow_tf_weapon_Crossing_Guard
			break;
		case "Necro Smasher":
			return allow_tf_weapon_NecroSmasher
			break;
		case "Memory Maker":
			return allow_tf_weapon_Memory_Maker
			break;
		case "Bat Outta Hell":
			return allow_tf_weapon_BatOuttaHell
			break;
		case "Freedom Staff":
			return allow_tf_weapon_Freedom_Staff
			break;
		case "Conscientious Objector":
			return allow_tf_weapon_Conscientious_Objector
			break;
		case "Saxxy":
			return allow_tf_weapon_Saxxy
			break;
		case "Gold Frying Pan":
		case "Frying Pan":
			return allow_tf_weapon_Pan
			break;
		case "B.A.S.E. Jumper":
			return allow_tf_weapon_basejumper
			break;
		case "Grappling Hook":
			return allow_tf_weapon_grapplinghook
			break;
		//scout
		case "Three-Rune Blade":
		case "Boston Basher":
			return allow_tf_weapon_Hurtselfbat
			break;
		case "Bat":
		case "Festive Bat":
		case "Batsaber":
			return allow_tf_weapon_Bat
			break;
		case "Candy Cane":
			return allow_tf_weapon_CandyCane
			break;
		case "Sun-on-a-Stick":
			return allow_tf_weapon_SunStick
			break;
		case "Fan O'War":
			return allow_tf_weapon_WarFan
			break;
		case "Atomizer":
			return allow_tf_weapon_Atomizer
			break;
		case "Sandman":
			return allow_tf_weapon_Sandman
			break;
		case "Unarmed Combat":
		case "Festive Holy Mackerel":
		case "Holy Mackerel":
			return allow_tf_weapon_FishBase
			break;
		case "Wrap Assassin":
			return allow_tf_weapon_BallBuster
			break;
		//scout drinks/throwables
		case "Festive Bonk!":
		case "Bonk! Atomic Punch":
			return allow_tf_weapon_Bonk
			break;
		case "Crit-a-Cola":
			return allow_tf_weapon_critcola
			break;
		case "Mutated Milk":
		case "Mad Milk":
			return allow_tf_weapon_milk
			break;
		case "Flying Guillotine":
		case "Flying Guillotine (Genuine)":
			return allow_tf_weapon_cleaver
			break;

		//soldier
		case "Market Gardener":
			return allow_tf_weapon_MarketGardener
			break;
		case "Shovel":
			return allow_tf_weapon_Shovel
			break;
		case "Escape Plan":
			return allow_tf_weapon_EscapePlan
			break;
		case "Equalizer":
			return allow_tf_weapon_Equalizer
			break;
		case "Disciplinary Action":
			return allow_tf_weapon_DisciplinaryAction
			break;
		case "Concheror":
			return allow_tf_weapon_concheror
			break;
		case "Buff Banner":
		case "Festive Buff Banner":
			return allow_tf_weapon_buffbanner
			break;
		case "Battalion's Backup":
			return allow_tf_weapon_battalionBackup
			break;
		//pyro
		case "Powerjack":
			return allow_tf_weapon_Powerjack
			break;
		case "Maul":
		case "Homewrecker":
			return allow_tf_weapon_Homewrecker
			break;
		case "Festive Axtinguisher":
		case "Postal Pummeler":
		case "Axtinguisher":
			return allow_tf_weapon_Axtinguisher
			break;
		case "Back Scratcher":
			return allow_tf_weapon_BackScratcher
			break;
		case "Sharpened Volcano Fragment":
			return allow_tf_weapon_SVF
			break;
		case "Fire Axe":
		case "Lollichop":
			return allow_tf_weapon_Fireaxe
			break;
		case "Third Degree":
			return allow_tf_weapon_ThirdDegree
			break;
		case "Neon Annihilator (Genuine)":
		case "Neon Annihilator":
			return allow_tf_weapon_NeonAnnihilator
			break;
		case "Hot Hand":
			return allow_tf_weapon_HotHand
			break;
		case "Gas Passer":
			return allow_tf_weapon_GasPasser
			break;
		case "Flare Gun":
		case "Festive Flare Gun":
			return allow_tf_weapon_Flaregun
			break;
		case "Detonator":
			return allow_tf_weapon_detonator
			break;
		case "Manmelter":
			return allow_tf_weapon_manmelter
			break;
		case "Scorch Shot":
			return allow_tf_weapon_scorchshot
			break;

		//demo
		case "Ullapool Caber":
			return allow_tf_weapon_Caber
			break;
		case "Scottish Handshake":
		case "Bottle":
			return allow_tf_weapon_bottle
			break;
		case "Horseless Headless Horsemann's Headtaker":
		case "Nessie's Nine Iron":
		case "Eyelander":
		case "Festive Eyelander":
			return allow_tf_weapon_eyelander
			break;
		case "Scotsman's Skullcutter":
			return allow_tf_weapon_Skullcutter
			break;
		case "Persian Persuader":
			return allow_tf_weapon_Persuader
			break;
		case "Claidheamh Mòr":
			return allow_tf_weapon_Claidheamh
			break;
			//shields
		case "Festive Targe":
		case "Chargin' Targe":
			return allow_tf_weapon_CharginTarge
			break;
		case "Splendid Screen":
			return allow_tf_weapon_SplendidScreen
			break;
		case "Tide Turner":
			return allow_tf_weapon_TideTurner
			break;

		//heavy
		case "Fists":
		case "Holiday Punch":
			return allow_tf_weapon_Fists
			break;
		case "Fists of Steel":
			return allow_tf_weapon_FistsOfSteel
			break;
		case "Eviction Notice":
			return allow_tf_weapon_EvictionNotice
			break;
		case "Killing Gloves of Boxing":
			return allow_tf_weapon_KGB
			break;
		case "Gloves of Running Urgently":
		case "Festive Gloves of Running Urgently (G.R.U.)":
		case "Bread Bite":
			return allow_tf_weapon_GRU
			break;
		case "Warrior's Spirit":
			return allow_tf_weapon_BearGloves
			break;
		case "Apoco-Fists":
			return allow_tf_weapon_ExplodeGloves
			break;
		case "Sandvich":
		case "Robo-Sandvich":
			return allow_tf_weapon_Sandvich
			break;
		case "Fishcake":
		case "Dalokohs Bar":
			return allow_tf_weapon_DalokohsBar
			break;
		case "Buffalo Steak Sandvich":
			return allow_tf_weapon_Steak
			break;
		case "Second Banana":
			return allow_tf_weapon_Banana
			break;

		//engineer
		case "Gunslinger":
			return allow_tf_weapon_gunslinger
			break;
		case "Southern Hospitality":
			return allow_tf_weapon_southernhospitality
			break;
		case "Jag":
			return allow_tf_weapon_jag
			break;
		case "Eureka Effect":
			return allow_tf_weapon_eurekaeffect
			break;
		case "Golden Wrench":
		case "Wrench":
		case "Festive Wrench":
			return allow_tf_weapon_wrench
			break;
		case "Toolbox":
			return allow_tf_weapon_toolbox
			break;
		case "Construction PDA":
			return allow_tf_weapon_constructionpda
			break;
		case "Destruction PDA":
			return allow_tf_weapon_destructionpda
			break;

		//medic
		case "Vita-Saw":
			return allow_tf_weapon_vitasaw
			break;
		case "Ubersaw":
		case "Festive Ubersaw":
			return allow_tf_weapon_ubersaw
			break;
		case "Amputator":
			return allow_tf_weapon_amputator
			break;
		case "Bonesaw":
		case "Festive Bonesaw":
			return allow_tf_weapon_bonesaw
			break;
		case "Solemn Vow":
			return allow_tf_weapon_solemnvow
			break;
		case "Crusader's Crossbow":
		case "Festive Crusader's Crossbow":
			return allow_tf_weapon_crossbow
			break;

		//sniper
		case "Kukri":
			return allow_tf_weapon_kukri
			break;
		case "Tribalman's Shiv":
			return allow_tf_weapon_shiv
			break;
		case "Bushwacka":
			return allow_tf_weapon_bushwacka
			break;
		case "Shahanshah":
			return allow_tf_weapon_shahanshah
			break;
		case "Huntsman":
		case "Festive Huntsman":
		case "Fortified Compound":
			return allow_tf_weapon_huntsman
			break;
		case "Jarate":
		case "Festive Jarate":
		case "Self-Aware Beauty Mark":
			return allow_tf_weapon_jarate
			break;
		case "Darwin's Danger Shield":
			return allow_tf_weapon_dangershield
			break;
		case "Cozy Camper":
			return allow_tf_weapon_cozycamper
			break;
		case "Razorback":
			return allow_tf_weapon_razorback
			break;

		//spy
		case "Knife":
		case "Festive Knife":
		case "Black Rose":
		case "Sharp Dresser":
			return allow_tf_weapon_knife
			break;
		case "Your Eternal Reward":
		case "Wanga Prick":
			return allow_tf_weapon_reward
			break;
		case "Conniver's Kunai":
			return allow_tf_weapon_kunai
			break;
		case "Big Earner":
			return allow_tf_weapon_bigearner
			break;
		case "Spy-cicle":
			return allow_tf_weapon_cicle
			break;
		case "Disguise Kit PDA":
			return allow_tf_weapon_spypda
			break;
		case "Invis Watch":
		case "Enthusiast's Timepiece":
		case "Quackenbirdt":
			return allow_tf_weapon_inviswatch
			break;
		case "Dead Ringer":
			return allow_tf_weapon_deadringer
			break;
		case "Cloak and Dagger":
			return allow_tf_weapon_cloakanddagger
			break;
		case "Sapper":
		case "Red-Tape Recorder":
		case "Ap-Sap":
		case "Festive Sapper":
		case "Snack Attack":
			return allow_tf_weapon_sapper
			break;
		default:
			return false
			break;
	}
}

::CBaseCombatWeapon.AllowedMeleeWeaponsKatsu <- CEconEntity.AllowedMeleeWeaponsKatsu
::CTFWeaponBase.AllowedMeleeWeaponsKatsu <- CBaseCombatWeapon.AllowedMeleeWeaponsKatsu

::CBaseCombatWeapon.GetCritSwingAnimation <- function()
{
	local weapon = this;
	local owner = weapon.GetOwner()
	local viewmodel = GetPropEntity(owner, "m_hViewModel");

	local ACT_VM = weapon.GetSequenceActivityName(GetPropInt(weapon, "m_nIdealSequence"))
	//printl(ACT_VM)
	if (weapon.GetClassname() == "tf_weapon_wrench")
	{
		return "ACT_ITEM3_VM_SWINGHARD"
	}
	else if (weapon.GetWeaponName() == "Solemn Vow")
	{
		return "ACT_MELEE_ALLCLASS_VM_HITCENTER"
	}
	else if (weapon.GetWeaponName() == "Hot Hand")
	{
		return "ACT_ITEM3_VM_PRIMARYATTACK"
	}
	else
	{
		switch (ACT_VM) {
			case "ACT_VM_HITCENTER":
				return "ACT_VM_SWINGHARD"
				break;
			case "ACT_VM_HITCENTER_SPECIAL":
				return "ACT_VM_SWINGHARD_SPECIAL"
				break;
			case "ACT_VM_HITLEFT":
			case "ACT_VM_HITRIGHT":
			case "ACT_MELEE_VM_HITCENTER":
				return "ACT_MELEE_VM_SWINGHARD"
				break;
			case "ACT_MELEE_ALLCLASS_VM_HITCENTER":
			{
				switch (owner.GetPlayerClassString()) {
					case "demo":
					case "sniper":
						return "ACT_MELEE_ALLCLASS_VM_SWINGHARD"
						break;
					default:
						return "ACT_MELEE_ALLCLASS_VM_HITCENTER"
						break;
				}
				break;
			}
			case "ACT_ITEM1_VM_HITCENTER":
				return "ACT_ITEM1_VM_SWINGHARD"
				break;
			case "ACT_ITEM2_VM_HITCENTER":
				return "ACT_ITEM2_VM_SWINGHARD"
				break;
			case "ACT_ITEM3_VM_HITCENTER":
				return "ACT_ITEM3_VM_SWINGHARD"
				break;
			case "ACT_BREADGLOVES_VM_HITLEFT":
			case "ACT_BREADGLOVES_VM_HITRIGHT":
				return "ACT_BREADGLOVES_VM_SWINGHARD"
				break;
			case "ACT_FISTS_VM_HITLEFT":
			case "ACT_FISTS_VM_HITRIGHT":
				return "ACT_FISTS_VM_SWINGHARD"
				break;
			default:
				return "ACT_MELEE_VM_SWINGHARD"
				break;
		}
	}
}

::CTFWeaponBase.GetCritSwingAnimation <- CBaseCombatWeapon.GetCritSwingAnimation

::CBaseCombatWeapon.GetDesiredBuildingString <- function()
{
	local weapon = this;
	if (weapon.GetClassname() == "tf_weapon_builder")
	{
		switch (GetPropInt(weapon, "m_iObjectType")) {
			case 0:
				return "dispenser"
				break;
			case 1:
				{
					if (GetPropInt(weapon, "m_iObjectMode") == 0)
					{
						return "entrance"
						break;
					}
					else
					{
						return "exit"
						break;
					}
					break;
				}
			case 2:
				return "sentry"
				break;
		}
	}
	else
	{
		return null
	}

}

::CTFWeaponBase.GetDesiredBuildingString <- CBaseCombatWeapon.GetDesiredBuildingString

::CBaseCombatWeapon.GetDesiredBuilding <- function()
{
	local weapon = this;
	if (weapon.GetClassname() == "tf_weapon_builder")
	{
		switch (GetPropInt(weapon, "m_iObjectType"))
		{
			case 0:
				return 0 //"dispenser"
				break;
			case 1:
				{
					if (GetPropInt(weapon, "m_iObjectMode") == 0)
					{
						return 1 //"entrence"
						break;
					}
					else
					{
						return 2 //"exit"
						break;
					}
					break;
				}
			case 2:
				return 3 //sentry
				break;
		}
	}
	else
	{
		return null
	}

}

::CTFWeaponBase.GetDesiredBuilding <- CBaseCombatWeapon.GetDesiredBuilding

::RuneTypeToCond <-
[
	Constants.ETFCond.TF_COND_RUNE_STRENGTH,
	Constants.ETFCond.TF_COND_RUNE_HASTE,
	Constants.ETFCond.TF_COND_RUNE_REGEN,
	Constants.ETFCond.TF_COND_RUNE_RESIST,
	Constants.ETFCond.TF_COND_RUNE_VAMPIRE,
	Constants.ETFCond.TF_COND_RUNE_REFLECT,
	Constants.ETFCond.TF_COND_RUNE_PRECISION,
	Constants.ETFCond.TF_COND_RUNE_AGILITY,
	Constants.ETFCond.TF_COND_RUNE_KNOCKOUT,
	Constants.ETFCond.TF_COND_RUNE_KING,
	Constants.ETFCond.TF_COND_RUNE_PLAGUE,
	Constants.ETFCond.TF_COND_RUNE_SUPERNOVA,
];

::CTFPlayer.GetCarryingRuneType <- function()
{
	local player = this;
	if (player.IsCarryingRune())
	{
		foreach (cond in RuneTypeToCond)
		{
			local player_cond_duration = player.GetCondDuration(cond);
			if (player_cond_duration != 0.0)
			{
				return cond
			}
		}
	}
	else
	{
		return -1
	}
}

::CTFBot.GetCarryingRuneType <- CTFPlayer.GetCarryingRuneType
//*

::CTFPlayer.GetViewmodel <- function()
{
	local player = this;
	return GetPropEntity(player, "m_hViewModel")
}

::CTFBot.GetViewmodel <- CTFPlayer.GetViewmodel

::CTFPlayer.GetPlayerCanAttack <- function()
{
	local player = this;
	local viewmodel = GetPropEntity(player, "m_hViewModel");

	if (!(GetPropFloat(player, "m_Shared.m_flStealthNoAttackExpire") < Time()))
		return false;

	if(player.InCond(TF_COND_STEALTHED))
		return false;

	if(player.InCond(TF_COND_PHASE))
		return false;

	if(GetPropBool(player, "m_Shared.m_bFeignDeathReady"))
		return false;

	if (viewmodel.GetModelName() == "models/weapons/v_models/v_pda_spy.mdl")
		return false;

	if(GetPropInt(player, "m_Shared.m_iStunFlags") & 64)
		return false;

	return true
}

::CTFBot.GetPlayerCanAttack <- CTFPlayer.GetPlayerCanAttack

::CTFPlayer.GetRuneHealthBonus <- function()
{
	local player = this
	local hp = 0
	switch (player.GetCarryingRuneType())
	{
		case 90:
		case 91:
		case 92:
		case 93:
		case 96:
		case 97:
		case 110:
		case 111:
			return hp
			break;
		case 94:
			return 80
			break;
		case 95:
		{
			if(player.InCond(129))
			{
				return 320
				break;
			}
			else
			{
				return 400
				break;
			}
		}
		case 103:
		{
			switch (player.GetPlayerClassString()) {
				case "scout":
				case "sniper":
				case "engineer":
				case "spy":
					return 175
					break;
				case "soldier":
				case "medic":
					return 150
					break;
				case "heavy":
				case "pyro":
					return 150
					break;
				case "demo":
				{
					for (local i = 0; i < MAX_WEAPONS; i++)
					{
						local shieldequipped = false

						for (local wearable = player.FirstMoveChild(); wearable != null; wearable = wearable.NextMovePeer())
						{
							if (wearable.GetClassname() == "tf_wearable_demoshield")
							{
								shieldequipped = true
							}
						}

						local weapon = GetPropEntityArray(player, "m_hMyWeapons", i);
						if (weapon != null)
						{
							if ((weapon.GetClassname() == "tf_weapon_katana") || (GetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex") == 357))
							{
								return 20
								break;
							}
							else if (shieldequipped && !((weapon.GetClassname() == "tf_weapon_katana") || (GetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex") == 357)))
							{
								return 30
								break;
							}
							else
							{
								return 150
								break;
							}
						}
					}
				}
			}
			break;
		}
		case 109:
		{
			if(player.InCond(129))
			{
				return 20
				break;
			}
			else
			{
				return 100
				break;
			}
		}
		default:
			return hp
			break;
	}
}

::CTFBot.GetRuneHealthBonus <- CTFPlayer.GetRuneHealthBonus

::CTFPlayer.MaxCarry <- function( nAmmoIndex)
{
	local pPlayer = this

	if ( nAmmoIndex < 1 || nAmmoIndex >= 7 )
		return 0;

	//printl(pPlayer.GetActiveWeapon().GetPrimaryAmmoType())

	for (local i = 0; i < MAX_WEAPONS; i++)
	{
		local weapon = GetPropEntityArray(pPlayer, "m_hMyWeapons", i);
		if (weapon != null)
		{
			if (weapon.GetPrimaryAmmoType() == nAmmoIndex)
			{
				return pPlayer.GetMaxReserveAmmo(weapon)
				break;
			}
		}
	}
}

::CTFBot.MaxCarry <- CTFPlayer.MaxCarry

::CTFPlayer.GetDisguiseMaxHealth <- function()
{
	local pPlayer = this
	if ((GetPropEntity(pPlayer, "m_Shared.m_hDisguiseTarget") == null) || (GetPropEntity(pPlayer, "m_Shared.m_hDisguiseTarget") == pPlayer))
	{
		switch (GetPropInt(pPlayer, "m_Shared.m_nDisguiseClass")) {
			case TF_PLAYERCLASS_SCOUT:
			case TF_PLAYERCLASS_SNIPER:
			case TF_PLAYERCLASS_ENGINEER:
			case TF_PLAYERCLASS_SPY:
				return 125
				break;
			case TF_PLAYERCLASS_MEDIC:
				return 150
				break;
			case TF_PLAYERCLASS_PYRO:
			case TF_PLAYERCLASS_DEMOMAN:
				return 175
				break;
			case TF_PLAYERCLASS_SOLDIER:
				return 200
				break;
			case TF_PLAYERCLASS_HEAVY:
				return 300
				break;
			default:
				return 125
				break;
		}
	}
	else
	{
		return GetPropEntity(pPlayer, "m_Shared.m_hDisguiseTarget").GetMaxHealth()
	}
}

::CTFBot.GetDisguiseMaxHealth <- CTFPlayer.GetDisguiseMaxHealth

::CTFPlayer.GetObserverMode <- function()
{
	local player = this
	if(player.IsFakeClient())
	{
		return 6
	}
	else
	{
		return Convars.GetClientConvarValue("cl_spec_mode", player.entindex())
	}
}

::CTFBot.GetObserverMode <- CTFPlayer.GetObserverMode


::FlashBangBlackScreenArray <-
[
	false, // dummy value
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
	false,
]

::CTFPlayer.ResetScriptOverlay <- function()
{
	local player = this
	player.SetScriptOverlayMaterial("")
}

::CTFBot.ResetScriptOverlay <- CTFPlayer.ResetScriptOverlay

::CTFPlayer.Blind <- function(holdTime, fadeTime, startingAlpha )
{
	local player = this
	// Don't flash a spectator.
	//printl(player.entindex())

	local clr = Quaternion(255, 255, 255, 255);

	if (FlashBangBlackScreenArray[player.entindex()] == true)
	{
		if (RandomChance(10, 0, 100))
		{
			player.SetScriptOverlayMaterial("models/props_halloween/luigijumpscare")
		}
		clr.x = 0;
		clr.y = 0;
		clr.z = 0;
	}

    //Quaternion(float x, float y, float z, float w)
	clr.w = startingAlpha;

    local m_flFlashMaxAlpha = startingAlpha
    local m_flFlashDuration = fadeTime
	local m_blindUntilTime = max( Time(), Time() + holdTime + 0.5 * fadeTime );

	fadeTime /= 1.4;

	// The previous flashbang is still going strong - only extend the duration
	local  remainingDuration = m_flFlashDuration - Time();

	local flNewDuration = max( remainingDuration, fadeTime );

	// The flashbang client effect runs off a network var change callback... Make sure the bits for duration get
	// sent by changing it a tiny bit whenever these end up being equal.
	if ( m_flFlashDuration == flNewDuration )
		flNewDuration += 0.01;

	m_flFlashDuration = flNewDuration;
	m_flFlashMaxAlpha = max( m_flFlashMaxAlpha, startingAlpha );
	//printl("player: " + player.GetPlayerName() + " m_flFlashMaxAlpha:" + m_flFlashMaxAlpha)
	//printl("player: " + player.GetPlayerName() + " m_flFlashDuration:" + m_flFlashDuration)
	EntFireByHandle(player, "runscriptcode", "activator.ResetScriptOverlay()", m_flFlashDuration * 0.5, player, player)
	player.AcceptInput("SpeakResponseConcept", "TLK_JARATE_HIT", null,null)
    ScreenFade(player, clr.x, clr.y, clr.z, m_flFlashMaxAlpha, m_flFlashDuration, holdTime, 1 + 16)

}

::CTFBot.Blind <- CTFPlayer.Blind

::CTFPlayer.Deafen <- function(flDistance)
{
	local player = this // Spectators don't get deafened
	if ( !(player.GetObserverMode() == OBS_MODE_NONE )  ||  (player.GetObserverMode() == OBS_MODE_IN_EYE ) )
	{
		// dsp presets are defined in hl2/scripts/dsp_presets.txt

		if( flDistance < 100 )
		{
			player.SetClientConvar("dsp_player " + 32)
			return
		}
		else if( flDistance < 500 )
		{
			player.SetClientConvar("dsp_player " + 33)
			return
		}
		else if( flDistance < 1000 )
		{
			player.SetClientConvar("dsp_player " + 34)
			return
		}
		else
		{
			// too far for us to get an effect
			return;
		}

		//TODO: bots can't hear sound for a while?
	}
}

::CTFBot.Deafen <- CTFPlayer.Deafen

::CTFPlayer.TakeHealth <- function( flHealth, bitsDamageType )
{
	local player = this
	if (GetPropEntity(player, "m_takedamage") == 0)
		return 0;

	local m_iMaxHealth = player.GetMaxHealth();
	local m_iHealth = player.GetHealth()

	if ( m_iHealth == m_iMaxHealth )
		return 0;

	// Heal the location
	local flAmountToHeal = flHealth;
	if ( flAmountToHeal > (m_iMaxHealth - m_iHealth) )
		flAmountToHeal = (m_iMaxHealth - m_iHealth);
	m_iHealth += flAmountToHeal;

	player.SetHealth(m_iHealth)
	//Msg( "Health: %d\n", m_iHealth );

	return flAmountToHeal;
}

::CTFBot.TakeHealth <- CTFPlayer.TakeHealth

::CTFPlayer.SetClientConvar <- function(output)
{
	local player = this
	local _clientcom = Entities.CreateByClassname("point_clientcommand");
	_clientcom.AcceptInput("command", output, player, player)
    _clientcom.Destroy()
}

::CTFBot.SetClientConvar <- CTFPlayer.SetClientConvar
//*/
::CTFPlayer.GiveAmmo <- function( iCount, iAmmoIndex, bSuppressSound)
{
	local pPlayer = this

	if (iCount <= 0)
		return 0;

	if (true == false) //CanHaveAmmo( this, iAmmoIndex ) )
	{
		// game rules say I can't have any more of this ammo type.
		return 0;
	}

	if ( iAmmoIndex < 0 || iAmmoIndex >= MAX_AMMO_SLOTS )
		return 0;
	local m_iAmmo = GetPropIntArray(pPlayer, "m_iAmmo", iAmmoIndex)

	//printl(pPlayer.MaxCarry(iAmmoIndex))

	local iMax = pPlayer.MaxCarry(iAmmoIndex);
	local iAdd = min( iCount, iMax - m_iAmmo );
	if ( iAdd < 1 )
		return 0;

	// Ammo pickup sound
	if ( !bSuppressSound )
	{
		EmitSound( "BaseCombatCharacter.AmmoPickup" );
	}

	SetPropIntArray(pPlayer, "m_iAmmo", m_iAmmo + iAdd, iAmmoIndex);

	return iAdd;

}

::CTFBot.GiveAmmo <- CTFPlayer.GiveAmmo

::CTFPlayer.IsAlive <- function()
{
	local player = this;
	return GetPropInt(player, "m_lifeState") == 0;
}

::CTFBot.IsAlive <- CTFPlayer.IsAlive

::CTFPlayer.GetPlayerName <- function()
{
	local player = this;
    return GetPropString(player, "m_szNetname");
}

::CTFBot.GetPlayerName <- CTFPlayer.GetPlayerName

::CTFPlayer.GetPlayerSteamID <- function()
{
	local player = this;
    return GetPropString(player, "m_szNetworkIDString");
}

::CTFBot.GetPlayerSteamID <- CTFPlayer.GetPlayerSteamID

::CTFPlayer.GetPlayerUserID <- function()
{
	local player = this;
    return GetPropIntArray(tf_player_manager, "m_iUserID", player.entindex());
}

::CTFBot.GetPlayerUserID <- CTFPlayer.GetPlayerUserID


::CTFPlayer.GetWeaponClassname <- function()
{
	local player = this;
	if (player.GetActiveWeapon() != null)
	{
		return player.GetActiveWeapon().GetClassname()
	}
	else
	{
		return ""
	}
}

::CTFBot.GetWeaponClassname <- CTFPlayer.GetWeaponClassname

::CTFPlayer.GetMaxReserveAmmo <- function(weapon)
{
	local player = this
	if (weapon == "metal")
	{
		return 200
	}

	switch (GetPropInt(weapon, "m_iWorldModelIndex"))
	{
		case GetModelIndex("models/weapons/c_models/c_shotgun/c_shotgun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_reserve_shooter/c_reserve_shooter.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_reserve_shooter/c_reserve_shooter.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_trenchgun/c_trenchgun.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_russian_riot/c_russian_riot.mdl"):
		case GetModelIndex("models/weapons/c_models/c_russian_riot/c_russian_riot.mdl"):
		case GetModelIndex("models/weapons/c_models/c_scatterdrum/c_scatterdrum.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_scatterdrum/c_scatterdrum.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_pep_scattergun/c_pep_scattergun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_pep_scattergun/c_pep_scattergun.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_soda_popper/c_soda_popper.mdl"):
		case GetModelIndex("models/weapons/c_models/c_soda_popper/c_soda_popper.mdl"):
		case GetModelIndex("models/weapons/c_models/c_scattergun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_double_barrel.mdl"):
		case GetModelIndex("models/weapons/c_models/c_frontierjustice/c_frontierjustice_xmas.mdl"):
		case GetModelIndex("models/weapons/c_models/c_frontierjustice/c_frontierjustice.mdl"):
		case GetModelIndex("models/weapons/c_models/c_shortstop/c_shortstop.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_shortstop/c_shortstop.mdl"):
			return 32
			break;
		case GetModelIndex("models/weapons/c_models/c_pistol/c_pistol.mdl"):
		case GetModelIndex("models/weapons/c_models/c_ttg_max_gun/c_ttg_max_gun.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_ttg_max_gun/c_ttg_max_gun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_winger_pistol/c_winger_pistol.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_winger_pistol/c_winger_pistol.mdl"):
		case GetModelIndex("models/weapons/c_models/c_pep_pistol/c_pep_pistol.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_pep_pistol/c_pep_pistol.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_invasion_pistol/c_invasion_pistol.mdl"):
		{
			if (player.GetPlayerClassString() == "scout")
			{
				return 36
				break;
			}

			return 200
			break;
		}
		//------- miniguns
		case GetModelIndex("models/weapons/c_models/c_minigun/c_minigun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_minigun/c_minigun_natascha.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_iron_curtain/c_iron_curtain.mdl"):
		case GetModelIndex("models/weapons/c_models/c_iron_curtain/c_iron_curtain.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_gatling_gun/c_gatling_gun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_gatling_gun/c_gatling_gun.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_tomislav/c_tomislav.mdl"):
		case GetModelIndex("models/weapons/c_models/c_tomislav/c_tomislav.mdl"):
		case GetModelIndex("models/workshop_partner/weapons/c_models/c_canton/c_canton.mdl"):
		case GetModelIndex("models/weapons/c_models/c_canton/c_canton.mdl"):
		//------- wido
		case GetModelIndex("models/workshop_partner/weapons/c_models/c_dex_shotgun/c_dex_shotgun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_dex_shotgun/c_dex_shotgun.mdl"):
		//------- flamethrowers
		case GetModelIndex("models/weapons/c_models/c_flameball/c_flameball.mdl"):
		case GetModelIndex("models/weapons/c_models/c_flamethrower/c_backburner.mdl"):
		case GetModelIndex("models/weapons/c_models/c_flamethrower/c_backburner_xmas.mdl"):
		case GetModelIndex("models/weapons/c_models/c_flamethrower/c_flamethrower.mdl"):
		case GetModelIndex("models/workshop_partner/weapons/c_models/c_ai_flamethrower/c_ai_flamethrower.mdl"):
		case GetModelIndex("models/weapons/c_models/c_drg_phlogistinator/c_drg_phlogistinator.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_drg_phlogistinator/c_drg_phlogistinator.mdl"):
		case GetModelIndex("models/weapons/c_models/c_degreaser/c_degreaser.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_degreaser/c_degreaser.mdl"):
		case GetModelIndex("models/weapons/c_models/c_rainblower/c_rainblower.mdl"):
			return 200
			break;
		case GetModelIndex("models/weapons/c_models/c_sniperrifle/c_sniperrifle.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_sydney_sleeper/c_sydney_sleeper.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_bazaar_sniper/c_bazaar_sniper.mdl"):
		case GetModelIndex("models/weapons/c_models/c_bazaar_sniper/c_bazaar_sniper.mdl"):
		case GetModelIndex("models/workshop_partner/weapons/c_models/c_dex_sniperrifle/c_dex_sniperrifle.mdl"):
		case GetModelIndex("models/weapons/c_models/c_dex_sniperrifle/c_dex_sniperrifle.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_invasion_sniperrifle/c_invasion_sniperrifle.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_pro_rifle/c_pro_rifle.mdl"):
		case GetModelIndex("models/weapons/c_models/c_pro_rifle/c_pro_rifle.mdl"):
		case GetModelIndex("models/weapons/c_models/c_csgo_awp/c_csgo_awp.mdl"):
		case GetModelIndex("models/weapons/c_models/c_tfc_sniperrifle/c_tfc_sniperrifle.mdl"):
			return 25
			break;
		case GetModelIndex("models/weapons/c_models/c_smg/c_smg.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_pro_smg/c_pro_smg.mdl"):
		case GetModelIndex("models/weapons/c_models/c_pro_smg/c_pro_smg.mdl"):
			return 75
			break;
		case GetModelIndex("models/weapons/c_models/c_revolver/c_revolver_xmas.mdl"):
		case GetModelIndex("models/weapons/c_models/c_revolver/c_revolver.mdl"):
		case GetModelIndex("models/weapons/c_models/c_ambassador/c_ambassador_xmas.mdl"):
		case GetModelIndex("models/weapons/c_models/c_ambassador/c_ambassador.mdl"):
		case GetModelIndex("models/weapons/c_models/c_ttg_sam_gun/c_ttg_sam_gun.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_ttg_sam_gun/c_ttg_sam_gun.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_letranger/c_letranger.mdl"):
		case GetModelIndex("models/weapons/c_models/c_letranger/c_letranger.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_snub_nose/c_snub_nose.mdl"):
		case GetModelIndex("models/weapons/c_models/c_snub_nose/c_snub_nose.mdl"):
		case GetModelIndex("models/workshop_partner/weapons/c_models/c_dex_revolver/c_dex_revolver.mdl"):
		case GetModelIndex("models/weapons/c_models/c_dex_revolver/c_dex_revolver.mdl"):
		case GetModelIndex("models/weapons/c_models/c_stickybomb_launcher.mdl"):
		case GetModelIndex("models/weapons/c_models/c_stickybomb_launcher/c_stickybomb_launcher.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_kingmaker_sticky/c_kingmaker_sticky.mdl"):
			return 24
			break;
		case GetModelIndex("models/weapons/c_models/c_scottish_resistance.mdl"):
		case GetModelIndex("models/weapons/c_models/c_scottish_resistance/c_scottish_resistance.mdl"):
			return 36
			break;
		case GetModelIndex("models/weapons/c_models/c_sticky_jumper/c_sticky_jumper.mdl"):
			return 72
			break;
		case GetModelIndex("models/workshop_partner/weapons/c_models/c_sd_cleaver/c_sd_cleaver.mdl"):
		case GetModelIndex("models/weapons/c_models/c_madmilk/c_madmilk.mdl"):
		case GetModelIndex("models/weapons/c_models/c_breadmonster/c_breadmonster_milk.mdl"):
		case GetModelIndex("models/weapons/c_models/c_energy_drink/c_energy_drink.mdl"):
		case GetModelIndex("models/weapons/c_models/c_gascan/c_gascan.mdl"):
		case GetModelIndex("models/weapons/c_models/c_sandwich/c_robo_sandwich.mdl"):
		case GetModelIndex("models/weapons/c_models/c_sandwich/c_sandwich.mdl"):
		case GetModelIndex("models/weapons/c_models/c_sandwich/c_sandwich_xmas.mdl"):
		case GetModelIndex("models/weapons/c_models/c_fishcake/c_fishcake.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_fishcake/c_fishcake.mdl"):
		case GetModelIndex("models/weapons/c_models/c_buffalo_steak/c_buffalo_steak.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_buffalo_steak/c_buffalo_steak.mdl"):
		case GetModelIndex("models/weapons/c_models/c_banana/c_banana.mdl"):
		case GetModelIndex("models/weapons/c_models/c_chocolate/c_chocolate.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_chocolate/c_chocolate.mdl"):
			return 1
			break;
		case GetModelIndex("models/weapons/c_models/c_rocketlauncher/c_rocketlauncher.mdl"):
		case GetModelIndex("models/weapons/c_models/c_rocketjumper/c_rocketjumper.mdl"):
		case GetModelIndex("models/weapons/c_models/c_bet_rocketlauncher/c_bet_rocketlauncher.mdl"):
		case GetModelIndex("models/workshop_partner/weapons/c_models/c_bet_rocketlauncher/c_bet_rocketlauncher.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_blackbox/c_blackbox.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_blackbox/c_blackbox_xmas.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_atom_launcher/c_atom_launcher.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_liberty_launcher/c_liberty_launcher.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_dumpster_device/c_dumpster_device.mdl"):
		case GetModelIndex("models/weapons/c_models/c_directhit/c_directhit.mdl"):
			return 20
			break;
		case GetModelIndex("models/weapons/c_models/c_rocketjumper/c_rocketjumper.mdl"):
			return 60
			break;
		case GetModelIndex("models/weapons/c_models/c_flaregun_pyro/c_flaregun_pyro.mdl"):
		case GetModelIndex("models/weapons/c_models/c_xms_flaregun/c_xms_flaregun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_scorch_shot/c_scorch_shot.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_scorch_shot/c_scorch_shot.mdl"):
		case GetModelIndex("models/weapons/c_models/c_detonator/c_detonator.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_detonator/c_detonator.mdl"):
		//------- grenadelauncher
		case GetModelIndex("models/weapons/c_models/c_demo_cannon/c_demo_cannon.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_demo_cannon/c_demo_cannon.mdl"):
		case GetModelIndex("models/weapons/c_models/c_grenadelauncher/c_grenadelauncher.mdl"):
		case GetModelIndex("models/weapons/c_models/c_grenadelauncher/c_grenadelauncher_xmas.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_quadball/c_quadball.mdl"):
		case GetModelIndex("models/weapons/c_models/c_lochnload/c_lochnload.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_lochnload/c_lochnload.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_tele_shotgun/c_tele_shotgun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_tele_shotgun/c_tele_shotgun.mdl"):
			return 16
			break;
		case GetModelIndex("models/weapons/c_models/c_proto_syringegun/c_proto_syringegun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_syringegun/c_syringegun.mdl"):
		case GetModelIndex("models/weapons/c_models/c_leechgun/c_leechgun.mdl"):
			return 150
			break;
		case GetModelIndex("models/workshop/weapons/c_models/c_crusaders_crossbow/c_crusaders_crossbow_xmas.mdl"):
		case GetModelIndex("models/weapons/c_models/c_crusaders_crossbow/c_crusaders_crossbow_xmas.mdl"):
		case GetModelIndex("models/workshop/weapons/c_models/c_crusaders_crossbow/c_crusaders_crossbow.mdl"):
		case GetModelIndex("models/weapons/c_models/c_crusaders_crossbow/c_crusaders_crossbow.mdl"):
			return 38
			break;
		case GetModelIndex("models/workshop_partner/weapons/c_models/c_bow_thief/c_bow_thief.mdl"):
		case GetModelIndex("models/weapons/c_models/c_bow/c_bow_thief.mdl"):
		case GetModelIndex("models/weapons/c_models/c_bow/c_bow.mdl"):
		case GetModelIndex("models/weapons/c_models/c_bow/c_bow_xmas.mdl"):
			return 12
			break;

		default:
			return 0
			break;
	}
}

::CTFBot.GetWeaponClassname <- CTFPlayer.GetWeaponClassname

::DamagePrint <- function(params)
{
	printl("OnScriptHook_OnTakeDamage")
    printl("----------------------------------------------------------------------")
    printl("const_entity: " + params.const_entity)
    printl("inflictor: " + params.inflictor)
    printl("weapon: " + params.weapon)
    printl("attacker: " + params.attacker)
    printl("damage: " + params.damage)
    printl("max_damage: " + params.max_damage)
    printl("damage_bonus: " + params.damage_bonus)
    printl("damage_bonus_provider: " + params.damage_bonus_provider)
    printl("const_base_damage: " + params.const_base_damage)
    printl("damage_force: " + params.damage_force)
    printl("damage_for_force_calc: " + params.damage_for_force_calc)
    printl("damage_position: " + params.damage_position)
    printl("reported_position: " + params.reported_position)
    printl("damage_type: " + params.damage_type)
    printl("damage_custom: " + params.damage_custom)
    printl("damage_stats: " + params.damage_stats)
    printl("force_friendly_fire: " + params.force_friendly_fire)
    printl("ammo_type: " + params.ammo_type)
    printl("player_penetration_count: " + params.player_penetration_count)
    printl("damaged_other_players: " + params.damaged_other_players)
    printl("crit_type: " + params.crit_type)
    printl("early_out: " + params.early_out)
    printl("----------------------------------------------------------------------")
}

::DamagePrint2 <- function(params)
{
	//DamagePrint(params)
	printl("seperate damagetype: ")
	local MaxDamageTypes = 30
	for (local i = 1; i <= MaxDamageTypes ; i++)
	{
		local damagetype = 1 << i
		if((params.damage_type & damagetype) == damagetype)
		{
			print(damagetype + ", ")
		}
	}
	printl("full damagetype: " + params.damage_type)
	printl("full customdamge: " + params.damage_custom)
}

::DamagePrint3 <- function(value)
{
	if(value == 0)
    {
        printl("DMG_GENERIC")
        return
    }
    local damagetypestring = ""
    //damage types that have been redefined in tf2 (valve reused DMG_IGNITE for DMG_FROM_OTHER_SAPPER)
    local redefineddamagetypes = {
    [DMG_RADIATION] = "DMG_HALF_FALLOFF",
    [DMG_AIRBOAT] = "DMG_USE_HITLOCATIONS",
    [DMG_ACID] = "DMG_CRITICAL",
    [DMG_ENERGYBEAM] = "DMG_RADIUS_MAX",
    [DMG_PLASMA] = "DMG_IGNITE or DMG_FROM_OTHER_SAPPER",
    [DMG_SLOWBURN] = "DMG_USEDISTANCEMOD",
    [DMG_POISON] = "DMG_NOCLOSEDISTANCEMOD",
    [DMG_BLAST_SURFACE] = "DMG_MELEE",
    [DMG_DISSOLVE] = "DMG_DONT_COUNT_DAMAGE_TOWARDS_CRIT_RATE"
    }


    foreach(k,v in Constants.FDmgType)
    {
        if(v && v & value)
        {
            local tempstring = ""
            if(damagetypestring != "") tempstring += "| "
            tempstring += k + " "
            if(v in redefineddamagetypes) tempstring += format("(%s)",redefineddamagetypes[v])
            damagetypestring += tempstring
        }
    }
    printl(damagetypestring)
}

::GetClosestTarget <-  function(entity, owner, ignore = null)
{
	local table = {
		TargetDistance = 0.0,
		ClosestTarget = null
	};

	for (local i = 1; i <= MaxPlayers ; i++)
    {
		local player = PlayerInstanceFromIndex(i)

		if (!(GetPropInt(player, "m_lifeState") == 0) || (player == owner) || (ignore == player) || (player.GetTeam() == owner.GetTeam())) continue;

		local EntityLocation = GetPropVector(entity, "m_vecAbsOrigin");
		local TargetLocation = player.GetOrigin()

		local distance = Distance3D(EntityLocation, TargetLocation);
		if(table.TargetDistance)
		{
			if(distance < table.TargetDistance)
			{
				table.ClosestTarget = player;
				table.TargetDistance = distance;
			}
		}
		else
		{
			table.ClosestTarget = player;
			table.TargetDistance = distance;
		}

	}
	return table;
}

::SetHomingProjectile <-  function(rocket, delay, m_bLimitRedirect = false, m_iMaxRedirectNum = 1, m_flRedirectDelay =  0.25)
{
	local m_hOwner = GetPropEntity(rocket, "m_hOwnerEntity");
	if (!m_hOwner)
	{
		m_hOwner = GetPropEntity(rocket, "m_hThrower");
	}

	if( rocket.ValidateScriptScope() )
	{
		local rocketscope = rocket.GetScriptScope();
		rocketscope.m_flHomingWait <- Time() + delay;
		rocketscope.m_iRedirectNum <- 0;
		rocketscope.m_hOwner <- m_hOwner;
		rocketscope["HomingRocket_Think"] <- function()	//Our script's name under the weapon scope.
		{

			if(!m_hOwner.IsValid())
				return -1

			local ClosestTargettable = GetClosestTarget(self, m_hOwner);
			local target = ClosestTargettable.ClosestTarget
			local distance = ClosestTargettable.TargetDistance

			if ((target == null) || (!target.IsValid()))
				return -1

			if(m_flHomingWait < Time())
			{
				if(m_hOwner && target)
				{
					if(m_bLimitRedirect)
					{
						if (m_iRedirectNum == m_iMaxRedirectNum)
						{
							m_flHomingWait = Time() + 8888
						}
						else
						{
							m_iRedirectNum++
							m_flHomingWait = Time() + m_flRedirectDelay
						}
					}

					local RocketPos = self.GetOrigin()
					local TargetPos = target.GetCenter()
					local Velocity = self.GetAbsVelocity()
					local Speed = Velocity.Length()

					local Direction = TargetPos - RocketPos
					Direction.Norm()

					self.SetAbsVelocity(Direction * Speed)
					self.SetForwardVector(Direction)
				}

			}

			return -1
		}

		AddThinkToEnt(rocket, "HomingRocket_Think")	//After all that's said an done, this adds the think script to handle 'weapon' after it has been validated.
	}
}

::RomeVision <- function(player)
{
    player.AddCustomAttribute("vision opt in flags", 4, -1)
    player.AddCustomAttribute("always_transmit_so", 1, -1)
    //printl("Player: "+ player.GetPlayerName() + " Is Team: " + player.GetPlayerTeamString())
}

::CTFPlayer.ChangeHPBaseOnItem <- function()
{
	local player = this;
	local hp = player.GetMaxHealth()
	local weapon = GetPropEntityArray(player, "m_hMyWeapons", 1);

	if (player.GetPlayerClassString() == "soldier")
	{
		if ((weapon.GetClassname() == "tf_weapon_buff_item") && (GetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex") == 226))
		{
			hp = player.GetMaxHealth() - 20
		}
		else
		{
			hp = player.GetMaxHealth()
		}
	}
	else if(player.GetPlayerClassString() == "demo")
	{
		if (player.GetMaxHealth() != 175)
		{
			hp = 175
		}
	}

	return hp
}

::CTFBot.ChangeHPBaseOnItem <- CTFPlayer.ChangeHPBaseOnItem

::HealthReset <- function(player)
{
    player.SetHealth(player.GetMaxHealth())
    player.StopSound("MVM.GiantScoutLoop")
    player.StopSound("MVM.GiantSoldierLoop")
    player.StopSound("MVM.GiantDemomanLoop")
    player.StopSound("MVM.GiantHeavyLoop")
    player.StopSound("MVM.GiantPyroLoop")
	SetPropString(player, "m_iName", "")
	player.RemoveCustomAttribute("max health additive bonus");
    player.RemoveCustomAttribute("health regen")
    player.RemoveCustomAttribute("backstab shield")
	player.Regenerate(true)
	local weapon = GetPropEntityArray(player, "m_hMyWeapons", 1);
	if (weapon != null)
	{
		if (weapon.GetClassname() != "tf_wearable_demoshield")
		{
			SetPropBool(player, "m_Shared.m_bShieldEquipped", false);
		}
	}
}

::CTFPlayer.GetPlayerClassString <- function()
{
	local player = this;
	return TF_CLASS_NAMES[player.GetPlayerClass()]
}

::CTFBot.GetPlayerClassString <- CTFPlayer.GetPlayerClassString

::CTFPlayer.GetPlayerTeamString <- function()
{
	local player = this;
	return TF_TEAM_NAMES[player.GetTeam()]
}

::CTFBot.GetPlayerTeamString <- CTFPlayer.GetPlayerTeamString

::CTFPlayer.IsDucking <- function()
{
	local player = this;
	return player.GetFlags() & FL_DUCKING
}

::CTFBot.IsDucking <- CTFPlayer.IsDucking

::CTFPlayer.GivePlayerWeapon <-  function(className, itemID, stats_function_Override=null)
{
	local player = this;
	local wearable = false

	if (className.slice(0, 11) == "tf_wearable")
	{
		wearable = true
	}

	if(!wearable)
	{
		//lets correct the classname....
		if (className == "tf_weapon_shotgun")
		{
			if (player.GetPlayerClass() == TF_PLAYERCLASS_HEAVY)
			{
				className = "tf_weapon_shotgun_hwg"
			}
			else if (player.GetPlayerClass() == TF_PLAYERCLASS_SOLDIER)
			{
				className = "tf_weapon_shotgun_soldier"
			}
			else if (player.GetPlayerClass() == TF_PLAYERCLASS_PYRO)
			{
				className = "tf_weapon_shotgun_pyro"
			}
			else if (player.GetPlayerClass() == TF_PLAYERCLASS_ENGINEER)
			{
				className = "tf_weapon_shotgun_primary"
			}
		}

		local weapon = Entities.CreateByClassname(className);

		SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemID);
		SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true);
		SetPropBool(weapon, "m_bValidatedAttachedEntity", true);
		weapon.SetTeam(player.GetTeam());
		Entities.DispatchSpawn(weapon);

		// remove existing weapon in same slot
		for (local i = 0; i < MAX_WEAPONS; i++)
		{
			local heldWeapon = GetPropEntityArray(player, "m_hMyWeapons", i);
			if (heldWeapon == null)
				continue;
			if (heldWeapon.GetSlot() != weapon.GetSlot())
				continue;
			heldWeapon.Destroy();
			SetPropEntityArray(player, "m_hMyWeapons", null, i);
			break;
		}

		if (stats_function_Override ) {
			stats_function_Override(weapon, player);
			weapon.ReapplyProvision();
		}

		player.Weapon_Equip(weapon);
		player.Weapon_Switch(weapon);

		return weapon;
	}
	else
	{
		local hWearable = Entities.CreateByClassname(className);

	// our properties. Taken from source code for Super Zombie Fortress + SCP Secret Fortress
		hWearable.SetAbsOrigin(player.GetLocalOrigin());
		hWearable.SetAbsAngles(player.GetLocalAngles());
		SetPropInt(hWearable, "m_iTeamNum", player.GetTeam());
		SetPropInt(hWearable, "m_Collision.m_usSolidFlags", Constants.FSolid.FSOLID_NOT_SOLID);
		SetPropInt(hWearable, "m_CollisionGroup", 11);
		SetPropInt(hWearable, "m_fEffects", 129);	//1 and 128 bitmasks both bone merge to player model

		SetPropInt(hWearable, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", itemID);
		//SetPropInt(hWearable, "m_nModelIndex", item_modelindex)

		//SetPropInt(hWearable, "m_AttributeManager.m_Item.m_iEntityQuality", 0);	//doesn't work due to vscript security reasons
		SetPropInt(hWearable, "m_AttributeManager.m_Item.m_iEntityLevel", 1);

		SetPropBool(hWearable, "m_bValidatedAttachedEntity", true);
		SetPropBool(hWearable, "m_AttributeManager.m_Item.m_bInitialized", true)
		SetPropBool(hWearable, "m_AttributeManager.m_Item.m_bOnlyIterateItemViewAttributes", false);

		SetPropEntity(hWearable, "m_hOwnerEntity", player);
		hWearable.SetOwner(player);

	//Dispatch Spawn && stats reapply
		Entities.DispatchSpawn(hWearable);	//Spawns ent into world
		hWearable.ReapplyProvision();		//reapplies any attributes from weapon onto the player

		DoEntFire("!self", "SetParent", "!activator", 0, player, hWearable);

		return hWearable;
	}
}

::CTFBot.GivePlayerWeapon <- CTFPlayer.GivePlayerWeapon

::PercentageOfFlashForPlayer <- function(player, flashPos, pevInflictor)
{
	if (!(player.IsPlayer()))
	{
		// if this entity isn't a player, it's a hostage or some other entity, then don't bother with the expensive checks
		// that come below.
		return 0.0;
	}
	local pos = player.EyePosition();

	local FLASH_FRACTION = 0.167;
	local SIDE_OFFSET = 75.0;

	local flashPosNew = flashPos + Vector(0, 0, 4)

	//DebugDrawLine(flashPosNew, pos, 0, 0, 255, false, 10.0)

	local retval = 0.0;
	local trace =
	{
		start = flashPosNew,
		end = pos,
		mask = CONTENTS_SOLID|CONTENTS_MOVEABLE|CONTENTS_WINDOW|CONTENTS_DEBRIS,
	}

	TraceLineEx(trace)
	// visualize the trace
	//DebugDrawLine(trace.startpos, trace.endpos, 0, 255, 0, false, 10.0)

	if ((trace.fraction == 1.0) || (trace.enthit == player))
	{
		retval += FLASH_FRACTION;
	}

	return retval;
}

::RadiusFlash <- function(vecSrc, pevInflictor, pevAttacker, flDamage, iClassIgnore, bitsDamageType, pOutNumOpponentsEffected = NULL, pOutNumTeammatesEffected = NULL )
{
	vecSrc.z += 1;// in case grenade is lying on the ground

	if ( !pevAttacker )
		pevAttacker = pevInflictor;

	if ( pOutNumOpponentsEffected )
		pOutNumOpponentsEffected = 0;

	if ( pOutNumTeammatesEffected )
		pOutNumTeammatesEffected = 0;

	local tr = {};
	local flAdjustedDamage = 0.0;
	local var;
	local vecEyePos = Vector();
	local fadeTime = 0.0;
    local fadeHold = 0.0;
	local vForward = Vector();
	local vecLOS = Vector();
	local flDot = 0.0;

	local pEntity = NULL;
	local flRadius = 3000;
	local falloff = flDamage / flRadius;

	//bool bInWater = (UTIL_PointContents( vecSrc, MASK_WATER ) == CONTENTS_WATER);

	// iterate on all entities in the vicinity.
	while ((pEntity = Entities.FindInSphere( pEntity, vecSrc, flRadius )) != NULL)
	{
		local bPlayer = pEntity.IsPlayer();

		if( !bPlayer )
			continue;

		vecEyePos = pEntity.EyePosition();

		//// blasts used to not travel into or out of water, users assumed it was a bug. Fix is not to run this check -wills
		//if ( bInWater && pEntity->GetWaterLevel() == WL_NotInWater)
		//	continue;
		//if (!bInWater && pEntity->GetWaterLevel() == WL_Eyes)
		//	continue;

		local percentageOfFlash = PercentageOfFlashForPlayer(pEntity, vecSrc, pevInflictor);

		if ( percentageOfFlash > 0.0 )
		{
			if ( pOutNumOpponentsEffected && pEntity.GetTeamNumber() != pevAttacker.GetTeamNumber() )
				pOutNumOpponentsEffected++;
			if ( pOutNumTeammatesEffected && pEntity.GetTeamNumber() == pevAttacker.GetTeamNumber() )
				pOutNumTeammatesEffected++;

			// decrease damage for an ent that's farther from the grenade
			flAdjustedDamage = flDamage - ( vecSrc - pEntity.EyePosition() ).Length() * falloff;

			if ( flAdjustedDamage > 0 )
			{
				// See if we were facing the flash
				vForward = AngleVectors(pEntity.EyeAngles(), vForward);

				vecLOS = ( vecSrc - vecEyePos );

				local flDistance = vecLOS.Length();
				//DebugDrawLine( vecEyePos, vecEyePos + (100.0 * vecLOS), 0, 255, 0, true, 10.0 );
				//DebugDrawLine( vecEyePos, vecEyePos + (100.0 * vForward), 0, 0, 255, true, 10.0 );

				// Normalize both vectors so the dotproduct is in the range -1.0 <= x <= 1.0
				vecLOS = NormalizeInPlace(vecLOS);

				flDot = DotProduct (vecLOS, vForward);

				local startingAlpha = 255;

				// if target is facing the bomb, the effect lasts longer
				if (pEntity == pevInflictor)
				{
					fadeTime = flAdjustedDamage * 2.5;
					fadeHold = flAdjustedDamage * 1.25;
				}
				else
				{
					if( flDot >= 0.6 )
					{
						// looking at the flashbang
						fadeTime = flAdjustedDamage * 2.5;
						fadeHold = flAdjustedDamage * 1.25;
					}
					else if( flDot >= 0.3 )
					{
						// looking to the side
						fadeTime = flAdjustedDamage * 1.75;
						fadeHold = flAdjustedDamage * 0.8;
						startingAlpha = 180;
					}
					else if( flDot >= -0.2 )
					{
						// looking to the side
						fadeTime = flAdjustedDamage * 1.00;
						fadeHold = flAdjustedDamage * 0.5;
						startingAlpha = 180;
					}
					else
					{
						// facing away
						fadeTime = flAdjustedDamage * 0.5;
						fadeHold = flAdjustedDamage * 0.25;
						startingAlpha = 100;
					}
				}

				fadeTime *= percentageOfFlash;
				fadeHold *= percentageOfFlash;

				if ( bPlayer )
				{
					// blind players and bots
					local player = pEntity;

					player.Blind( fadeHold, fadeTime, startingAlpha );
					// deafen players and bots
					player.Deafen( flDistance );
				}
			}
		}
	}
}

::AngleBetween <- function(v1,v2)
{
	local move_dir = (v2 - v1);


	return move_dir;
}

::VectorAngles <- function(v1,v2)
{
	local forward = (v2 - v1);
	local yaw, pitch;
	if ( forward.y == 0.0 && forward.x == 0.0 )
	{
		yaw = 0.0;
		if (forward.z > 0.0)
			pitch = 270.0;
		else
			pitch = 90.0;
	}
	else
	{
		yaw = (atan2(forward.y, forward.x) * 180.0 / Constants.Math.Pi);
		if (yaw < 0.0)
			yaw += 360.0;
		pitch = (atan2(-forward.z, forward.Length2D()) * 180.0 / Constants.Math.Pi);
		if (pitch < 0.0)
			pitch += 360.0;
	}

	return QAngle(0.0, yaw, 0.0);
}

::GetVectorAngles <- function(v1,v2)
{
	local vOut = Vector()
	local forward = (v2 - v1);

	local yaw = 0.0;
	local pitch = yaw;

	if ( !forward.y && !forward.x )
	{
		if ( forward.z > 0.0 )
			pitch = 270.0;
		else
			pitch = 90.0;
	}
	else
	{
		yaw = atan2( forward.y, forward.x ) * RAD2DEG;
		if ( yaw < 0.0 )
			yaw += 360.0;

		pitch = atan2( -forward.z, forward.Length2D() ) * RAD2DEG;
		if ( pitch < 0.0 )
			pitch += 360.0;
	};

	vOut.x = pitch;
	vOut.y = yaw;
	vOut.z = 0.0;

	return vOut;
}

::VectorAngles2 <- function(v1,v2)
{

	local forward = (v2 - v1);
	local yaw, pitch;
	if ( forward.y == 0.0 && forward.x == 0.0 )
	{
		yaw = 0.0;
		if (forward.z > 0.0)
			pitch = 270.0;
		else
			pitch = 90.0;
	}
	else
	{
		yaw = (atan2(forward.y, forward.x) * 180.0 / Constants.Math.Pi);
		if (yaw < 0.0){}
			//yaw += 360.0;
		pitch = (atan2(-forward.z, forward.Length2D()) * 180.0 / Constants.Math.Pi);
		if (pitch < 0.0){}
			//pitch += 360.0;
	}

	return QAngle(pitch, yaw, 0.0);
}

::VectorAngles3 <- function(v1,v2)
{
	local forward = (v2 - v1);
	local yaw, pitch;
	if ( forward.y == 0.0 && forward.x == 0.0 )
	{
		yaw = 0.0;
		if (forward.z > 0.0)
			pitch = 270.0;
		else
			pitch = 90.0;
	}
	else
	{
		yaw = (atan2(forward.y, forward.x) * 180.0 / Constants.Math.Pi);
		if (yaw < 0.0)
			yaw += 360.0;
		pitch = (atan2(-forward.z, forward.Length2D()) * 180.0 / Constants.Math.Pi);
		if (pitch < 0.0)
			pitch += 360.0;
	}

	return QAngle(pitch, yaw, 0.0);
}

::PlayerDisable <- function(ply,toggle = false)
{
	if(toggle)
	{
		ply.AddCustomAttribute("no_attack", 1, -1);
		ply.AddCustomAttribute("no_duck", 1, -1);
		ply.AddCustomAttribute("no_jump", 1, -1);
		ply.SetMoveType(0,0)
	}
	else
	{
    	ply.AddCustomAttribute("no_attack", 0, -1);
		if(!ply.IsMiniBoss()){ply.AddCustomAttribute("no_duck", 0, -1);}
		ply.AddCustomAttribute("no_jump", 0, -1);
		ply.SetMoveType(2,0)
	}
}

::PlayDeployAnim <- function(ply)
{
    ply.SetSequence(ply.LookupSequence("primary_deploybomb"));
}

::SetAttributeDelayed <- function(player ,attribute, attributenum = 0 || [], delay = 0.0, checkclass = false, checkboss = false, bossattributenum = 0 || []  )
{
    EntFireByHandle(mainScript, "RunScriptCode", AttributeSetter(player , attribute, attributenum, checkclass, checkboss, bossattributenum), delay, null, null); // call self to make a fake think!
}

function AttributeSetter(player , attribute, attributenum, checkclass, checkboss, bossattributenum)
{
    if(!checkclass)
	{
		player.AddCustomAttribute(attribute, attributenum, -1);
	}
	else
	{
		if(player.IsMiniBoss()){player.AddCustomAttribute(attribute, bossattributenum, -1);}
		else{player.AddCustomAttribute(attribute, attributenum, -1);}
	}
}