::robot_boss_table <- [
    [ 0, 5, 3375, "MVM.GiantScoutLoop", "MVM.GiantEntranceScout", "MVM.GiantCommonExplodes"],
    [ 1, 5, 3375, "MVM.GiantScoutLoop", "MVM.GiantEntranceScout", "MVM.GiantCommonExplodes"],
    [ 2, 8, 4875, "MVM.GiantScoutLoop", "MVM.GiantEntranceSniper", "MVM.GiantCommonExplodes"],
    [ 3, 3, 4800, "MVM.GiantSoldierLoop", "MVM.GiantEntranceSoldier", "MVM.GiantSoldierExplodes"],
    [ 4, 4, 4825, "MVM.GiantDemomanLoop", "MVM.GiantEntranceDemoman", "MVM.GiantCommonExplodes"],
    [ 5, 8, 4850, "MVM.GiantScoutLoop", "MVM.GiantEntranceMedic", "MVM.GiantCommonExplodes"],
    [ 6, 2, 4700, "MVM.GiantHeavyLoop", "MVM.GiantEntranceHeavy", "MVM.GiantCommonExplodes"],
    [ 7, 6, 4825, "MVM.GiantPyroLoop", "MVM.GiantEntrancePyro", "MVM.GiantCommonExplodes"],
    [ 8, 8, 4875, "MVM.GiantScoutLoop", "MVM.GiantEntranceSpy", "MVM.GiantCommonExplodes"],
    [ 9, 8, 4850, "MVM.GiantScoutLoop", "MVM.GiantEntranceEngineer", "MVM.GiantCommonExplodes"]
]

::m_bFirstPickup <- false

::players <- []

::red_players <- []

::PowerupTimer <- 0

self.PrecacheSoundScript("MVM.Warning")

::m_bAllowBannerEffect <- false

::m_hFlagHolder <- null

::TeamEffectGiverThink <- function()
{
	if(m_hFlagHolder == null)
		return

	local ent = null
	while (ent = Entities.FindByClassnameWithin(ent, "player",m_hFlagHolder.GetOrigin(),512.0))
	{
		if((ent != m_hFlagHolder) && (ent.GetTeam() == 3))
		{
			if (PowerupTimer > (15 / FrameTime()))
			{
				ent.AddCondEx(42, 0.5, null)
				if (PowerupTimer > (180 / FrameTime()))
				{
					ent.AddCondEx(29, 0.5, null)
				}
			}
		}
	}

	if(m_bAllowBannerEffect)
	{
		EntFireByHandle(self, "RunScriptCode", "TeamEffectGiverThink()", 0.01, null, null); // call self to make a fake think!
	}
}

NetProps.SetPropFloat(UpgradeProxyManager,"m_flCheapWaterStartDistance", 0);

::PowerUpThink <- function()
{
    local player = self
    if (player.GetTeam() == TF_TEAM_BLUE)
    {
        NetProps.SetPropIntArray(player, "m_nModelIndexOverrides", ROBOTMODEL_INDEX[player.GetPlayerClass()], 3);

        if (NetProps.GetPropIntArray(player, "m_nModelIndexOverrides", 3) != GetModelIndex("models/player/" + player.GetPlayerClassString() + ".mdl"))
        {
            NetProps.SetPropIntArray(player, "m_nModelIndexOverrides", ROBOTMODEL_INDEX[player.GetPlayerClass()], 3);
        }

        local viewmodel = NetProps.GetPropEntity(player, "m_hViewModel")
        if(player.GetWeaponClassname() != "tf_weapon_pda_spy")
        {
            if (player.GetPlayerClassString() != "generic")
            {
                if (player.HasGunslinger())
                {
                    NetProps.SetPropInt(viewmodel, "m_nModelIndex", GetModelIndex("models/mvm/weapons/c_models/c_engineer_bot_gunslinger.mdl"))
                    viewmodel.SetModelSimple("models/mvm/weapons/c_models/c_engineer_bot_gunslinger.mdl")

                    local viewmodelIndex = GetModelIndex("models/mvm/weapons/c_models/c_engineer_bot_gunslinger.mdl");

                    for (local i = 0; i < 8; i++)
                    {
                        local weapon = GetPropEntityArray(player, "m_hMyWeapons", i)
                        SetPropBool(weapon, "m_bForcePurgeFixedupStrings", true)
                        if (weapon)
                        {
                            weapon.SetModelSimple("models/mvm/weapons/c_models/c_engineer_bot_gunslinger.mdl");
                            weapon.SetCustomViewModelModelIndex(viewmodelIndex);
                            SetPropInt(weapon, "m_nModelIndex", viewmodelIndex);
                            SetPropInt(weapon, "m_iViewModelIndex", viewmodelIndex);
                        }

                    }
                }
                else
                {
                    NetProps.SetPropInt(viewmodel, "m_nModelIndex", GetModelIndex("models/mvm/weapons/c_models/c_" + player.GetPlayerClassString() + "_bot_arms.mdl"))
                    viewmodel.SetModelSimple("models/mvm/weapons/c_models/c_" + player.GetPlayerClassString() + "_bot_arms.mdl")

                    local viewmodelIndex = GetModelIndex("models/mvm/weapons/c_models/c_" + player.GetPlayerClassString() + "_bot_arms.mdl");

                    for (local i = 0; i < 8; i++)
                    {
                        local weapon = GetPropEntityArray(player, "m_hMyWeapons", i)
                        SetPropBool(weapon, "m_bForcePurgeFixedupStrings", true)
                        if (weapon)
                        {
                            weapon.SetModelSimple("models/mvm/weapons/c_models/c_" + player.GetPlayerClassString() + "_bot_arms.mdl");
                            weapon.SetCustomViewModelModelIndex(viewmodelIndex);
                            SetPropInt(weapon, "m_nModelIndex", viewmodelIndex);
                            SetPropInt(weapon, "m_iViewModelIndex", viewmodelIndex);
                        }

                    }

                }
            }
        }
        if((player.HasItem() == true) && (NetProps.GetPropEntity(player, "m_hItem").GetClassname() == "item_teamflag"))
        {
            if(PowerupTimer == (15 / FrameTime()))
            {
                m_bAllowBannerEffect = true
                m_hFlagHolder = self
                TeamEffectGiverThink()
                self.Taunt(0,1)
                self.AddCond(42)
                EmitSoundEx({sound_name = "MVM.Warning", origin = self.GetCenter(), filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL })
                NetProps.SetPropFloat(UpgradeProxyManager,"m_flCheapWaterStartDistance", 1);
				HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_BOMB_CARRIER_UPGRADE1", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");

            }
            else if(PowerupTimer == (45  / FrameTime()))
            {
                self.Taunt(0,1)
                self.AddCustomAttribute("health regen", 45, -1)
                NetProps.SetPropFloat(UpgradeProxyManager,"m_flCheapWaterStartDistance", 2);
                EmitSoundEx({sound_name = "MVM.Warning", origin = self.GetCenter(), filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL })
				HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_BOMB_CARRIER_UPGRADE2", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");
            }
            else if(PowerupTimer == (90 / FrameTime()))
            {
                self.Taunt(0,1)
                self.AddCond(33)
                NetProps.SetPropFloat(UpgradeProxyManager,"m_flCheapWaterStartDistance", 3);
                EmitSoundEx({sound_name = "MVM.Warning", origin = self.GetCenter(), filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL })
				HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_BOMB_CARRIER_UPGRADE3", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");
            }
            else if(PowerupTimer == (180  / FrameTime()))
            {
                self.Taunt(0,1)
                self.AddCond(29)
                NetProps.SetPropFloat(UpgradeProxyManager,"m_flCheapWaterStartDistance", 4);
                EmitSoundEx({sound_name = "MVM.Warning", origin = self.GetCenter(), filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL })
				HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_BOMB_CARRIER_UPGRADE3", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");
            }
            else if(PowerupTimer >= (181  / FrameTime()))
            {
                PowerupTimer = (181 / FrameTime())
            }
            PowerupTimer++
        }

        if(player.IsTaunting())
        {
            local tf_taunt_prop = Entities.FindByClassnameNearest("tf_taunt_prop", player.GetOrigin() , 0.0)

            if( player.IsMiniBoss() )
            {

                if (tf_taunt_prop != null)
                {
                    tf_taunt_prop.SetModelScale(player.GetModelScale(), -1)
                }
            }
            else
            {
                if (tf_taunt_prop != null)
                {
                    tf_taunt_prop.SetModelScale(1, -1)
                }
            }
        }
    }
    else if(player.GetTeam() == TF_TEAM_RED)
    {
        if (player.GetPlayerClass() == TF_PLAYERCLASS_SPY)
        {
            if (player.InCond(TF_COND_DISGUISED))
            {
                local DisguiseClass = NetProps.GetPropInt(player,"m_Shared.m_nDisguiseClass")
                local DisguiseTeam = NetProps.GetPropInt(player,"m_Shared.m_nDisguiseTeam")
                if (DisguiseTeam == TF_TEAM_BLUE)
                {
                    NetProps.SetPropIntArray(player, "m_nModelIndexOverrides", ROBOTMODEL_INDEX[DisguiseClass], 3);
                }
                else if (DisguiseTeam == TF_TEAM_RED)
                {
                    NetProps.SetPropIntArray(player, "m_nModelIndexOverrides", GetModelIndex("models/player/" + TF_CLASS_NAMES[DisguiseClass] + ".mdl"), 3);
                }
            }
            else
            {
                NetProps.SetPropIntArray(player, "m_nModelIndexOverrides", GetModelIndex("models/player/" + player.GetPlayerClassString() + ".mdl"), 3);
            }
        }
        else if (NetProps.GetPropIntArray(player, "m_nModelIndexOverrides", 3) != GetModelIndex("models/player/" + player.GetPlayerClassString() + ".mdl"))
        {
            NetProps.SetPropIntArray(player, "m_nModelIndexOverrides", GetModelIndex("models/player/" + player.GetPlayerClassString() + ".mdl"), 3);
        }
    }

	return -1
}

function MakePlayerBoss(player)
{
    if ((player.HasItem() == true) && (NetProps.GetPropEntity(player, "m_hItem").GetClassname() == "item_teamflag") && (player.GetEFlags() != 1048576) )
    {
        local index = player.GetPlayerClass()
        player.SetIsMiniBoss(true) // Mark them as a giant so we don't do it again (clear this on death)
        player.AddCustomAttribute("ubercharge overheal rate penalty", 0, -1)
        player.AddCustomAttribute("reduced_healing_from_medics", 0.5, -1);
        player.AddCustomAttribute("patient overheal penalty", 0, -1);
        player.AddCustomAttribute("backstab shield", 999, -1);
        player.AddCustomAttribute("no_duck", 1, -1);
        player.AddCustomAttribute("cancel falling damage", 1, -1);
        player.AddCustomAttribute("melee bounds multiplier", 1.2, -1);
        player.AddCustomAttribute("melee range multiplier", 1.3, -1);
        player.AddCustomAttribute("health from packs decreased", 0, -1);
        player.AddCustomAttribute("dmg taken from crit reduced", 0.75, -1);
        player.AddCond(130)
        player.SetModelScale(1.75, 0.0)
        player.AddCustomAttribute("head scale", 0.7, -1)
        local maxHealth = CalculateBossHP();
        local previousmaxhp = player.ChangeHPBaseOnItem()
        player.SetHealth(maxHealth);
        player.SetMaxHealth(maxHealth);
        player.RemoveCustomAttribute("max health additive bonus");
        player.AddCustomAttribute("max health additive bonus", maxHealth - previousmaxhp, -1);
        player.SetHealth(player.GetMaxHealth())
	    SetBossEntity(player)
	    EntFireByHandle(player, "addoutput", "health " + (player.GetMaxHealth() - 1), 0.1, null, null);
	    EntFireByHandle(player, "addoutput", "health " + player.GetMaxHealth(), 0.3, null, null);

        for (local i = 0; i < 7; i++)
        {
            local weapon = NetProps.GetPropEntityArray(player, "m_hMyWeapons", i);
            if (weapon != null)
            {
				local weaponname = weapon.GetClassname().slice(10,weapon.GetClassname().len())
				if((weaponname != "builder") && (weaponname != "pda_engineer_build") && (weaponname != "pda_engineer_destroy"))
				{
					weapon.Destroy()
				}
			}
        }

        foreach (loopsound in robot_boss_table)
        {
            if (index == loopsound[0])
            {
                player.EmitSound(loopsound[3]) // Special thanks to Sprinkles for helping me set this up
            }
        }
        foreach (giantentrancevoice in robot_boss_table)
        {
            if (index == giantentrancevoice[0])
            {
                EmitSoundEx({sound_name = giantentrancevoice[4], origin = player.GetCenter(), filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL })
            }
        }

        switch(TF_CLASS_NAMES[player.GetPlayerClass()])
        {
            case "scout":
            {
                player.AddCustomAttribute("damage force reduction", 0.7, -1)
                player.AddCustomAttribute("no double jump", 1.0, -1)
                player.AddCustomAttribute("rage giving scale", 0.1, -1);
                player.AddCustomAttribute("airblast vulnerability multiplier", 0.7, -1);

                switch(RandomInt(1,3))
                {
                    case 1:
                    {
                        player.GivePlayerWeapon("tf_weapon_scattergun", 45, CW_Stats_GiantScoutForceANature);
                        player.AddCustomAttribute("move speed bonus", 0.9, -1);
                        UpdateBossBarLeaderboardIcon(leaderboard.scout_fan);
                        break;
                    }
                    case 2:
                    {
                        player.GivePlayerWeapon("tf_weapon_bat_wood", 44, CW_Stats_GiantScoutSandman);
                        player.AddCustomAttribute("move speed bonus", 2, -1);
                        player.AddCustomAttribute("airblast vulnerability multiplier", 3.0, -1);
                        player.AddCustomAttribute("airblast vertical vulnerability multiplier", 0.1, -1);
					    UpdateBossBarLeaderboardIcon(leaderboard.scout_stun)
                        break
                    }
                    case 3:
                    {
                        player.GivePlayerWeapon("tf_weapon_bat_fish", 221, CW_Stats_GiantScoutHolyMackerel);
                        player.AddCustomAttribute("move speed bonus", 4, -1);
                        UpdateBossBarLeaderboardIcon(leaderboard.scout_giant_fast);
                        break;
                    }
                }

                break;
            }
            case "sniper":
            {
                player.AddCustomAttribute("damage force reduction", 0.70, -1)
                player.AddCustomAttribute("airblast vulnerability multiplier", 0.5, -1)
                player.AddCustomAttribute("move speed bonus", 0.70, -1)
                player.AddCustomAttribute("rage giving scale", 0.1, -1);

                switch(RandomInt(1,2))
                {
                    case 1:
                    {
                        player.GivePlayerWeapon("tf_weapon_compound_bow", 56, CW_Stats_GiantSniperHuntsman);
						UpdateBossBarLeaderboardIcon(leaderboard.sniper_bow);
                        break;
                    }
                    case 2:
                    {
                        player.GivePlayerWeapon("tf_weapon_smg", 16, CW_Stats_GiantSniperSMG);
                        UpdateBossBarLeaderboardIcon(leaderboard.sniper_smg);
                        break;
                    }
                }

                break;
            }
            case "soldier":
            {
                player.AddCustomAttribute("damage force reduction", 0.4, -1)
                player.AddCustomAttribute("airblast vulnerability multiplier", 0.4, -1)
                player.AddCustomAttribute("move speed bonus", 0.50, -1)
                player.AddCustomAttribute("rage giving scale", 0.1, -1)
                NetProps.SetPropBool(player, "m_Shared.m_bParachuteEquipped", false);

                if(player.GetPlayerSteamID() == "[U:1:89189905]") //[U:1:89189905] aar
                {
                    player.GivePlayerWeapon("tf_weapon_particle_cannon", 441, CW_Stats_GiantSoldierCowManglerAar);
                    UpdateBossBarLeaderboardIcon(leaderboard.soldier_cowmangler);
                    break;
                }
                else
                {
                    switch(RandomInt(1,4))
                    {
                        case 1:
                        {
                            player.GivePlayerWeapon("tf_weapon_rocketlauncher", 18, CW_Stats_GiantSoldierRapidFire);
                            UpdateBossBarLeaderboardIcon(leaderboard.soldier_burstfire);
                            break;
                        }
                        case 2:
                        {
                            player.GivePlayerWeapon("tf_weapon_raygun", 442, CW_Stats_GiantSoldierBison);
                            UpdateBossBarLeaderboardIcon(leaderboard.soldier_bison);
                            break;
                        }
                        case 3:
                        {
                            player.GivePlayerWeapon("tf_weapon_rocketlauncher", 228, CW_Stats_GiantSoldierBlackBox);
                            UpdateBossBarLeaderboardIcon(leaderboard.soldier_blackbox);
                            break;
                        }
                        case 4:
                        {
                            player.GivePlayerWeapon("tf_weapon_rocketlauncher_airstrike", 1104, CW_Stats_GiantSoldierTracking);
                            UpdateBossBarLeaderboardIcon(leaderboard.soldier_barrage);
                            break;
                        }
                    }
                }

                break;
            }
            case "demo":
            {
                player.AddCustomAttribute("damage force reduction", 0.55, -1)
                player.AddCustomAttribute("airblast vulnerability multiplier", 0.40, -1)
                SetPropBool(player, "m_Shared.m_bParachuteEquipped", false);
                player.AddCustomAttribute("move speed bonus", 0.7, -1)

				if(player.GetPlayerSteamID() == "[U:1:1274289548]") //ICM
                //if(player.GetPlayerSteamID() == "[U:1:94791175]")
				{
					player.GiveWeapon("GiantDemoGlock")
                    player.GivePlayerWeapon("tf_weapon_bottle", 30758, CW_Stats_GiantDemoSwitchBlade)
					player.AddCustomAttribute("move speed bonus", 0.7, -1)
                    NetProps.SetPropBool(player, "m_Shared.m_bShieldEquipped", false);
                    UpdateBossBarLeaderboardIcon(leaderboard.demo_glock)
					break
				}
				else
				{
					switch(RandomInt(1,3))
					{
						case 1:
                        {
                            player.GivePlayerWeapon("tf_weapon_grenadelauncher", 19, CW_Stats_GiantDemomanRapidFire);
							NetProps.SetPropBool(player, "m_Shared.m_bShieldEquipped", false);
                            UpdateBossBarLeaderboardIcon(leaderboard.demo_burst);
							break;
                        }
						case 2:
                        {
                            player.GivePlayerWeapon("tf_weapon_sword", 132, CW_Stats_GiantDemoknight)
							NetProps.SetPropBool(player, "m_Shared.m_bShieldEquipped", true);
							player.GiveWeapon("GiantDemoknightShield")
							player.GiveWeapon("Bootlegger")
                            UpdateBossBarLeaderboardIcon(leaderboard.demoknight)
							break;
                        }
						case 3:
                        {
                            player.GivePlayerWeapon("tf_weapon_pipebomblauncher", 20, CW_Stats_GiantDemomanIsmac);
                            NetProps.SetPropBool(player, "m_Shared.m_bShieldEquipped", false);
                            UpdateBossBarLeaderboardIcon(leaderboard.demo_burst);
                            break;
                        }
					}
				}

                break;
            }
            case "medic":
            {
                player.AddCustomAttribute("move speed bonus", 0.7, -1)
                player.AddCustomAttribute("damage force reduction", 0.75, -1)
                player.AddCustomAttribute("airblast vulnerability multiplier", 0.55, -1)

                switch(RandomInt(1,2))
                {
                    case 1:
                    {
                        player.GivePlayerWeapon("tf_weapon_crossbow", 305, CW_Stats_GiantMedicCrossbow);
                        UpdateBossBarLeaderboardIcon(leaderboard.medic_crossbow);
                        break;
                    }
                    case 2:
                    {
                        player.GivePlayerWeapon("tf_weapon_syringegun_medic", 412, CW_Stats_GiantMedicOverdose);
                        UpdateBossBarLeaderboardIcon(leaderboard.medic_syringe);
                        break;
                    }
                }

                break;
            }
            case "heavy":
            {
                if(player.GetPlayerSteamID() == "[U:1:1041260268]") //[U:1:1041260268] poltrageese holiday punch!
				{
                    player.GivePlayerWeapon("tf_weapon_fists", 656)
					player.AddCustomAttribute("move speed bonus", 1.3, -1)
                    player.AddCustomAttribute("rage giving scale", 0.1, -1)
                    player.AddCustomAttribute("damage force reduction", 0.4, -1)
                    player.AddCustomAttribute("airblast vulnerability multiplier", 1.4, -1)
                    UpdateBossBarLeaderboardIcon(leaderboard.heavy_mittens)
					break;
                }
                else if(player.GetPlayerSteamID() == "[U:1:94791175]")//sprinkles :3
                {
                    player.GivePlayerWeapon("tf_weapon_minigun", 298, CW_Stats_GiantHeavyIronCurtainSprinkles);
					player.AddCustomAttribute("move speed bonus", 0.6, -1);
                    player.AddCustomAttribute("rage giving scale", 0.1, -1);
                    player.AddCustomAttribute("damage force reduction", 0.4, -1);
                    player.AddCustomAttribute("airblast vulnerability multiplier", 0.2, -1);
                    player.AddCustomAttribute("airblast vertical vulnerability multiplier", 0.1, -1);
                    UpdateBossBarLeaderboardIcon(leaderboard.heavy);
					break;
                }
                else
                {
                    player.AddCustomAttribute("move speed bonus", 0.5, -1)
                    player.AddCustomAttribute("damage force reduction", 0.3, -1)
                    player.AddCustomAttribute("airblast vulnerability multiplier", 0.3, -1)
                    player.AddCustomAttribute("rage giving scale", 0.1, -1)

                    switch(RandomInt(1,6))
                    {
                        case 1:
                        {
                            player.GivePlayerWeapon("tf_weapon_minigun", 850, CW_Stats_GiantHeavyDeflecter);
                            UpdateBossBarLeaderboardIcon(leaderboard.heavy_deflector);
                            break;
                        }
                        case 2:
                        {
                            player.GivePlayerWeapon("tf_weapon_fists", 331, CW_Stats_GiantHeavyFistsOfSteel);
                            player.AddCustomAttribute("airblast vertical vulnerability multiplier", 0.1, -1);
                            UpdateBossBarLeaderboardIcon(leaderboard.heavy_steelfist);
                            break;
                        }
                        case 3:
                        {
                            player.GivePlayerWeapon("tf_weapon_shotgun", 199, CW_Stats_GiantHeavyShotgun);
                            UpdateBossBarLeaderboardIcon(leaderboard.heavy_shotgun);
                            break;
                        }
                        case 4:
                        {
                            player.GivePlayerWeapon("tf_weapon_minigun", 811, CW_Stats_GiantHeavyHuoLongHeatmaker);
                            UpdateBossBarLeaderboardIcon(leaderboard.heavy_heater);
                            break;
                        }
                        case 5:
                        {
                            player.GivePlayerWeapon("tf_weapon_minigun", 312, CW_Stats_GiantHeavyNormal)
                            UpdateBossBarLeaderboardIcon(leaderboard.heavy_brassbeast)
                            break
                        }
                        case 6:
                        {
                            player.GivePlayerWeapon("tf_weapon_minigun", 41, CW_Stats_GiantHeavyNormal);
                            UpdateBossBarLeaderboardIcon(leaderboard.heavy_natascha_slow);
                            break;
                        }
                    }
                }

                break;
            }
            case "pyro":
            {
                player.AddCustomAttribute("damage force reduction", 0.6, -1)
                player.AddCustomAttribute("airblast vulnerability multiplier", 0.6, -1)
                player.AddCustomAttribute("move speed bonus", 0.5, -1);
                player.AddCustomAttribute("rage giving scale", 0.1, -1)

                switch(RandomInt(1, 4))
                {
                    case 1:
                    {
                        player.GivePlayerWeapon("tf_weapon_flamethrower", 21, CW_Stats_GiantPyroFlamethrower);
                        UpdateBossBarLeaderboardIcon(leaderboard.pyro);
                        break;
                    }
                    case 2:
                    {
                        player.GivePlayerWeapon("tf_weapon_flaregun_revenge", 595, CW_Stats_GiantPyroManmelter);
                        UpdateBossBarLeaderboardIcon(leaderboard.pyro_manmelter);
                        break;
                    }
                    case 3:
                    {
                        player.GivePlayerWeapon("tf_weapon_flaregun", 740, CW_Stats_GiantPyroScorchSpammer);
                        UpdateBossBarLeaderboardIcon(leaderboard.pyro_flare);
                        break;
                    }
                    case 4:
                    {
                        player.GivePlayerWeapon("tf_weapon_flamethrower", 30474, CW_Stats_GiantPyroNapalmer);
                        UpdateBossBarLeaderboardIcon(leaderboard.pyro);
                        break;
                    }
                }

                break;
            }
            case "spy":
            {

                player.AddCustomAttribute("move speed bonus", 0.6, -1);
                player.AddCustomAttribute("damage force reduction", 0.5, -1);
                player.AddCustomAttribute("airblast vulnerability multiplier", 0.5, -1);
                player.AddCustomAttribute("rage giving scale", 0.1, -1)

                switch(RandomInt(1, 2))
                {
                    case 1:
                    {
                        player.GivePlayerWeapon("tf_weapon_revolver", 24, CW_Stats_GiantSpyRevolver);
                        UpdateBossBarLeaderboardIcon(leaderboard.spy);
                        break;
                    }
                    case 2:
                    {
                        player.GivePlayerWeapon("tf_weapon_revolver", 61, CW_Stats_GiantSpyRevolverHeadshot);
                        UpdateBossBarLeaderboardIcon(leaderboard.spy);
                        break;
                    }
                }

                break;
            }
            case "engineer":
            {
                player.AddCustomAttribute("damage force reduction", 0.7, -1);
                player.AddCustomAttribute("airblast vulnerability multiplier", 0.5, -1);
                player.AddCustomAttribute("engy building health bonus", 2, -1);
                player.AddCustomAttribute("engy sentry damage bonus", 1.5, -1);
                player.AddCustomAttribute("engy dispenser radius increased", 2, -1);
                player.AddCustomAttribute("move speed bonus", 0.8, -1);
                player.GivePlayerWeapon("tf_weapon_robot_arm", 142);

                switch(RandomInt(1,2))
                {
                    case 1:
                    {
                        UpdateBossBarLeaderboardIcon(leaderboard.engineer_widowmaker);
                        player.GivePlayerWeapon("tf_weapon_shotgun_primary", 527, CW_Stats_GiantEngineerWidowmaker);
                        break;
                    }
                    case 2:
                    {
                        player.GivePlayerWeapon("tf_weapon_drg_pomson", 588, CW_Stats_GiantEngineerPomson);
                        UpdateBossBarLeaderboardIcon(leaderboard.engineer_pomson);
                        break;
                    }
                }

                break;
            }
        }
    }
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////

	OnGameEvent_teamplay_flag_event = function(params)
    {
        if(params.eventtype == 5)
        {
            ReturnToLastPoint()
        }

        if ("player" in params)
        {
            local pPlayer = PlayerInstanceFromIndex(params.player)
            if (pPlayer != null)
            {
                if (((pPlayer.HasItem() == true) && (NetProps.GetPropEntity(pPlayer, "m_hItem").GetClassname() == "item_teamflag")))
                {
                    EntFireByHandle(self, "runscriptcode", "GiantRobotFootsteps(activator)", 0.1, pPlayer, pPlayer)
                    pPlayer.SetIsMiniBoss(false)
                }

                if ((params.eventtype == 4) && (pPlayer.IsMiniBoss() == true))
                {
                    pPlayer.TakeDamageCustom(pPlayer, pPlayer, Entities.First(), Vector(), Vector(), 99999, 0, Constants.ETFDmgCustom.TF_DMG_CUSTOM_TELEFRAG);
                    HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_BOMB_DROPPED", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");
                    return;
                }

                if ((params.eventtype == 4) && (pPlayer.IsMiniBoss() != true))
                {

                    pPlayer.AddCustomAttribute("move speed bonus", 1.0, -1)
                    local bomb = Entities.FindByClassname(null, "item_teamflag")
                    bomb.SetDrawEnabled(true)
                    SetBossEntity(null)
                    PowerupTimer = 0
                    pPlayer.RemoveCond(42);
                    pPlayer.RemoveCond(33);
                    pPlayer.RemoveCond(29);
                    m_bAllowBannerEffect = false
                    m_hFlagHolder = null
                    NetProps.SetPropFloat(UpgradeProxyManager,"m_flCheapWaterStartDistance", 0);
                    NetProps.SetPropString(pPlayer, "m_iName", "")
                    HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_BOMB_DROPPED", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");
                }
                else if ((params.eventtype == 1) && (pPlayer.IsMiniBoss() != true) && (m_bFirstPickup != true))
                {
                    m_bFirstPickup = true
                    MakePlayerBoss(pPlayer)
                    HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_GIANT_HAS_BOMB", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");
                }
                else if ((params.eventtype == 1) && (pPlayer.IsMiniBoss() != true))
                {
                    pPlayer.AddCond(130)
                    pPlayer.AddCustomAttribute("move speed bonus", 0.6, -1)
                    SetBossEntity(pPlayer)
                    NetProps.SetPropFloat(UpgradeProxyManager,"m_flCheapWaterStartDistance", 0);
                    HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_BOMB_PICKUP", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");
                }
            }
        }
    }
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)

function GiantRobotFootsteps(player)
{
    local player_class = player.GetPlayerClass()
    if ((player_class in robot_table) && (player.IsMiniBoss() == true))
    {
        local index = player.GetPlayerClass()
        foreach (giantfootsteps in robot_boss_table)
        {
            if (index == giantfootsteps[0])
            {
                activator.AddCustomAttribute("override footstep sound set", (giantfootsteps[1]), -1); // Special thanks to Sprinkles for helping me set this up
            }
        }
    }
}

::GIBS_BOTS <- [
    ["models/player/gibs/gibs_can.mdl"],
    ["models/bots/gibs/scoutbot_gib_boss_arm1.mdl", "models/bots/gibs/scoutbot_gib_boss_arm2.mdl", "models/bots/gibs/scoutbot_gib_boss_chest.mdl", "models/bots/gibs/scoutbot_gib_boss_head.mdl", "models/bots/gibs/scoutbot_gib_boss_leg1.mdl", "models/bots/gibs/scoutbot_gib_boss_leg2.mdl", "models/bots/gibs/scoutbot_gib_boss_pelvis.mdl"],
    ["models/bots/gibs/scoutbot_gib_boss_arm1.mdl", "models/bots/gibs/scoutbot_gib_boss_arm2.mdl", "models/bots/gibs/scoutbot_gib_boss_chest.mdl", "models/bots/gibs/sniperbot_gib_head.mdl", "models/bots/gibs/scoutbot_gib_boss_leg1.mdl", "models/bots/gibs/scoutbot_gib_boss_leg2.mdl", "models/bots/gibs/scoutbot_gib_boss_pelvis.mdl"],
    ["models/bots/gibs/soldierbot_gib_boss_arm1.mdl", "models/bots/gibs/soldierbot_gib_boss_arm2.mdl", "models/bots/gibs/soldierbot_gib_boss_chest.mdl", "models/bots/gibs/soldierbot_gib_boss_head.mdl", "models/bots/gibs/soldierbot_gib_boss_leg1.mdl", "models/bots/gibs/soldierbot_gib_boss_leg2.mdl", "models/bots/gibs/soldierbot_gib_boss_pelvis.mdl"],
    ["models/bots/gibs/demobot_gib_boss_arm1.mdl", "models/bots/gibs/demobot_gib_boss_arm2.mdl", "models/bots/gibs/demobot_gib_boss_leg3.mdl", "models/bots/gibs/demobot_gib_boss_head.mdl", "models/bots/gibs/demobot_gib_boss_leg1.mdl", "models/bots/gibs/demobot_gib_boss_leg2.mdl", "models/bots/gibs/demobot_gib_boss_pelvis.mdl"],
    ["models/bots/gibs/scoutbot_gib_boss_arm1.mdl", "models/bots/gibs/scoutbot_gib_boss_arm2.mdl", "models/bots/gibs/scoutbot_gib_boss_chest.mdl", "models/bots/gibs/medicbot_gib_head.mdl", "models/bots/gibs/scoutbot_gib_boss_leg1.mdl", "models/bots/gibs/scoutbot_gib_boss_leg2.mdl", "models/bots/gibs/scoutbot_gib_boss_pelvis.mdl"],
    ["models/bots/gibs/heavybot_gib_boss_arm.mdl", "models/bots/gibs/heavybot_gib_boss_arm2.mdl", "models/bots/gibs/heavybot_gib_boss_chest.mdl", "models/bots/gibs/heavybot_gib_boss_head.mdl", "models/bots/gibs/heavybot_gib_boss_leg.mdl", "models/bots/gibs/heavybot_gib_boss_leg2.mdl", "models/bots/gibs/heavybot_gib_boss_pelvis.mdl"],
    ["models/bots/gibs/pyrobot_gib_boss_arm1.mdl", "models/bots/gibs/pyrobot_gib_boss_arm2.mdl","models/bots/gibs/pyrobot_gib_boss_arm3.mdl","models/bots/gibs/pyrobot_gib_boss_chest.mdl","models/bots/gibs/pyrobot_gib_boss_chest2.mdl","models/bots/gibs/pyrobot_gib_boss_head.mdl","models/bots/gibs/pyrobot_gib_boss_leg.mdl","models/bots/gibs/pyrobot_gib_boss_pelvis.mdl",],
    ["models/bots/gibs/scoutbot_gib_boss_arm1.mdl", "models/bots/gibs/scoutbot_gib_boss_arm2.mdl", "models/bots/gibs/scoutbot_gib_boss_chest.mdl", "models/bots/gibs/spybot_gib_head.mdl", "models/bots/gibs/scoutbot_gib_boss_leg1.mdl", "models/bots/gibs/scoutbot_gib_boss_leg2.mdl", "models/bots/gibs/scoutbot_gib_boss_pelvis.mdl"],
    ["models/bots/gibs/scoutbot_gib_boss_arm1.mdl", "models/bots/gibs/scoutbot_gib_boss_arm2.mdl", "models/bots/gibs/scoutbot_gib_boss_chest.mdl", "models/bots/gibs/scoutbot_gib_boss_head.mdl", "models/bots/gibs/scoutbot_gib_boss_leg1.mdl", "models/bots/gibs/scoutbot_gib_boss_leg2.mdl", "models/bots/gibs/scoutbot_gib_boss_pelvis.mdl"]
];

foreach (gibArray in GIBS_BOTS)
{
    foreach (gib in gibArray)
    {
        PrecacheModel(gib);
    }
}

::ShootGibs <- function(origin, classIndex)
{
    local gibSpawner = SpawnEntityFromTable("env_shooter",
    {
        spawnflags = 5,
        m_iGibs = 1,
        m_flVelocity = 500,
        scale = 10,
        m_flVariance = 1,
        m_flGibLife = 10,
        shootsounds = 3,
        simulation = 1,
        skin = 1,
        nogibshadows = true
    })
    gibSpawner.SetAbsOrigin(origin);
    gibSpawner.SetAbsAngles(QAngle(-90, 0, 0));
    EntFireByHandle(gibSpawner, "Kill", "", 2, null, null);

    local gibArray = GIBS_BOTS[classIndex];
    local gibLength = gibArray.len();
    for(local i = 0; i < gibLength; i++)
    {
        EntFireByHandle(gibSpawner, "AddOutput", "shootmodel "+gibArray[i], 0.01 * i, null, null);
        EntFireByHandle(gibSpawner, "Shoot", "", 0.01 * i, null, null);
    }
}

::ExplosiveDeath <- function(player)
{
    local ragdoll = NetProps.GetPropEntity(player, "m_hRagdoll")
    ShootGibs(player.GetOrigin(), clamp(player.GetPlayerClass(), 0, 9));
    ragdoll.Destroy()
}

PrecacheParticle("fireSmokeExplosion_trackb")

::GiantDeath <- function(params)
{
    if (!("userid" in params))
    return;
    local player = GetPlayerFromUserID(params.userid)

    if (player.IsMiniBoss())
    {
		bossEntity = null;
        GiantReset(player)

        DispatchParticleEffect("fireSmokeExplosion_trackb", player.GetCenter(), Vector(0, 180, 0));
        EmitSoundEx({
            sound_name = "ambient/explosions/explode_2.wav",
            volume = 1,
            filter = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL,
            soundlevel = 150,
            flags = 1,
            channel = 0
        });

        EntFireByHandle(player, "RunScriptCode", "ExplosiveDeath(activator)", -1, player, player)
        HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_GIANT_KILLED", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1");

    }
}

::GiantReset <- function(player)
{
    player.RemoveCustomAttribute("cancel falling damage")
    player.RemoveCustomAttribute("no double jump")
    player.RemoveCustomAttribute("crit kill will gib")
    player.RemoveCustomAttribute("attack projectiles")
    player.RemoveCustomAttribute("damage force reduction")
    player.RemoveCustomAttribute("airblast vulnerability multiplier")
    player.RemoveCustomAttribute("ubercharge overheal rate penalty")
    player.RemoveCustomAttribute("reduced_healing_from_medics")
    player.RemoveCustomAttribute("patient overheal penalty")
    player.RemoveCustomAttribute("no_duck")
    player.RemoveCustomAttribute("head scale")
    player.RemoveCondEx(21, true)
    player.RemoveCondEx(56, true)
    player.RemoveCondEx(273, true)
    //player.SetGravity(1.0)
    player.SetIsMiniBoss(false)
    local index = player.GetPlayerClass();
    foreach (loopsound in robot_boss_table)
    {
        if (index == loopsound[0])
        {
            StopSoundOn(loopsound[3], player) // Special thanks to Sprinkles for helping me set this up
        }
    }
    foreach (giantdeathsound in robot_boss_table)
    {
        if (index == giantdeathsound[0])
        {
            EmitSoundEx({sound_name = giantdeathsound[5], origin = player.GetCenter(), filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_GLOBAL })
        }
    }
}

//This is for backstabs to make them not as powerful
::GiantTakeDamage <- function(params)
{
    if (!params.const_entity.IsPlayer()) return;
    if(params.const_entity.IsMiniBoss() && (params.damage_custom == 2))
    {
        params.const_entity.TakeDamageCustom(params.inflictor, params.attacker, params.weapon, params.damage_force, params.damage_position, 200, 135270528, 0);
        //params.damage_custom = 0
        //params.crit_type = 0
        //params.damage = 200
    }
}