
//my personal weapon when i play as a giant heavy!
::CW_Stats_GiantHeavyIronCurtainSprinkles <- function(weapon, player)
{
	weapon.AddAttribute("damage bonus", 2, -1)
	weapon.AddAttribute("projectile penetration heavy", 3, -1)
	weapon.AddAttribute("pyro year number", 3, -1)
	weapon.AddAttribute("fire rate bonus with reduced health", 0.3, -1)
	weapon.AddAttribute("minigun spinup time decreased", 0.8, -1)
	weapon.AddAttribute("spunup_damage_resistance", 0.8, -1)
	weapon.AddAttribute("mod shovel damage boost", 1, -1)
	weapon.AddAttribute("selfmade description", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantHeavyNormal <- function(weapon, player)
{
    weapon.AddAttribute("damage bonus", 1.5, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantHeavyDeflecter <- function(weapon, player)
{
    weapon.AddAttribute("attack projectiles", 4, -1)
    weapon.AddAttribute("damage bonus", 1.5, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantHeavyHuoLongHeatmaker <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 1.1, -1)
	weapon.AddAttribute("Set DamageType Ignite", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantHeavyHuoLongHeatmaker <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 1.1, -1)
	weapon.AddAttribute("Set DamageType Ignite", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantPyroFlamethrower <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 3, -1)
	weapon.AddAttribute("airblast cost increased", 2, -1)
	weapon.AddAttribute("airblast pushback scale", 2, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantPyroNapalmer <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 0.5, -1)
	weapon.AddAttribute("airblast disabled", 1, -1)
	weapon.AddAttribute("weapon burn dmg increased", 4, -1)
	weapon.AddAttribute("weapon burn time increased", 2, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 4.995, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantEngineerPomson <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.3, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("damage bonus", 3, -1)
	weapon.AddAttribute("projectile speed increased", 8, -1)
}

::CW_Stats_GiantEngineerWidowmaker <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 1.5, -1)
	weapon.AddAttribute("faster reload rate", 0.8, -1)
	weapon.AddAttribute("weapon spread bonus", 1.4, -1)
	weapon.AddAttribute("damage penalty", 1.5, -1)
}

::CW_Stats_GiantScoutForceANature <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.5, -1)
	weapon.AddAttribute("bullets per shot bonus", 2, -1)
	weapon.AddAttribute("faster reload rate", 1.7, -1)
	weapon.AddAttribute("scattergun knockback mult", 6, -1)
	weapon.AddAttribute("weapon spread bonus", 0.4, -1)
	weapon.AddAttribute("damage penalty", 0.6, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 31.21875, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantPyroManmelter <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.3, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("override projectile type", 13, -1)
	weapon.AddAttribute("set item tint RGB", 15185211, -1)
	weapon.AddAttribute("energy weapon penetration", 1, -1)
	weapon.AddAttribute("energy weapon no deflect", 1, -1)
	weapon.AddAttribute("damage bonus", 8, -1)
	weapon.AddAttribute("Projectile speed increased", 4, -1)
}

::CW_Stats_GiantScoutSandman <- function(weapon, player)
{
    weapon.AddAttribute("damage penalty", 3, -1)
	weapon.AddAttribute("effect bar recharge rate increased", 0.1, -1)
	weapon.AddAttribute("fire rate penalty", 0.7, -1)
}

::CW_Stats_GiantDemoknight <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.85, -1)
	weapon.AddAttribute("damage penalty", 2, -1)
	weapon.AddAttribute("critboost on kill", 3, -1)
}
self.PrecacheScriptSound("vo/mvm/norm/demoman_mvm_paincrticialdeath04.mp3")
::CW_Stats_GiantDemoknightShield <- function(weapon, player)
{
	if( weapon.ValidateScriptScope() )
	{
		local weaponscope = weapon.GetScriptScope()
        weaponscope.m_bInCharge <- false
        weaponscope.m_hOwner <- player
        weaponscope.flCurrentChargeMeter <- 0.0
		weaponscope["think_democharge"] <- function()	//Our script's name under the weapon scope.
		{

			local buttons = GetPropInt(m_hOwner, "m_nButtons");
            SetPropBool(m_hOwner, "m_Shared.m_bShieldEquipped", true);
			local chargeamount = GetPropFloat(m_hOwner, "m_Shared.m_flChargeMeter");
			if ((chargeamount >= 99) && ((buttons & 2048) == 2048))
			{
				m_hOwner.StopSound("DemoCharge.Charging")
				EmitSoundEx({
					sound_name = "vo/mvm/norm/demoman_mvm_paincrticialdeath04.mp3",
					origin = m_hOwner.GetCenter(),
					channel = 8,
					sound_level = 95,
					volume = 0.82,
					speaker_entity = m_hOwner,
					entity = m_hOwner,
				})
                m_bInCharge = true
				m_hOwner.AddCond(TF_COND_SHIELD_CHARGE)
			}

            if(m_bInCharge && m_hOwner.InCond(TF_COND_SHIELD_CHARGE))
            {
                flCurrentChargeMeter = GetPropFloat(m_hOwner, "m_Shared.m_flChargeMeter")
            }
            else if(m_bInCharge && !m_hOwner.InCond(TF_COND_SHIELD_CHARGE))
            {
                m_bInCharge = false
                self.ShieldBash(m_hOwner, flCurrentChargeMeter)
            }

            return -1
		}
		AddThinkToEnt(weapon, "think_democharge")	//After all that's said an done, this adds the think script to handle 'weapon' after it has been validated.
	}
}

::CW_Stats_GiantDemomanRapidFire <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.15, -1)
	weapon.AddAttribute("faster reload rate", 0.15, -1)
	weapon.AddAttribute("blast radius increased", 1.25, -1)
	weapon.AddAttribute("Projectile speed increased", 1.5, -1)
	weapon.AddAttribute("damage penalty", 0.5, -1)
	weapon.AddAttribute("auto fires full clip penalty", 2, -1)
	weapon.AddAttribute("auto fires when full", 2, -1)
	weapon.AddAttribute("projectile spread angle penalty", 3, -1)
	weapon.AddAttribute("clip size bonus", 5, -1)
	NetProps.SetPropIntArray(weapon, "m_iClip1", 0, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 62.4375, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantDemomanIsmac <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.15, -1)
	weapon.AddAttribute("faster reload rate", 0.15, -1)
	weapon.AddAttribute("stickybomb charge rate", 0.001, -1)
	weapon.AddAttribute("blast radius increased", 1.25, -1)
	weapon.AddAttribute("Projectile speed increased", 1.5, -1)
	weapon.AddAttribute("damage penalty", 0.5, -1)
	weapon.AddAttribute("auto fires full clip penalty", 1, -1)
	weapon.AddAttribute("auto fires when full", 1, -1)
	weapon.AddAttribute("projectile spread angle penalty", 3, -1)
	weapon.AddAttribute("clip size bonus", 2.5, -1)
	NetProps.SetPropIntArray(weapon, "m_iClip1", 0, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 41.625, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 2);
}

::CW_Stats_GiantDemoGlock <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.75, -1)
	weapon.AddAttribute("faster reload rate", 2, -1)
	weapon.AddAttribute("damage bonus", 2, -1)
}

::CW_Stats_GiantDemoSwitchBlade <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.75, -1)
	weapon.AddAttribute("damage bonus", 2, -1)
}

::CW_Stats_GiantHeavyFistsOfSteel <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 5, -1)
	weapon.AddAttribute("fire rate bonus", 0.6, -1)
}

::CW_Stats_GiantHeavyShotgun <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 2.5, -1)
	weapon.AddAttribute("bullets per shot bonus", 10, -1)
	weapon.AddAttribute("faster reload rate", 0.1, -1)
	weapon.AddAttribute("damage penalty", 0.5, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 31.21875, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantScoutHolyMackerel <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 2, -1)
	weapon.AddAttribute("dmg bonus vs buildings", 0.8, -1)
}

::CW_Stats_GiantMedicCrossbow <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.4, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("damage penalty", 3, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 26.28947368, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantMedicOverdose <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.6, -1)
	weapon.AddAttribute("faster reload rate", 2, -1)
	weapon.AddAttribute("damage penalty", 1.5, -1)
	weapon.AddAttribute("clip size bonus", 2.5, -1)
	NetProps.SetPropIntArray(weapon, "m_iClip1", 100, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 6.66, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantScoutPistol <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.5, -1)
	weapon.AddAttribute("faster reload rate", 1.5, -1)
	weapon.AddAttribute("weapon spread bonus", 0.4, -1)
	weapon.AddAttribute("damage penalty", 0.5, -1)
	weapon.AddAttribute("dmg bonus vs buildings", 3, -1)
}

::CW_Stats_GiantSniperSMG <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 1.1, -1)
	weapon.AddAttribute("fire rate penalty", 0.85, -1)
	weapon.AddAttribute("clip size bonus", 2.4, -1)
	NetProps.SetPropIntArray(weapon, "m_iClip1", 60, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 13.32, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 2);
}

::CW_Stats_GiantSniperHuntsman <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 0.8, -1)
	weapon.AddAttribute("fire rate penalty", 0.55, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 83.25, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantSoldierBison <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.3, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("SPELL: set item tint RGB", 4, -1)
	weapon.AddAttribute("energy weapon no deflect", 1, -1)
	weapon.AddAttribute("damage bonus", 4, -1)
	weapon.AddAttribute("Projectile speed increased", 4, -1)
}

::CW_Stats_GiantSoldierRapidFire <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.15, -1)
	weapon.AddAttribute("faster reload rate", 0.15, -1)
	weapon.AddAttribute("blast radius increased", 1.25, -1)
	weapon.AddAttribute("Projectile speed increased", 1.5, -1)
	weapon.AddAttribute("damage penalty", 0.6, -1)
	weapon.AddAttribute("auto fires full clip penalty", 2, -1)
	weapon.AddAttribute("auto fires when full", 2, -1)
	weapon.AddAttribute("projectile spread angle penalty", 3, -1)
	weapon.AddAttribute("clip size bonus", 5, -1)
	NetProps.SetPropIntArray(weapon, "m_iClip1", 0, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 49.95, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantSoldierBlackBox <- function(weapon, player)
{
	weapon.AddAttribute("damage penalty", 0.45, -1)
	weapon.AddAttribute("fire rate penalty", 0.001, -1)
	weapon.AddAttribute("clip size upgrade atomic", 0, -1)
	weapon.AddAttribute("faster reload rate", 1.6, -1)
	weapon.AddAttribute("blast radius increased", 1.5, -1)
	weapon.AddAttribute("projectile spread angle penalty", 4, -1)
	weapon.AddAttribute("heal on hit for rapidfire", 1000, -1)
	weapon.AddAttribute("Projectile speed increased", 0.9, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 49.95, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantSoldierCowManglerAar <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 1.5, -1)
	weapon.AddAttribute("faster reload rate", -0.8, -1)
	weapon.AddAttribute("blast radius increased", 1.5, -1)
	weapon.AddAttribute("Projectile speed increased", 0.5, -1)
	weapon.AddAttribute("damage penalty", 0.6, -1)
	weapon.AddAttribute("set item tint RGB", 14432, -1)

	if( weapon.ValidateScriptScope() )
	{
		local weaponscope = weapon.GetScriptScope()
		weaponscope["WeaponThink"] <- function()	//Our script's name under the weapon scope.
		{
			local owner = self.GetOwner()

			for (local entity; entity = Entities.FindByClassname(entity, "tf_projectile_energy_ball");)
			{
				SetPropBool(entity, "m_bForcePurgeFixedupStrings", true)
				if ((GetPropEntity(entity, "m_hLauncher") == weapon) && (entity.GetScriptThinkFunc() != "HomingRocket_Think"))
				{
					SetPropBool(entity, "m_bCritical", false)
					SetHomingProjectile(entity, 0.8, true)
					break;
				}
			}

			return -1
		}
		AddThinkToEnt(weapon, "WeaponThink")	//After all that's said an done, this adds the think script to handle 'weapon' after it has been validated.
	}
}

::CW_Stats_GiantSoldierTracking <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.25, -1)
	weapon.AddAttribute("faster reload rate", 0.5, -1)
	weapon.AddAttribute("blast radius increased", 0.5, -1)
	weapon.AddAttribute("Projectile speed increased", 0.8, -1)
	weapon.AddAttribute("damage penalty", 0.9, -1)
	weapon.AddAttribute("auto fires full clip penalty", 1, -1)
	weapon.AddAttribute("auto fires when full", 1, -1)
	weapon.AddAttribute("projectile spread angle penalty", 3, -1)

	if( weapon.ValidateScriptScope() )
	{
		local weaponscope = weapon.GetScriptScope()
		weaponscope["WeaponThink"] <- function()	//Our script's name under the weapon scope.
		{
			local owner = self.GetOwner()

			for (local entity; entity = Entities.FindByClassname(entity, "tf_projectile_rocket");)
			{
				SetPropBool(entity, "m_bForcePurgeFixedupStrings", true)
				if ((GetPropEntity(entity, "m_hLauncher") == weapon) && (entity.GetScriptThinkFunc() != "HomingRocket_Think"))
				{
					SetPropBool(entity, "m_bCritical", false)
					SetHomingProjectile(entity, 0.75, true, 8, 0.5)
					break;
				}
			}

			return -1
		}
		AddThinkToEnt(weapon, "WeaponThink")	//After all that's said an done, this adds the think script to handle 'weapon' after it has been validated.
	}

	NetProps.SetPropIntArray(weapon, "m_iClip1", 0, 1);
	weapon.AddAttribute("hidden primary max ammo bonus", 49.95, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
}

::CW_Stats_GiantPyroScorchSpammer <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.4, -1)
	weapon.AddAttribute("faster reload rate", 0.4, -1)
	weapon.AddAttribute("Projectile speed increased", 1.5, -1)
	weapon.AddAttribute("projectile spread angle penalty", 7, -1)
	weapon.AddAttribute("dmg penalty vs nonburning", 0.25, -1)
	weapon.AddAttribute("damage bonus vs burning", 1.5, -1)
	weapon.AddAttribute("Blast radius increased", 1.5, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 62.4375, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 0);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 2);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 3);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 4);
}

::CW_Stats_GiantSpyRevolver <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 0.75, -1)
	weapon.AddAttribute("faster reload rate", 1.15, -1)
	weapon.AddAttribute("damage penalty", 1.25, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 41.625, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 0);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 2);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 3);
}

::CW_Stats_GiantSpyRevolverHeadshot <- function(weapon, player)
{
	weapon.AddAttribute("fire rate penalty", 2.0, -1)
	weapon.AddAttribute("faster reload rate", 1.5, -1)
	weapon.AddAttribute("damage penalty", 2, -1)
	weapon.AddAttribute("special taunt", 1, -1)
	weapon.AddAttribute("hidden primary max ammo bonus", 41.625, -1)
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 0);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 1);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 2);
	NetProps.SetPropIntArray(player, "m_iAmmo", 999, 3);
}

RegisterCustomWeapon("GiantDemoknightShield", "Chargin' Targe",
		null,
		Defaults,
		function (table, player) {
			table.slot			= 1;		// The slot the script checks for before deleting and making our new weapon
		},
		CW_Stats_GiantDemoknightShield)

function SlappyReplace(weapon, player){
	weapon.SetSkin(1)
	weapon.SetDrawEnabled(false)
	AddThinkToEnt(weapon, "stopthathand")
}

RegisterCustomWeapon("RobotSlappingHand", "Hot Hand",
		null,
		Defaults,
		function (table, player) {
			table.worldModel = "models/empty.mdl"
			table.slot			= 2
		},SlappyReplace)


RegisterCustomWeapon("GiantDemoGlock", "pistol",
		22,
		Defaults,
		function (table, player) {
			table.slot			= 1
			table.classArms = GTFW_ARMS.ENGINEER;		//Adds Pyro arms model to all classes
			table.reserve		= 999
			table.reserveMax	= 999
			table.clipSize		= 20
			table.clipSizeMax	= 20
		},CW_Stats_GiantDemoGlock )