::robotimpactsound <- [
    "MVM.ImpactSoft"
]

::standardsoundrobot <- [
    ["Weapon_HolyMackerel.HitFlesh"],
    ["Weapon_HolyMackerel.HitWorld"],
    ["Weapon_Slap.BackHandHitWorld"],
    ["Weapon_Slap.OpenHandHitWorld"],
    ["Weapon_Slap.BackHand"],
    ["Weapon_Slap.OpenHand"],
    ["Weapon_Fist.HitFlesh"],
    ["Weapon_Fist.HitWorld"],
    ["Weapon_Fist.HitHand"],
]

::meleewepsrobot <- [
    ["tf_weapon_bat_fish"],
    ["tf_weapon_saxxy"],
    //["tf_weapon_robot_arm"],
    ["tf_weapon_fists"],
    ["tf_weapon_slap"],
]

function StopImpact(player)
{
    local index = player.GetPlayerClass()
    foreach (baseimpact in standardsoundrobot)
    {
        if (index == baseimpact[0])
        {
            StopSoundOn(baseimpact[0], player)
        }
    }
}

function MeleeWepsStandard(player)
{
    local index = player.GetPlayerClass()
    foreach (normwep in meleewepsrobot)
    {
        if (index == normwep[0])
        {
            params.weapon.GetClassname(normwep[0], player)
        }
    }
}

::RobotWeaponImpact <- function(params)
{
    local player = params.const_entity
    if (player == null && params.attacker != null && params.inflictor != null)
        return;

    if (!params.inflictor.IsPlayer())
        return;

    if (player.GetClassname() != "player")
        return;

    if (params.weapon != null)
        return;

    local index = player.GetPlayerClass()
    if ((params.weapon.GetClassname() !=  meleewepsrobot[0]) && (params.weapon.GetClassname() == ("tf_weapon_slap" || params.weapon.GetClassname() == "tf_weapon_fists" || params.weapon.GetClassname() == ("tf_weapon_bat_fish"))))
    {
        EmitAmbientSoundOn(robotimpactsound[0], 1, 95, 100, player)
    }
}