::deathsound <- [
    [ 0, "Scout.MVM_Death", "Scout.MVM_CritDeath", "Scout.MVM_MeleeDeath", "Scout.MVM_ExplosionDeath", "Scout" ],
    [ 1, "Scout.MVM_Death", "Scout.MVM_CritDeath", "Scout.MVM_MeleeDeath", "Scout.MVM_ExplosionDeath", "Scout" ],
    [ 3, "Soldier.MVM_Death", "Soldier.MVM_CritDeath", "Soldier.MVM_MeleeDeath", "Soldier.MVM_ExplosionDeath", "Soldier" ],
    [ 7, "Pyro.MVM_Death", "Pyro.MVM_CritDeath", "Pyro.MVM_MeleeDeath", "Pyro.MVM_ExplosionDeath", "Pyro" ],
    [ 4, "Demoman.MVM_Death", "Demoman.MVM_CritDeath", "Demoman.MVM_MeleeDeath", "Demoman.MVM_ExplosionDeath", "Demoman" ],
    [ 6, "Heavy.MVM_Death", "Heavy.MVM_CritDeath", "Heavy.MVM_MeleeDeath", "Heavy.MVM_ExplosionDeath", "Heavy" ],
    [ 9, "Engineer.MVM_Death", "Engineer.MVM_CritDeath", "Engineer.MVM_MeleeDeath", "Engineer.MVM_ExplosionDeath", "Engineer" ],
    [ 5, "Medic.MVM_Death", "Medic.MVM_CritDeath", "Medic.MVM_MeleeDeath", "Medic.MVM_ExplosionDeath", "Medic" ],
    [ 2, "Sniper.MVM_Death", "Sniper.MVM_CritDeath", "Sniper.MVM_MeleeDeath", "Sniper.MVM_ExplosionDeath", "Sniper" ],
    [ 8, "Spy.MVM_Death", "Spy.MVM_CritDeath", "Spy.MVM_MeleeDeath", "Spy.MVM_ExplosionDeath", "Spy" ]
]

function StopSounds(player)
{
    local index = player.GetPlayerClass();
    local num = RandomInt(1,7)
    foreach (playerclassname in deathsound)
    {
        if (index == playerclassname[0])
        {
            StopSoundOn(playerclassname[5]+".CritDeath" player)
            StopSoundOn(playerclassname[5]+".Death" player)
            StopSoundOn(playerclassname[5]+".MeleeDeath" player)
            StopSoundOn(playerclassname[5]+".ExplosionDeath" player)
            StopSoundOn(playerclassname[5]+".PainCrticialdeath0"+num, player)
            StopSoundOn(playerclassname[5]+".Painsevere0"+num, player)
            StopSoundOn(playerclassname[5]+".Painsharp0"+num, player)
        }
    }
}

::PlayerDeathLineStandard <- function(params)
{
    if (!("userid" in params))
    return
    local player = GetPlayerFromUserID(params.userid)
    //local player_class = player.GetPlayerClass()
    local index = player.GetPlayerClass();
    foreach (playerclassname in deathsound)
    {
        if (index == playerclassname[0])
        {
            EntFireByHandle(mainScript, "RunScriptCode", "StopSounds(activator)", 0.1, player, player)
            foreach (playerstandeath in deathsound)
            {
                if (index == playerstandeath[0])
                {
                    if (params.crit_type != 2)
                    {
                        if ((params.damagebits & 128) == 128)
                        {
                            EmitSoundOn(playerstandeath[3], player)
                        }
                        else if ((params.damagebits & 64) == 64)
                        {
                            EmitSoundOn(playerstandeath[4], player)
                        }
                        else
                        {
                        EmitSoundOn(playerstandeath[1], player)
                        }
                    }
                    else
                    {
                        EmitSoundOn(playerstandeath[2], player)
                    }
                }
            }
        }
    }
}