
m_aTrainWatcher <- []
local entity = null
while (entity = Entities.FindByClassname(entity, "team_train_watcher"))
{
	m_aTrainWatcher.push(entity)
}

::m_eTrainWatcher <- m_aTrainWatcher[miniroundnum];
::m_sStartTrack <- NetProps.GetPropString(m_eTrainWatcher, "m_iszStartNode");
::m_sEndTrack <- NetProps.GetPropString(m_eTrainWatcher, "m_iszGoalNode");

//IncludeScript("sprinkles_util.nut")
m_flTankThinkTime <- 0.05;
m_iDefinedHealth <- 10000;
m_iSpeed <- 75.0;
m_flDelayTime <- 15.0;

if(DEBUG)
{
	m_flDelayTime = 0
}

::money_table <-
[
    ["item_currencypack_large"],
    ["item_currencypack_medium"],
    ["item_currencypack_small"],
    ["item_currencypack_custom"]
]

m_iHealth <- m_iDefinedHealth // redundent but it works

NetProps.SetPropInt(tf_gamerules, "m_nHudType", 3)
NetProps.SetPropBool(tf_gamerules, "m_bPlayingHybrid_CTF_CP", false)

::TrackArray <- []
m_eStartTrack_Ent <- Entities.FindByName(null, m_sStartTrack)
m_eEndTrack_Ent <- Entities.FindByName(null, m_sEndTrack)

::CPArray <- []
::GoalArray <- []
m_eNextTrack <- null;
m_ePrevTrack <- null;
::m_iTrackLength <- 0
::m_eTank <- null;
m_eTankGlow <- null;
m_eTankDestory <- null;
m_bFirstTrackCheck <- false;
m_eFakeTankMain <- null;

CPArray.push(m_eStartTrack_Ent)

m_eLinkedCP1 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[0]"))
if (m_eLinkedCP1 != null) {CPArray.push(m_eLinkedCP1) }
m_eLinkedCP2 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[1]"))
if (m_eLinkedCP2 != null) {CPArray.push(m_eLinkedCP2) }
m_eLinkedCP3 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[2]"))
if (m_eLinkedCP3 != null) {CPArray.push(m_eLinkedCP3) }
m_eLinkedCP4 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[3]"))
if (m_eLinkedCP4 != null) {CPArray.push(m_eLinkedCP4) }
m_eLinkedCP5 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[4]"))
if (m_eLinkedCP5 != null) {CPArray.push(m_eLinkedCP5) }
m_eLinkedCP6 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[5]"))
if (m_eLinkedCP6 != null) {CPArray.push(m_eLinkedCP6) }
m_eLinkedCP7 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[6]"))
if (m_eLinkedCP7 != null) {CPArray.push(m_eLinkedCP7) }
m_eLinkedCP8 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedCPs[7]"))
if (m_eLinkedCP8 != null) {CPArray.push(m_eLinkedCP8) }

linked_pathtrack_1 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[0]"))
if (linked_pathtrack_1 != null) {GoalArray.push(linked_pathtrack_1) }
linked_pathtrack_2 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[1]"))
if (linked_pathtrack_2 != null) {GoalArray.push(linked_pathtrack_2) }
linked_pathtrack_3 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[2]"))
if (linked_pathtrack_3 != null) {GoalArray.push(linked_pathtrack_3) }
linked_pathtrack_4 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[3]"))
if (linked_pathtrack_4 != null) {GoalArray.push(linked_pathtrack_4) }
linked_pathtrack_5 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[4]"))
if (linked_pathtrack_5 != null) {GoalArray.push(linked_pathtrack_5) }
linked_pathtrack_6 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[5]"))
if (linked_pathtrack_6 != null) {GoalArray.push(linked_pathtrack_6) }
linked_pathtrack_7 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[6]"))
if (linked_pathtrack_7 != null) {GoalArray.push(linked_pathtrack_7) }
linked_pathtrack_8 <- Entities.FindByName(null, NetProps.GetPropString(m_eTrainWatcher, "m_iszLinkedPathTracks[7]"))
if (linked_pathtrack_8 != null) {GoalArray.push(linked_pathtrack_8) }
/*
printl("---------------------------------------")
foreach (CP in CPArray)
{
	printl(CP)
}

printl("---------------------------------------")
foreach (Goal in GoalArray)
{
	printl(Goal)
}

printl("---------------------------------------")
*/
self.PrecacheModel("models/stt/boss_tank_hologram.mdl")
self.PrecacheModel("models/props_rotunda/tank_engine.mdl")

::AmountCapped <- 0;
::AmountCappedMax <- CPArray.len() - 1
::redplayerarray <- []
::m_iRedPlayersAmount <- 0
TankHandlerScope <- this
::TANKSPEED <- m_iSpeed.tofloat()
function SpawnTank()
{
	HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_TANK_CALLOUT", TF_TEAM_PVE_DEFENDERS , "IsMvMDefender:1"); //TODO add defenders tank busting lines
	local healthcalc = CalculateTankHP()
	m_eTank = SpawnEntityFromTable("base_boss", {
    targetname = "Tank",
	TeamNum = 3,
	speed = m_iSpeed.tofloat(),
	angles = m_eStartTrack_Ent.GetAbsAngles(),
	health = healthcalc,
	vscripts = "stopthattank/tank.nut",
	})
	m_eTank.ValidateScriptScope();

	local scopeTank = m_eTank.GetScriptScope()

	scopeTank.mainScript <- mainScript;

	m_eTank.SetOrigin(m_eStartTrack_Ent.GetOrigin())
	SetBossEntity(m_eTank)
	EntFireByHandle(m_eTank, "sethealth", ""+(healthcalc - 10), 0.1, null, null);
	EntFireByHandle(m_eTank, "sethealth", ""+ healthcalc, 0.3, null, null);
	UpdateBossBarLeaderboardIcon(leaderboard.tank)
	if(DEBUG)
	{
		EntFireByHandle(m_eTank, "sethealth", "1", 0.5, null, null);
		EntFireByHandle(m_eTank, "setteam", "4", 0.5, null, null);
		//local netpropvalue = "m_startNode"
	}
}

function SpawnTankGlow()
{
	m_eTankGlow = SpawnEntityFromTable("tf_glow", {
    targetname = "Tank_Glow",
	GlowColor = "125 168 196 255",
    target = "Tank",
	})
	//m_eTankGlow.DispatchSpawn()
}
m_eHologramGlow <- null;

function HologramGlow()
{
    m_eTankGlow = SpawnEntityFromTable("tf_glow", {
    targetname = "Hologram_Glow",
    GlowColor = "125 168 196 255",
    target = "Hologram",
    })
}
//4291347595

function debug_GetEntityColor(r, g, b)
{
    local color = (r) | (g << 8) | (b << 16);
    return color
}

function CalculateTrackLength()
{
	if(!m_bFirstTrackCheck)
	{
		m_eNextTrack = NetProps.GetPropEntity(m_eStartTrack_Ent, "m_pnext")
		m_iTrackLength = m_iTrackLength + Distance3D(m_eNextTrack.GetOrigin(),m_eStartTrack_Ent.GetOrigin())
		m_bFirstTrackCheck = true
		TrackArray.push(m_eStartTrack_Ent)
		TrackArray.push(m_eNextTrack)
		CalculateTrackLength()
	}
	else if((m_eNextTrack != null) && (m_eNextTrack != m_eEndTrack_Ent))
	{
		m_ePrevTrack = m_eNextTrack
		m_eNextTrack = NetProps.GetPropEntity(m_ePrevTrack, "m_pnext")
		TrackArray.push(m_eNextTrack)
		m_iTrackLength = m_iTrackLength + Distance3D(m_eNextTrack.GetOrigin(),m_ePrevTrack.GetOrigin())
		CalculateTrackLength()
	}
}

function CalculateTankHP()
{
	if (m_iRedPlayersAmount < 2){
		return 2000;
	}
    local unrounded = m_iRedPlayersAmount * (m_iTrackLength.tointeger() / 12) + (m_iDefinedHealth / 2)
    return floor(unrounded / 100) * 100;
}

::CalculateBossHP <-function()
{
  if (m_iRedPlayersAmount < 2)
        return 1500;
    local unrounded = m_iRedPlayersAmount * (m_iTrackLength.tointeger() / 8) + (m_iRedPlayersAmount < 6 ? 1500 : 2500)
    return floor(unrounded / 100) * 100;
}

local DeployTime = 999999999;
local AllowDeploy = true;
local AllowBoom = true;
local StopHud = false;

::bossBar <- Entities.FindByClassname(null, "monster_resource");

::TickBossBar <- function(player)
{
    if (bossBar == null)
        bossBar = SpawnEntityFromTable("monster_resource"); //todo this is not how you call this method, but for some reason it doesn't matter anyway

    local hpByte = (player.GetHealth() * 255) / player.GetMaxHealth();
    if (hpByte == 0 && player.GetHealth() > 0)
        hpByte = 1;
    NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", hpByte);
}
m_flTrainDistanceFromStart <- 0.1
trackpassed <- 1 // we assume its at the start
m_flTotalPathDistance <- 0

function TankThink()
{
	m_iRedPlayersAmount = redplayerarray.len()
	EntFireByHandle(self, "RunScriptCode", "TankThink()", m_flTankThinkTime, null, null); // call self to make a fake think!
}

::TankPostSpawn <- function()
//function OnPostSpawn()
{
	CalculateTrackLength()
	m_eFakeTankMain = SpawnEntityFromTable("prop_dynamic", {
   		model = "models/stt/boss_tank_hologram.mdl",
		targetname = "Hologram",
		solid = 6,
		renderfx = 15,
		rendercolor = "255 255 255",
		renderamt = 126,
		disableshadows = 1,
	})
	local faketankvector = m_eStartTrack_Ent.GetOrigin()
	m_eFakeTankMain.SetOrigin(Vector(faketankvector.x, faketankvector.y, faketankvector.z - 48))
	m_eFakeTankMain.SetAbsAngles(VectorAngles(m_eStartTrack_Ent.GetOrigin(),NetProps.GetPropEntity(m_eStartTrack_Ent, "m_pnext").GetOrigin()))
	HologramGlow()
}

::OnDeployBomb <- function()
{
	EntFire("boss_deploy_relay", "trigger", "", 0.0);
	m_eTank = null;
}

::BombFlag <- Entities.FindByClassname(null, "item_teamflag")

::OnKilled <- function()
{
	m_eTank = null;
	NetProps.SetPropInt(bossBar,"m_iBossHealthPercentageByte", 0);
	if(AllowBoom)
	{
		NetProps.SetPropInt(tf_gamerules, "m_nHudType", 2)
		NetProps.SetPropBool(tf_gamerules, "m_bPlayingHybrid_CTF_CP", true)

		if (CPArray[AmountCapped].GetClassname() == "path_track")
		{
			local pathtrackvector = CPArray[0].GetOrigin()
			BombFlag.SetOrigin(Vector(pathtrackvector.x, pathtrackvector.y,pathtrackvector.z - 48 ))
		}
		else
		{
			BombFlag.SetOrigin(CPArray[AmountCapped].GetOrigin())
		}
		EntFire("boss_dead_relay", "trigger", "", 0.0);
		HaveAllPlayersSpeakConceptIfAllowed("TLK_MVM_FIRST_BOMB_PICKUP", TF_TEAM_PVE_DEFENDERS, "IsMvMDefender:1", 10.0);

	}
}

::ReturnToLastPoint <- function()
{
	if (CPArray[AmountCapped].GetClassname() == "path_track")
	{
		local pathtrackvector = CPArray[0].GetOrigin()
		BombFlag.SetOrigin(Vector(pathtrackvector.x, pathtrackvector.y,pathtrackvector.z - 48 ))
	}
	else
	{
		BombFlag.SetOrigin(CPArray[AmountCapped].GetOrigin())
	}

}

local totaldelaytime = Time()

DelayTankSpawn <- function()
{
	if (Time() > totaldelaytime)
	{
		m_eFakeTankMain.Kill()
		SpawnTank()
		SpawnTankGlow()

	}
	else
	{
		EntFireByHandle(self, "RunScriptCode", "DelayTankSpawn()", m_flTankThinkTime, null, null); // call self to make a fake think!
	}
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////

	OnGameEvent_teamplay_point_captured = function(params)
    {
		AmountCapped++
    }

    OnGameEvent_player_spawn = function(params)
    {
		if("userid" in params)
		{
			local player = GetPlayerFromUserID(params.userid)
			if(player.GetTeam() == 2)
			{
				local index = redplayerarray.find(player);
				if (index != null)
				{

				}
				else
				{
					redplayerarray.push(player)
				}
			}
			if(player.GetTeam() == 3)
			{
				local index = redplayerarray.find(player);
				if (index != null)
				{
					redplayerarray.remove(index)
				}
			}
		}
    }

	OnGameEvent_teamplay_setup_finished = function(params)
    {
		totaldelaytime = (m_flDelayTime * 1) + Time()
		DelayTankSpawn()
    }

	OnGameEvent_player_disconnect = function(params)
    {
		if("userid" in params)
		{
			local player = GetPlayerFromUserID(params.userid)
			if(player.GetTeam() == 2)
			{
				local index = redplayerarray.find(player);
				if (index != null)
				{
					redplayerarray.remove(index)
				}
			}
		}
    }
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)