//-----------------------------------------------------------------------------
//	Purpose: Grabs model path of an econ item by creating a tf_wearable and using GetModelName() on it
//-----------------------------------------------------------------------------

::GetItemModelName <- function(ItemID) {
	
	local wearable = Entities.CreateByClassname("tf_wearable")
	
	wearable.SetAbsAngles(QAngle(0,0,0))
	SetPropInt(wearable, "m_fEffects", 32)
	wearable.SetSolidFlags(4);
	wearable.SetCollisionGroup(11);
	
	local pootis = ItemID & ( (1 << 16) - 1);
	
	SetPropInt(wearable, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", pootis)
	SetPropInt(wearable, "m_AttributeManager.m_Item.m_bInitialized", 1)
	
	wearable.DispatchSpawn();

	local modelname = wearable.GetModelName();
//	printl("WHAA " + pootis +  " "  + wearable.GetModelName() + " !!!");
	wearable.Kill();
	
	return modelname
}